/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;

import javax.faces.context.FacesContext;


/**
* <strong>UIBehavior</strong> is a {@link javax.faces.component.UIComponent UIComponent}
* that adds script actions to ODC components. This tag is to replace the old ODC event attributes
* that were used in ODC component tags pre RAD 7.0<p>
* <b>Tags:</b> {@link com.ibm.faces.bf.taglib.BehaviorTag}<br>
* <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.BehaviorRenderer}
* </p>
* @see UIComponent
* @author: Breffni Coffey
*
*/
public class UIBehavior extends UIBrowserFramework
{
	public static final String COMPONENT_FAMILY = "com.ibm.faces.bf.Behavior"; //$NON-NLS-1$
	
	private String target;
	private String targetAction;
	private String behaviorAction;
	private String onActionFunction;
	
	public String getFamily() 
	{
		return COMPONENT_FAMILY;
	}
	
	//Should be one of list of supported actions
	public String getBehaviorAction() 
	{
		return behaviorAction;
	}
	
	public void setBehaviorAction(String behaviorAction) 
	{
		this.behaviorAction = behaviorAction;
	}
	
	//Allows optional JavaScript function to be performed when action is executed 
	public String getOnActionFunction() 
	{
		return onActionFunction;
	}
	
	public void setOnActionFunction(String onActionFunction) 
	{
		this.onActionFunction = onActionFunction;
	}
	
	//Indicates which component the behaviorAction will be applied to.
	public String getTargetAction() 
	{
		return targetAction;
	}
	
	public void setTargetAction(String targetAction) 
	{
		this.targetAction = targetAction;
	}

	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[5];
		values[0] = super.saveState(context);
		values[1] = this.target;
		values[2] = this.targetAction;
		values[3] = this.behaviorAction;
		values[4] = this.onActionFunction;
	
		return values;
	}
	

	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.target = (String) values[1];
		this.targetAction = (String) values[2];
		this.behaviorAction = (String) values[3];
		this.onActionFunction = (String) values[4];

	}
	
}