/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;
import javax.faces.context.FacesContext;

import com.ibm.odcb.jrender.misc.Streamer;
/**
 * <strong>UIBfPanel</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents the panel inside a {@link com.ibm.faces.bf.component.UITabbedPanel UITabbedPanel}
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.BfPanelTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.PanelRenderer}
 * </p>
 * @see UIBrowserFramework
 * @author Fenil shah
 */
public class UIBfPanel extends UIBrowserFramework
{
	private String onenter, onexit;
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.BfPanel";
	

	
	//	Constructors and Initializers    
	public UIBfPanel()
	{
		super();
		Streamer.trace.Header().println("enter UIBfPanel() of UIBfPanel.java");
	}
	
	/**
	 * @return
	 */
	public String getOnenter() {
		return onenter;
	}

	/**
	 * @return
	 */
	public String getOnexit() {
		return onexit;
	}

	/**
	 * @param string
	 */
	public void setOnenter(String string) {
		onenter = string;
	}

	/**
	 * @param string
	 */
	public void setOnexit(String string) {
		onexit = string;
	}

	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[3];
		values[0] = super.saveState(context);
		values[1] = this.onenter;
		values[2] = this.onexit;
		return values;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.onenter = (String) values[1];
		this.onexit = (String) values[2];
	}
	
}
