/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;
import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

import com.ibm.odcb.jrender.emitters.BaseEmitter;
import com.ibm.odcb.jrender.misc.Streamer;
/**<p>
 * This class is the super class of
 * all Browser Framework UIComponent classes.  This class handles
 * the common functionalities needed for Browser Framework components,
 * such as saving the state and providing getters and setters for the properties common to all Browser Framework components. 
 * @see UIComponentBase
 * </p>
 * @author: Jianren Li, Titania Gupta
 */
public abstract class UIBrowserFramework extends UIComponentBase {
	private String modelName;
	private Object value;
	private String stateString;
	private ValueBinding clientBinding;
	private BaseEmitter emitter;
	private boolean serverDataBinding = false;

	/**
	  * Constructor.
	  **/
	public UIBrowserFramework() {
		super();
		Streamer.trace.Header().println("Calling constructor of UIBrowserFramework.java");
	}

	/**
	 * @return 
	 */
	public boolean isServerDataBinding() {
		return serverDataBinding;
	}
	/**
	 * @param boolean
	 */
	public void setServerDataBinding(boolean serverDataBinding) {
		this.serverDataBinding = serverDataBinding;
	}
	/**
	 * @return
	 */
	public String getModelName() {
		return modelName;
	}

	/**
	 * @return
	 */
	public Object getValue() {
		if (this.value != null) {
			return (this.value);
		}
		ValueBinding vb = getValueBinding("value");
		if (vb != null) {
			return (vb.getValue(getFacesContext()));
		} else {
			return null;
		}
	}

	/**
	 * @param string
	 */
	public void setModelName(String string) {
		modelName = string;
	}

	/**
	 * @param object
	 */
	public void setValue(Object object) {
		this.value = object;
	}

	/* (non-Javadoc)
	 * @see javax.faces.component.UIComponentBase#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		Object values[] = new Object[2];
		values[0] = super.saveState(context);
		values[1] = this.stateString;
		return values;
	}

	/* (non-Javadoc)
	 * @see javax.faces.component.UIComponentBase#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		if (values.length == 2 && values[1] != null) {
			this.stateString = (String) values[1];
		}
	}

	/**
	 * @param string
	 */
	public void setStateString(String string) {
		stateString = string;
	}

	/**
	 * @return
	 */
	public String getStateString() {
		return stateString;
	}

	/**
	 * @return
	 */
	public ValueBinding getClientBinding() {
		return clientBinding;
	}

	/**
	 * @param binding
	 */
	public void setClientBinding(ValueBinding binding) {
		clientBinding = binding;
	}

	/**
	 * @return
	 */
	public BaseEmitter getEmitter() {
		return emitter;
	}

	/**
	 * @param emitter
	 */
	public void setEmitter(BaseEmitter emitter) {
		this.emitter = emitter;
	}

}
