//////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2004
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;


/**
 * <strong>UIClientBinder</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that works together with other JSF components to provide client-side bindings for them.
 * <p>
 * The standard JSF components that can have client-side bindings are:
 * <ul>
 * <li>{@link javax.faces.component.html.HtmlGraphicImage}
 * <li>{@link com.ibm.faces.component.html.HtmlGraphicImageEx}
 * <li>{@link javax.faces.component.html.HtmlInputHidden}
 * <li>{@link javax.faces.component.html.HtmlInputSecret}
 * <li>{@link javax.faces.component.html.HtmlInputText}
 * <li>{@link javax.faces.component.html.HtmlInputTextarea}
 * <li>{@link javax.faces.component.html.HtmlOutputText}
 * <li>{@link javax.faces.component.html.HtmlSelectBooleanCheckbox}
 * <li>{@link javax.faces.component.html.HtmlSelectManyCheckbox}
 * <li>{@link javax.faces.component.html.HtmlSelectManyListbox}
 * <li>{@link javax.faces.component.html.HtmlSelectManyMenu}
 * <li>{@link javax.faces.component.html.HtmlSelectOneListbox}
 * <li>{@link javax.faces.component.html.HtmlSelectOneMenu}
 * <li>{@link javax.faces.component.html.HtmlSelectOneRadio}
 * </ul>
 * <br>
 * The Faces Client JSF components that can have client-side bindings are:
 * <ul>
 * <li>{@link com.ibm.faces.bf.component.html.HtmlDataGrid}
 * <li>{@link com.ibm.faces.bf.component.html.HtmlGraphDraw}
 * <li>{@link com.ibm.faces.bf.component.html.HtmlTree}
 * <li>{@link com.ibm.faces.bf.component.html.HtmlWsInput}
 * <li>{@link com.ibm.faces.bf.component.html.HtmlWsOutput}
 * </ul>
 * </p>
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.ClientBinderTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.ClientBinderRenderer}
 * </p>
 * @see UIBrowserFramework
 * @author Fenil shah
 */
public class UIClientBinder extends UIBrowserFramework{
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.ClientBinder";
	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}		
}
