/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2004
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;

import javax.faces.component.UICommand;

import com.ibm.odcb.jrender.diff.DiffProcessor.DiffedObjectsLists;

/**
 * <strong>UIClientData</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents the client-side model and data streamed out to the browser.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.ClientDataTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.ClientDataRenderer}
 * </p> 
 * @see UICommand
 * @author fenil
 */
public class UIClientData extends UICommand {
	
	
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.ClientData";

	private String diffStr;
	private String modelName;
	private DiffedObjectsLists diffedObjectsLists;
	/**
	* Returns the diff string for the model, which reflects the data changes that have taken place on the model in the browser.
	* @return String The diff string which refelcts the data changes
	**/
	public String getDiffStr() {
		return diffStr;
	}

	
	/**
	 * Set the diff string for model, which reflects the data changes
	 * @param string
	 */
	public void setDiffStr(String string) {
		diffStr = string;
	}

	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}
	/**
	 * @return Returns the modelName.
	 */
	public String getModelName() {
		return modelName;
	}
	/**
	 * @param modelName The modelName to set.
	 */
	public void setModelName(String modelName) {
		this.modelName = modelName;
	}
	/**
	 * @return Returns the diffedObjectsList.
	 */
	public DiffedObjectsLists getDiffedObjectsLists() {
		return diffedObjectsLists;
	}
	/**
	 * @param diffedObjectsLists The diffedObjectsLists to set.
	 */
	public void setDiffedObjectsLists(DiffedObjectsLists diffedObjectsLists) {
		this.diffedObjectsLists = diffedObjectsLists;
	}
}
