/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;
import javax.faces.context.FacesContext;

import com.ibm.odcb.jrender.misc.Streamer;
/**
 * <strong>UIDataGrid</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents the client-side data table.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.DataGridTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.DataGridRenderer}
 * </p> 
 * @see UIBrowserFramework
 * @author Titania Gupta
 */
public class UIDataGrid extends UIBrowserFramework
{
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.DataGrid";

	//Event strings
	private String onhighlight, onselect, onunselect,onpage, onsort, onfilter, onselectall, onunselectall, onrowadd, onrowremove;
	
	public UIDataGrid()
	{
		super();
		Streamer.trace.Header().println(
			"begin UIDataGrid() of UIDataGrid.java calling constructor!");
	}

	/**
	 * @return
	 */
	public String getOnhighlight() {
		return onhighlight;
	}

	/**
	 * @return
	 */
	public String getOnselect() {
		return onselect;
	}

	/**
	 * @return
	 */
	public String getOnunselect() {
		return onunselect;
	}

	/**
	 * @return
	 */
	public String getOnrowadd() {
		return onrowadd;
	}
	
	/**
	 * @return
	 */
	public String getOnrowremove() {
		return onrowremove;
	}

	/**
	 * @param string
	 */
	public void setOnhighlight(String string) {
		onhighlight = string;
	}

	/**
	 * @param string
	 */
	public void setOnselect(String string) {
		onselect = string;
	}

	/**
	 * @param string
	 */
	public void setOnunselect(String string) {
		onunselect = string;
	}

	/**
	 * @param string
	 */
	public void setOnrowadd(String string) {
		onrowadd = string;
	}
	
	/**
	 * @param string
	 */
	public void setOnrowremove(String string) {
		onrowremove = string;
	}		
	
	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}
	/**
	 * @return Returns the onfilter.
	 */
	public String getOnfilter() {
		return onfilter;
	}
	/**
	 * @param onfilter The onfilter to set.
	 */
	public void setOnfilter(String onfilter) {
		this.onfilter = onfilter;
	}
	/**
	 * @return Returns the onpage.
	 */
	public String getOnpage() {
		return onpage;
	}
	/**
	 * @param onpage The onpage to set.
	 */
	public void setOnpage(String onpage) {
		this.onpage = onpage;
	}
	/**
	 * @return Returns the onselectall.
	 */
	public String getOnselectall() {
		return onselectall;
	}
	/**
	 * @param onselectall The onselectall to set.
	 */
	public void setOnselectall(String onselectall) {
		this.onselectall = onselectall;
	}
	/**
	 * @return Returns the onsort.
	 */
	public String getOnsort() {
		return onsort;
	}
	/**
	 * @param onsort The onsort to set.
	 */
	public void setOnsort(String onsort) {
		this.onsort = onsort;
	}
	/**
	 * @return Returns the onunselectall.
	 */
	public String getOnunselectall() {
		return onunselectall;
	}
	/**
	 * @param onunselectall The onunselectall to set.
	 */
	public void setOnunselectall(String onunselectall) {
		this.onunselectall = onunselectall;
	}
	
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[11];
		values[0] = super.saveState(context);
		values[1] = this.onhighlight;
		values[2] = this.onselect;
		values[3] = this.onunselect;
		values[4] = this.onpage;
		values[5] = this.onsort;
		values[6] = this.onfilter;
		values[7] = this.onselectall;
		values[8] = this.onunselectall;
		values[9] = this.onrowadd;
		values[10] = this.onrowremove;
		return values;
	}
	
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.onhighlight = (String) values[1];
		this.onselect = (String) values[2];
		this.onunselect = (String) values[3];
		this.onpage = (String) values[4];
		this.onsort = (String) values[5];
		this.onfilter = (String) values[6];
		this.onselectall = (String) values[7];
		this.onunselectall = (String) values[8];
		this.onrowadd = (String) values[9];
		this.onrowremove = (String) values[10];
	}
	
}