/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;
import javax.faces.component.ValueHolder;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import com.ibm.odcb.jrender.misc.Streamer;
/**
 * <strong>UIDataGridCol</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents a column inside the {@link com.ibm.faces.bf.component.UIDataGrid} component.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.DataGridColTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.DataGridColRenderer}
 * </p> 
 * @see UIBrowserFramework
 * @author Titania Gupta
 */
public class UIDataGridCol extends UIBrowserFramework implements ValueHolder
{
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY =
		"com.ibm.faces.bf.DataGridCol";
	private String attributeName;
	private Converter converter;
	
	public void setConverter(Converter converter)
	{
		this.converter = converter;
	}
	
	public Converter getConverter()
	{
		return converter;
	}
	
	public Object getLocalValue()
	{
		return null;
	}
	/**
	 * Default Constructor for UIDataGridCol
	 *
	 */
	public UIDataGridCol()
	{
		super();
		Streamer.trace.Header().println(
			"begin UIDataGridCol() of UIDataGridCol.java calling constructor!");
	}
	/**
	 * @return
	 */
	public String getAttributeName()
	{
		return attributeName;
	}
	/**
	 * @param string
	 */
	public void setAttributeName(String string)
	{
		attributeName = string;
	}
	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily()
	{
		return COMPONENT_FAMILY;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[3];
		values[0] = super.saveState(context);
		values[1] = this.attributeName;
		values[2] = saveAttachedState(context, this.converter);
		
		return values;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.attributeName = (String) values[1];
		this.converter = (Converter)restoreAttachedState(context, values[2]);
		
	}
}
