/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;

import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.component.ValueHolder;

/**
 * <strong>UIGraphDrawData</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that is child of the {@link com.ibm.faces.bf.component.UIGraphDraw} component and acts as a container for one
 * or more {@link com.ibm.faces.bf.component.UIGraphDrawDataSeries} components.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.GraphDrawDataTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.GraphDrawDataRenderer}
 * </p>
 * @see UIBrowserFramework
 * @author	Vidya Rao
 */
public class UIGraphDrawData extends UIBrowserFramework implements ValueHolder {
	private Converter converter;
	
	/*
	 * @see javax.faces.component.ValueHolder#setConverter(javax.faces.convert.Converter)
	 */
	public void setConverter(Converter converter) {
		this.converter = converter;
	}

	/*
	 * @see javax.faces.component.ValueHolder#getConverter()
	 */
	public Converter getConverter() {
		return converter;
	}
		
	/*
	 * @see javax.faces.component.ValueHolder#getLocalValue()
	 */
	public Object getLocalValue() { 
		return null;
	}

	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.GraphDrawData";
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[2];
		values[0] = super.saveState(context);
		values[1] = saveAttachedState(context, this.converter);		
		
		return values;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.converter = (Converter) restoreAttachedState(context, values[1]);				
	}
}
