/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;

import javax.faces.context.FacesContext;
/**
 * <strong>UIGraphDrawDataSeries</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents one series plotted on the y-axis of the {@link com.ibm.faces.bf.component.UIGraphDraw} component. 
 * This component is always a child of the {@link com.ibm.faces.bf.component.UIGraphDrawData} component.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.GraphDrawDataSeriesTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.GraphDrawDataSeriesRenderer}
 * </p>
 * @see UIBrowserFramework
 * @author	Vidya Rao
 */
public class UIGraphDrawDataSeries extends UIBrowserFramework {
	private String attributeName;

	/**
	 * @return The attribute name for the series
	 */
	public String getAttributeName() {
		return attributeName;
	}

	/**
	 * @param attributeName The attribute name for the series
	 */
	public void setAttributeName(String attributeName) {
		this.attributeName = attributeName;
	}
	
	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.GraphDrawDataSeries";
	
	
	public Object saveState(FacesContext _context) {

		Object _values[] = new Object[2];
		_values[0] = super.saveState(_context);
		_values[1] = attributeName;
		return _values;
	}

	public void restoreState(FacesContext _context, Object _state) {

		Object _values[] = (Object[]) _state;
		super.restoreState(_context, _values[0]);
		this.attributeName = (java.lang.String) _values[1];
	}
	
}
