/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;
import javax.faces.convert.Converter;
import javax.faces.component.ValueHolder;
import javax.faces.context.FacesContext;

/**
 * <strong>UIGraphDrawLabels</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents the series plotted on the x-axis of the {@link com.ibm.faces.bf.component.UIGraphDraw} component.
 * This component is always a child of the {@link com.ibm.faces.bf.component.UIGraphDraw} component.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.GraphDrawLabelsTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.GraphDrawLabelsRenderer}
 * </p>
 * @see UIBrowserFramework
 * @author	Vidya Rao
 */
public class UIGraphDrawLabels extends UIBrowserFramework implements ValueHolder {
	private String attributeName;
	private Converter converter;

	/*
	 * @see javax.faces.component.ValueHolder#setConverter(javax.faces.convert.Converter)
	 */
	public void setConverter(Converter converter) {
		this.converter = converter;
	}
	
	/*
	 * @see javax.faces.component.ValueHolder#getConverter()
	 */
	public Converter getConverter() {
		return converter;
	}

	/*
	 * @see javax.faces.component.ValueHolder#getLocalValue()
	 */	
	public Object getLocalValue() { 
		return null;
	}

	/**
	 * @return The attribute name for the label
	 */
	public String getAttributeName() {
		return attributeName;
	}

	/**
	 * @param attributeName The attribute name for the label
	 */
	public void setAttributeName(String attributeName) {
		this.attributeName = attributeName;
	}
	
	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.GraphDrawLabels";
	
	
	public Object saveState(FacesContext context) {

		Object values[] = new Object[3];
		values[0] = super.saveState(context);
		values[1] = attributeName;
		values[2] = saveAttachedState(context, this.converter);
		return values;
	}

	public void restoreState(FacesContext context, Object state) {
		
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.attributeName = (java.lang.String) values[1];
		this.converter = (Converter)restoreAttachedState(context, values[2]);
	}
	
}
