/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;

import javax.faces.context.FacesContext;


/**
 * <strong>UITabbedPanel</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents the entire tabbed panel.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.TabbedPanelTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.TabbedPanelRenderer}
 * </p>
 * @see UIBrowserFramework
 * @author Fenil shah
 */
public class UITabbedPanel extends UIBrowserFramework
{
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.TabbedPanel";

	private String onfinish, oncancel;
	private String onpanelenter, onpanelexit, oninitialpanelshow, initialPanelId;
	

	/**
	 * @return
	 */
	public String getOncancel() {
		return oncancel;
	}

	/**
	 * @return
	 */
	public String getOnfinish() {
		return onfinish;
	}

	/**
	 * @param string
	 */
	public void setOncancel(String string) {
		oncancel = string;
	}

	/**
	 * @param string
	 */
	public void setOnfinish(String string) {
		onfinish = string;
	}
	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}
	/**
	 * @return
	 */
	public String getOnpanelenter() {
		return onpanelenter;
	}

	/**
	 * @return
	 */
	public String getOnpanelexit() {
		return onpanelexit;
	}

	/**
	 * @param string
	 */
	public void setOnpanelenter(String string) {
		onpanelenter = string;
	}

	/**
	 * @param string
	 */
	public void setOnpanelexit(String string) {
		onpanelexit = string;
	}

	/**
	 * @return Returns the onpanelshow.
	 */
	public String getOninitialpanelshow() {
		return oninitialpanelshow;
	}
	/**
	 * @param onpanelshow The onpanelshow to set.
	 */
	public void setOninitialpanelshow(String onpanelshow) {
		this.oninitialpanelshow = onpanelshow;
	}
	/**
	 * @return Returns the initialPanelId.
	 */
	public String getInitialPanelId() {
		return initialPanelId;
	}
	/**
	 * @param initialPanelId The initialPanelId to set.
	 */
	public void setInitialPanelId(String initialPanelId) {
		this.initialPanelId = initialPanelId;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[7];
		values[0] = super.saveState(context);
		values[1] = this.onfinish;
		values[2] = this.oncancel;
		values[3] = this.onpanelenter;
		values[4] = this.onpanelexit;
		values[5] = this.oninitialpanelshow;
		values[6] = this.initialPanelId;
		return values;
	}
	

	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.onfinish = (String) values[1];
		this.oncancel = (String) values[2];
		this.onpanelenter = (String) values[3];
		this.onpanelexit = (String) values[4];
		this.oninitialpanelshow = (String) values[5];
		this.initialPanelId = (String) values[6];
	}
	
}
