/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;

import javax.faces.context.FacesContext;

import com.ibm.odcb.jrender.misc.Streamer;
/**
 * <strong>UITree</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents the client-side Tree View component.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.TreeTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.TreeRenderer}
 * </p>  
 * @see UIBrowserFramework
 * @author: Jianren Li
**/
public class UITree extends UIBrowserFramework {
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.Tree";

	//Event Strings
	private String onnodehighlight, onnodeselect, onnodeunselect, onnodeexpand, onnodecollapse, onnodedrop,onnodedragenterover,scrollNum;
	
	public UITree() {
		super();
		Streamer.trace.Header().println("Entering UITree() of UITree.java calling constructor.");
	}
	
	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}
	/**
	 * @return  Returns the onnodehighlight method.
	 */
	public String getOnnodehighlight() {
		return onnodehighlight;
	}

	/**
	 * @return  Returns the onnodeselect method.
	 */
	public String getOnnodeselect() {
		return onnodeselect;
	}

	/**
	 * @return Returns the onnodeunselect method.
	 */
	public String getOnnodeunselect() {
		return onnodeunselect;
	}
	
	/**
	 * @return Returns the onnodecollapse method.
	 */
	public String getOnnodecollapse() {
		return onnodecollapse;
	}

	/**
	 * @return Returns the onnodeexpand method.
	 */
	public String getOnnodeexpand() {
		return onnodeexpand;
	}
	/**
	 * @return Returns the onnodedrop method.
	 */
	public String getOnnodedrop() {
		return onnodedrop;
	}
	
	/**
	 * @return Returns the method to be triggered by the onnodedragenterover event.
	 */
	public String getOnnodedragenterover() {
		return onnodedragenterover;
	}


	/**
	 * @param string
	 */
	public void setOnnodehighlight(String string) {
		onnodehighlight = string;
	}

	/**
	 * @param string
	 */
	public void setOnnodeselect(String string) {
		onnodeselect = string;
	}

	/**
	 * @param string
	 */
	public void setOnnodeunselect(String string) {
		onnodeunselect = string;
	}

	/**
	 * @param onnodecollapse The onnodecollapse to set.
	 */
	public void setOnnodecollapse(String onnodecollapse) {
		this.onnodecollapse = onnodecollapse;
	}

	/**
	 * @param onnodeexpand The onnodeexpand to set.
	 */
	public void setOnnodeexpand(String onnodeexpand) {
		this.onnodeexpand = onnodeexpand;
	}
	
	/**
	 * @param onnodeexpand The onnodeexpand to set.
	 */
	public void setOnnodedrop(String onnodedrop) {
		this.onnodedrop = onnodedrop;
	}
	
	/**
	 * @param onnodedragenterover The onnodedragenterover to set.
	 */
	public void setOnnodedragenterover(String onnodedragenterover) {
		this.onnodedragenterover = onnodedragenterover;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[9];
		values[0] = super.saveState(context);
		values[1] = this.onnodehighlight;
		values[2] = this.onnodeselect;
		values[3] = this.onnodeunselect;
		values[4] = this.onnodeexpand;
		values[5] = this.onnodecollapse;
		values[6] = this.onnodedrop;
		values[7] = this.onnodedragenterover;
		values[8] = this.scrollNum;
		return values;
	}
	
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.onnodehighlight = (String) values[1];
		this.onnodeselect = (String) values[2];
		this.onnodeunselect = (String) values[3];
		this.onnodeexpand = (String) values[4];
		this.onnodecollapse = (String) values[5];
		this.onnodedrop = (String) values[6];
		this.onnodedragenterover = (String) values[7];
		this.scrollNum = (String) values[8];
	}
	
}