/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;

import javax.faces.context.FacesContext;

/**
* <strong>UITreeColumn</strong> is a {@link javax.faces.component.UIComponent UIComponent}
* that is used to apply customised widths to tree table columns. This tag will always be a child of the
* {@link com.ibm.faces.bf.component.UITreeTable} component
* <p>
* <b>Tags:</b> {@link com.ibm.faces.bf.taglib.TreeColumnTag}<br>
* <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.TreeColumnRenderer}
* </p>
* @see UIBrowserFramework
* @author: Breffni Coffey
**/
public class UITreeColumn extends UIBrowserFramework{
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.TreeColumn";
	
	private String id, width, label;

	/**
	 * @return Returns the id.
	 */
	public String getId() {
		return id;
	}
	/**
	 * @param id The id to set.
	 */
	public void setId(String id) {
		this.id = id;
	}
	/**
	 * @return Returns the width.
	 */
	public String getWidth() {
		return width;
	}
	/**
	 * @return Returns the attributeName.
	 */
	public String getLabel() {
		return label;
	}
	/**
	 * @param attributeName The attributeName to set.
	 */
	public void setLabel(String label) {
		this.label = label;
	}
	/**
	 * @param width The width to set.
	 */
	public void setWidth(String width) {
		this.width = width;
	}
	/* (non-Javadoc)
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		
		return COMPONENT_FAMILY;
	}

	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[4];
		values[0] = super.saveState(context);
		values[1] = this.id;
		values[2] = this.width;
		values[3] = this.label;
		return values;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.id = (String) values[1];
		this.width = (String) values[2];
		this.label = (String) values[3];
	}
	
}
