/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;

import javax.faces.context.FacesContext;

/**
* <strong>UITreeColumnData</strong> is a {@link javax.faces.component.UIComponent UIComponent}
* that represents an individual nodes data for a tree table in the {@link com.ibm.faces.bf.component.UITreeNodeAttr} component.
* This component will always be a child of the {@link com.ibm.faces.bf.component.UITreeNodeAttr} component.
* <p>
* <b>Tags:</b> {@link com.ibm.faces.bf.taglib.TreeColumnDataTag}<br>
* <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.TreeColumnDataRenderer}
* </p>
* @see UIBrowserFramework
* @author: Breffni Coffey
**/

public class UITreeColumnData extends UIBrowserFramework {
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.TreeColumnData";
	
	private String id, attributeName;

	/**
	 * @return Returns the attribute.
	 */
	public String getAttributeName() {
		return attributeName;
	}
	/**
	 * @param attribute The attribute to set.
	 */
	public void setAttributeName(String attribute) {
		this.attributeName = attribute;
	}
	/**
	 * @return Returns the id.
	 */
	public String getId() {
		return id;
	}
	/**
	 * @param id The id to set.
	 */
	public void setId(String id) {
		this.id = id;
	}
	/* (non-Javadoc)
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		
		return COMPONENT_FAMILY;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[3];
		values[0] = super.saveState(context);
		values[1] = this.id;
		values[2] = this.attributeName;
		
		return values;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.id = (String) values[1];
		this.attributeName = (String) values[2];
		
	}
}
