/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;

import java.io.IOException;
import java.util.Iterator;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

import com.ibm.faces.renderkit.html_extended.Utils;
import com.ibm.odcb.jrender.misc.Streamer;
/**
 * <strong>UITreeNodeAttr</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents an individual node in the {@link com.ibm.faces.bf.component.UITree} component.
 * This component will always be a child of the {@link com.ibm.faces.bf.component.UITree} component.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.TreeNodeAttrTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.TreeNodeAttrRenderer}
 * </p>
 * @see UIBrowserFramework
 * @author: Jianren Li
**/
public class UITreeNodeAttr extends UIBrowserFramework
{
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.TreeNodeAttr";
	
	private String attributeName, className, referenceName, nodeLabel;
	//Event Strings
	private String onhighlight, onselect, onunselect, onexpand, oncollapse, ondragenterover;
	
	public UITreeNodeAttr()
	{
		super();
		Streamer.trace.Header().println(
			"Entering UITree() of UITreeNodeattr.java calling constructor.");
	}
	/**
	 * @return
	 */
	public String getAttributeName() {
		return attributeName;
	}

         /**
	 * @return
	 */
	public String getNodeLabel() {
		return nodeLabel;
	}


	/**
	 * @return
	 */
	public String getClassName() {
		return className;
	}

	/**
	 * @return
	 */
	public String getReferenceName() {
		return referenceName;
	}

	/**
	 * @param string
	 */
	public void setNodeLabel(String string) {
		nodeLabel = string;
	}

        /**
	 * @param string
	 */
	public void setAttributeName(String string) {
		attributeName = string;
	}


	/**
	 * @param string
	 */
	public void setClassName(String string) {
		className = string;
	}

	/**
	 * @param string
	 */
	public void setReferenceName(String string) {
		referenceName = string;
	}

	/**
	 * @return
	 */
	public String getOnhighlight() {
		return onhighlight;
	}

	/**
	 * @return
	 */
	public String getOnselect() {
		return onselect;
	}

	/**
	 * @return
	 */
	public String getOnunselect() {
		return onunselect;
	}

	public String getOndragenterover() {
		return ondragenterover;
	}
	
	/**
	 * @param string
	 */
	public void setOnhighlight(String string) {
		onhighlight = string;
	}

	/**
	 * @param string
	 */
	public void setOnselect(String string) {
		onselect = string;
	}

	/**
	 * @param string
	 */
	public void setOnunselect(String string) {
		onunselect = string;
	}
	
	public void setOndragenterover(String string) {
		ondragenterover = string;
	}
	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}
	/**
	 * @return Returns the oncollapse.
	 */
	public String getOncollapse() {
		return oncollapse;
	}
	/**
	 * @param oncollapse The oncollapse to set.
	 */
	public void setOncollapse(String oncollapse) {
		this.oncollapse = oncollapse;
	}
	/**
	 * @return Returns the onexpand.
	 */
	public String getOnexpand() {
		return onexpand;
	}
	/**
	 * @param onexpand The onexpand to set.
	 */
	public void setOnexpand(String onexpand) {
		this.onexpand = onexpand;
	}
	
	/* (non-Javadoc)
	 * @see javax.faces.component.UIComponent#encodeChildren(javax.faces.context.FacesContext)
	 */
	public boolean getRendersChildren() 
	{
		return true;
	}
	
	/* (non-Javadoc)
	 * @see javax.faces.component.UIComponent#encodeChildren(javax.faces.context.FacesContext)
	 */
	public void encodeChildren(FacesContext context) throws IOException 
	{
		if(!isRendered())
		{
			return;
		}
		
		//process iterator children
		Iterator children = getChildren().iterator();
		while(children.hasNext())
		{
			Utils.encodeComponent(context, (UIComponent)children.next());
		}
		
	}

	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[11];
		values[0] = super.saveState(context);
		values[1] = this.attributeName;
		values[2] = this.className;
		values[3] = this.referenceName;
		values[4] = this.nodeLabel;		
		values[5] = this.onhighlight;
		values[6] = this.onselect;
		values[7] = this.onunselect;
		values[8] = this.onexpand;
		values[9] = this.oncollapse;
		values[10] = this.ondragenterover;
		return values;
	}
	
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.attributeName = (String) values[1];
		this.className = (String) values[2];
		this.referenceName = (String) values[3];
		this.nodeLabel = (String) values[4];		
		this.onhighlight = (String) values[5];
		this.onselect = (String) values[6];
		this.onunselect = (String) values[7];
		this.onexpand = (String) values[8];
		this.oncollapse = (String) values[9];
		this.ondragenterover = (String) values[10];
	}

}
