/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;

import java.io.IOException;
import java.util.Iterator;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

import com.ibm.faces.renderkit.html_extended.Utils;
/**
* <strong>UITreeTable</strong> is a {@link javax.faces.component.UIComponent UIComponent}
* that enables the Tree component to display tabular data along side a tree node. This tag is used in conjunction with the
* {@link com.ibm.faces.bf.component.UITreeColumn}and the {@link com.ibm.faces.bf.component.UITreeColumnData} components.
* This component will always be a child of the {@link com.ibm.faces.bf.component.UITree} component.
* <p>
* <b>Tags:</b> {@link com.ibm.faces.bf.taglib.TreeTableTag}<br>
* <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.TreeTableRenderer}
* </p>
* @see UIBrowserFramework
* @author: Breffni Coffey
**/

public class UITreeTable extends UIBrowserFramework
{
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.TreeTable";
	
	private String id;

	/**
	 * @return Returns the id.
	 */
	public String getId() {
		return id;
	}
	/**
	 * @param id The id to set.
	 */
	public void setId(String id) {
		this.id = id;
	}
	/* (non-Javadoc)
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		
		return COMPONENT_FAMILY;
	}

	/* (non-Javadoc)
	 * @see javax.faces.component.UIComponent#encodeChildren(javax.faces.context.FacesContext)
	 */
	public boolean getRendersChildren() 
	{
		return true;
	}
	
	
	/* (non-Javadoc)
	 * @see javax.faces.component.UIComponent#encodeChildren(javax.faces.context.FacesContext)
	 */
	public void encodeChildren(FacesContext context) throws IOException {
		
		if(!isRendered()){
			return;
		}
		
		//process iterator children
		Iterator children = getChildren().iterator();
		while(children.hasNext()){
			Utils.encodeComponent(context, (UIComponent)children.next());
		}
		
	}

}
