/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.component;

import javax.faces.context.FacesContext;

import com.ibm.odcb.jrender.misc.Streamer;

/**
 * <strong>UIWebService</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents the client-side WebService component.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.WebServiceTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.WebServiceRenderer}
 * </p>
 * @see UIBrowserFramework
 * @author Qun Zhou
 * @author Rajesh V Ramachandran
 */
public class UIWebService extends UIBrowserFramework
{
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.WebService";
	private String wsAlias, wsdlURL, webServiceOperation;
	
	public UIWebService()
	{
		super();
		Streamer.trace.Header().println("begin UIWebService() of UIWebService.java calling constructor!");
	}
	
	/**
	 * @return The web service operation
	 */
	public String getWebServiceOperation() {
		return webServiceOperation;
	}

	/**
	 * @return The web service alias
	 */
	public String getWsAlias() {
		return wsAlias;
	}

	/**
	 * @return The WSDL URL
	 */
	public String getWsdlURL() {
		return wsdlURL;
	}

	/**
	 * @param string The web service operation
	 */
	public void setWebServiceOperation(String string) {
		webServiceOperation = string;
	}

	/**
	 * @param string The alias for the web service
	 */
	public void setWsAlias(String string) {
		wsAlias = string;
	}

	/**
	 * @param string The WSDL URL
	 */
	public void setWsdlURL(String string) {
		wsdlURL = string;
	}
	/* 
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[4];
		values[0] = super.saveState(context);
		values[1] = this.wsAlias;
		values[2] = this.wsdlURL;
		values[3] = this.webServiceOperation;
		
		return values;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.wsAlias = (String) values[1];
		this.wsdlURL = (String) values[2];
		this.webServiceOperation = (String) values[3];
		
	}
}
