/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

package com.ibm.faces.bf.component;

import javax.faces.context.FacesContext;


/**
 * <strong>UIWsInput</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents an input parameter to a WebService. This component is always a child of the 
 * {@link com.ibm.faces.bf.component.UIWebService} component.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.WsInputTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.WsInputRenderer}
 * </p>
 * @see UIBrowserFramework
 * @author Qun Zhou
 * @author Rajesh V Ramachandran
 */

public class UIWsInput extends UIBrowserFramework {
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.WsInput";
	private java.lang.String requestElementName;
	private java.lang.String attributeName;

	/**
	 * @param attributeName	The attribute name for the web service input
	 */
	public void setAttributeName(java.lang.String attributeName) {
		this.attributeName = attributeName;
	}

	/**
	 * @param string The request element name
	 */
	public void setRequestElementName(java.lang.String string) {
		requestElementName = string;
	}

	/**
	 * @return The attribute name for the web service input
	 */
	public java.lang.String getAttributeName() {
		return attributeName;
	}

	/**
	 * @return The request element name
	 */
	public java.lang.String getRequestElementName() {
		return requestElementName;
	}

	/*
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[3];
		values[0] = super.saveState(context);
		values[1] = this.requestElementName;
		values[2] = this.attributeName;
		
		return values;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.requestElementName = (String) values[1];
		this.attributeName = (String) values[2];
		
	}
}
