/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

package com.ibm.faces.bf.component;

import javax.faces.context.FacesContext;


/**
 * <strong>UIWsOutput</strong> is a {@link javax.faces.component.UIComponent UIComponent}
 * that represents a binding from the result of a WebService call to the client-side model. 
 * This component is always a child of the {@link com.ibm.faces.bf.component.UIWebService} component.
 * <p>
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.WsOutputTag}<br>
 * <b>Renderers:</b> {@link com.ibm.faces.bf.renderkit.WsOutputRenderer}
 * </p>
 * @see UIBrowserFramework
 * @author Qun Zhou
 * @author Rajesh V Ramachandran
 */

public class UIWsOutput extends UIBrowserFramework {
	/**
	 * <p>The standard component family for this component.</p>
	 */
	private static final String COMPONENT_FAMILY = "com.ibm.faces.bf.WsOutput";

	private String responseElementName;
	private String attributeName;

	/**
	 * @return The response element name
	 */
	public String getResponseElementName() {
		return responseElementName;
	}
	/**
	 * @param attributeName The attribute name for the web service output 
	 */
	public void setAttributeName(String attributeName) {
		this.attributeName = attributeName;
	}
	/**
	 * @param string The response element name
	 */
	public void setResponseElementName(String string) {
		responseElementName = string;
	}
	/**
	 * @return The attribute name for the web service output
	 */
	public String getAttributeName() {
		return attributeName;
	}
	/*
	 * @see javax.faces.component.UIComponent#getFamily()
	 */
	public String getFamily() {
		return COMPONENT_FAMILY;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		// TODO Auto-generated method stub
		Object values[] = new Object[3];
		values[0] = super.saveState(context);
		values[1] = this.responseElementName;
		values[2] = this.attributeName;
		
		return values;
	}
	
	/* (non-Javadoc)
	 * @see com.ibm.faces.bf.component.UIBrowserFramework#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		// TODO Auto-generated method stub
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		this.responseElementName = (String) values[1];
		this.attributeName = (String) values[2];
		
	}
}
