/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>Behavior</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlBehavior extends com.ibm.faces.bf.component.UIBehavior {


  public HtmlBehavior() {
    super();
    setRendererType("Behavior"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.bf.HtmlBehavior"; //$NON-NLS-1$


  private java.lang.String event;

  /**
   * <p>Return the value of the <code>event</code> property.  Contents:</p><p>
   * The event that fires the action.
   * </p>
   */
  public java.lang.String getEvent() {
    if (null != this.event) {
      return this.event;
    }
    ValueBinding _vb = getValueBinding("event"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>event</code> property.</p>
   */
  public void setEvent(java.lang.String event) {
    this.event = event;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[2];
    _values[0] = super.saveState(_context);
    _values[1] = event;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.event = (java.lang.String) _values[1];
  }


}
