/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>ButtonPanel</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlButtonPanel extends com.ibm.faces.bf.component.UIButtonPanel {


  public HtmlButtonPanel() {
    super();
    setRendererType("ButtonPanel"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.bf.HtmlButtonPanel"; //$NON-NLS-1$


  private java.lang.String alignContent;

  /**
   * <p>Return the value of the <code>alignContent</code> property.  Contents:</p><p>
   * The alignment of the custom content in relation to the existing buttons.
   * </p>
   */
  public java.lang.String getAlignContent() {
    if (null != this.alignContent) {
      return this.alignContent;
    }
    ValueBinding _vb = getValueBinding("alignContent"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>alignContent</code> property.</p>
   */
  public void setAlignContent(java.lang.String alignContent) {
    this.alignContent = alignContent;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[2];
    _values[0] = super.saveState(_context);
    _values[1] = alignContent;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.alignContent = (java.lang.String) _values[1];
  }


}
