/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>DataGridCol</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlDataGridCol extends com.ibm.faces.bf.component.UIDataGridCol {


  public HtmlDataGridCol() {
    super();
    setRendererType("DataGridCol"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.bf.HtmlDataGridCol"; //$NON-NLS-1$


  private java.lang.String alignment;

  /**
   * <p>Return the value of the <code>alignment</code> property.  Contents:</p><p>
   * Alignment of this column (Left, Right, or Center).
   * </p>
   */
  public java.lang.String getAlignment() {
    if (null != this.alignment) {
      return this.alignment;
    }
    ValueBinding _vb = getValueBinding("alignment"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>alignment</code> property.</p>
   */
  public void setAlignment(java.lang.String alignment) {
    this.alignment = alignment;
  }


  private java.lang.String colHead;

  /**
   * <p>Return the value of the <code>colHead</code> property.  Contents:</p><p>
   * The key for the label in the column header, which will
   * 				be used to load a NLV string from the resource bundle
   * 				specified on its parent tag.
   * </p>
   */
  public java.lang.String getColHead() {
    if (null != this.colHead) {
      return this.colHead;
    }
    ValueBinding _vb = getValueBinding("colHead"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>colHead</code> property.</p>
   */
  public void setColHead(java.lang.String colHead) {
    this.colHead = colHead;
  }


  private boolean readOnly = false;
  private boolean readOnly_set = false;

  /**
   * <p>Return the value of the <code>readOnly</code> property.  Contents:</p><p>
   * Is this column readOnly or not.
   * </p>
   */
  public boolean isReadOnly() {
    if (this.readOnly_set) {
      return this.readOnly;
    }
    ValueBinding _vb = getValueBinding("readOnly"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.readOnly;
    }
  }

  /**
   * <p>Set the value of the <code>readOnly</code> property.</p>
   */
  public void setReadOnly(boolean readOnly) {
    this.readOnly = readOnly;
    this.readOnly_set = true;
  }


  private boolean underline = false;
  private boolean underline_set = false;

  /**
   * <p>Return the value of the <code>underline</code> property.  Contents:</p><p>
   * Should the column be underlined or not
   * </p>
   */
  public boolean isUnderline() {
    if (this.underline_set) {
      return this.underline;
    }
    ValueBinding _vb = getValueBinding("underline"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.underline;
    }
  }

  /**
   * <p>Set the value of the <code>underline</code> property.</p>
   */
  public void setUnderline(boolean underline) {
    this.underline = underline;
    this.underline_set = true;
  }


  private java.lang.String width;

  /**
   * <p>Return the value of the <code>width</code> property.  Contents:</p><p>
   * Width of the column
   * </p>
   */
  public java.lang.String getWidth() {
    if (null != this.width) {
      return this.width;
    }
    ValueBinding _vb = getValueBinding("width"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>width</code> property.</p>
   */
  public void setWidth(java.lang.String width) {
    this.width = width;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[8];
    _values[0] = super.saveState(_context);
    _values[1] = alignment;
    _values[2] = colHead;
    _values[3] = this.readOnly ? Boolean.TRUE : Boolean.FALSE;
    _values[4] = this.readOnly_set ? Boolean.TRUE : Boolean.FALSE;
    _values[5] = this.underline ? Boolean.TRUE : Boolean.FALSE;
    _values[6] = this.underline_set ? Boolean.TRUE : Boolean.FALSE;
    _values[7] = width;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.alignment = (java.lang.String) _values[1];
    this.colHead = (java.lang.String) _values[2];
    this.readOnly = ((Boolean) _values[3]).booleanValue();
    this.readOnly_set = ((Boolean) _values[4]).booleanValue();
    this.underline = ((Boolean) _values[5]).booleanValue();
    this.underline_set = ((Boolean) _values[6]).booleanValue();
    this.width = (java.lang.String) _values[7];
  }


}
