/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>GraphDrawDataSeries</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlGraphDrawDataSeries extends com.ibm.faces.bf.component.UIGraphDrawDataSeries {


  public HtmlGraphDrawDataSeries() {
    super();
    setRendererType("GraphDrawDataSeries"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.bf.HtmlGraphDrawDataSeries"; //$NON-NLS-1$


  private java.lang.String groupOperation;

  /**
   * <p>Return the value of the <code>groupOperation</code> property.  Contents:</p><p>
   * The aggregation function to be applied on the values in
   * 				this series
   * </p>
   */
  public java.lang.String getGroupOperation() {
    if (null != this.groupOperation) {
      return this.groupOperation;
    }
    ValueBinding _vb = getValueBinding("groupOperation"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>groupOperation</code> property.</p>
   */
  public void setGroupOperation(java.lang.String groupOperation) {
    this.groupOperation = groupOperation;
  }


  private java.lang.String seriesName;

  /**
   * <p>Return the value of the <code>seriesName</code> property.  Contents:</p><p>
   * Name of the series
   * </p>
   */
  public java.lang.String getSeriesName() {
    if (null != this.seriesName) {
      return this.seriesName;
    }
    ValueBinding _vb = getValueBinding("seriesName"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>seriesName</code> property.</p>
   */
  public void setSeriesName(java.lang.String seriesName) {
    this.seriesName = seriesName;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[3];
    _values[0] = super.saveState(_context);
    _values[1] = groupOperation;
    _values[2] = seriesName;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.groupOperation = (java.lang.String) _values[1];
    this.seriesName = (java.lang.String) _values[2];
  }


}
