/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>Tree</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlTree extends com.ibm.faces.bf.component.UITree {


  public HtmlTree() {
    super();
    setRendererType("Tree"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.bf.HtmlTree"; //$NON-NLS-1$


  private java.lang.String dir;

  /**
   * <p>Return the value of the <code>dir</code> property.  Contents:</p><p>
   * The dir of the tree
   * </p>
   */
  public java.lang.String getDir() {
    if (null != this.dir) {
      return this.dir;
    }
    ValueBinding _vb = getValueBinding("dir"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>dir</code> property.</p>
   */
  public void setDir(java.lang.String dir) {
    this.dir = dir;
  }


  private boolean enableSelect = false;
  private boolean enableSelect_set = false;

  /**
   * <p>Return the value of the <code>enableSelect</code> property.  Contents:</p><p>
   * Boolean property to enable selection boxes or not.
   * </p>
   */
  public boolean isEnableSelect() {
    if (this.enableSelect_set) {
      return this.enableSelect;
    }
    ValueBinding _vb = getValueBinding("enableSelect"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.enableSelect;
    }
  }

  /**
   * <p>Set the value of the <code>enableSelect</code> property.</p>
   */
  public void setEnableSelect(boolean enableSelect) {
    this.enableSelect = enableSelect;
    this.enableSelect_set = true;
  }


  private java.lang.String height;

  /**
   * <p>Return the value of the <code>height</code> property.  Contents:</p><p>
   * Tree height--in pixels or percentage
   * </p>
   */
  public java.lang.String getHeight() {
    if (null != this.height) {
      return this.height;
    }
    ValueBinding _vb = getValueBinding("height"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>height</code> property.</p>
   */
  public void setHeight(java.lang.String height) {
    this.height = height;
  }


  private java.lang.String lang;

  /**
   * <p>Return the value of the <code>lang</code> property.  Contents:</p><p>
   * The lang of the tree
   * </p>
   */
  public java.lang.String getLang() {
    if (null != this.lang) {
      return this.lang;
    }
    ValueBinding _vb = getValueBinding("lang"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>lang</code> property.</p>
   */
  public void setLang(java.lang.String lang) {
    this.lang = lang;
  }


  private boolean rootVisibleFlag = false;
  private boolean rootVisibleFlag_set = false;

  /**
   * <p>Return the value of the <code>rootVisibleFlag</code> property.  Contents:</p><p>
   * Boolean property to identify tree root visible or not.
   * </p>
   */
  public boolean isRootVisibleFlag() {
    if (this.rootVisibleFlag_set) {
      return this.rootVisibleFlag;
    }
    ValueBinding _vb = getValueBinding("rootVisibleFlag"); //$NON-NLS-1$
    if (_vb != null) {
      Object _result = _vb.getValue(getFacesContext());
      if (_result == null) {
        return false;
      } else {
        return ((Boolean) _result).booleanValue();
      }
    } else {
        return this.rootVisibleFlag;
    }
  }

  /**
   * <p>Set the value of the <code>rootVisibleFlag</code> property.</p>
   */
  public void setRootVisibleFlag(boolean rootVisibleFlag) {
    this.rootVisibleFlag = rootVisibleFlag;
    this.rootVisibleFlag_set = true;
  }


  private java.lang.String scrollNum;

  /**
   * <p>Return the value of the <code>scrollNum</code> property.  Contents:</p><p>
   * Number of nodes before scrolling is activated
   * </p>
   */
  public java.lang.String getScrollNum() {
    if (null != this.scrollNum) {
      return this.scrollNum;
    }
    ValueBinding _vb = getValueBinding("scrollNum"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>scrollNum</code> property.</p>
   */
  public void setScrollNum(java.lang.String scrollNum) {
    this.scrollNum = scrollNum;
  }


  private java.lang.String styleClass;

  /**
   * <p>Return the value of the <code>styleClass</code> property.  Contents:</p><p>
   * Prefix specifying CSS for multiple data grids on page
   * </p>
   */
  public java.lang.String getStyleClass() {
    if (null != this.styleClass) {
      return this.styleClass;
    }
    ValueBinding _vb = getValueBinding("styleClass"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>styleClass</code> property.</p>
   */
  public void setStyleClass(java.lang.String styleClass) {
    this.styleClass = styleClass;
  }


  private java.lang.String systemIconStyle;

  /**
   * <p>Return the value of the <code>systemIconStyle</code> property.  Contents:</p><p>
   * A style string to configure the icons for the tree.
   * </p>
   */
  public java.lang.String getSystemIconStyle() {
    if (null != this.systemIconStyle) {
      return this.systemIconStyle;
    }
    ValueBinding _vb = getValueBinding("systemIconStyle"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>systemIconStyle</code> property.</p>
   */
  public void setSystemIconStyle(java.lang.String systemIconStyle) {
    this.systemIconStyle = systemIconStyle;
  }


  private java.lang.Object value;

  /**
   * <p>Return the value of the <code>value</code> property.  Contents:</p><p>
   * Value for setting server data binding only, bound
   * 			data to this component should be either client or server, however if both are bound to the
   * 			component the server side value set in this attribute will be used.
   * </p>
   */
  public java.lang.Object getValue() {
    if (null != this.value) {
      return this.value;
    }
    ValueBinding _vb = getValueBinding("value"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.Object) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>value</code> property.</p>
   */
  public void setValue(java.lang.Object value) {
    this.value = value;
  }


  private java.lang.Object _var;

  /**
   * <p>Return the value of the <code>var</code> property.  Contents:</p><p>
   * var for child nodes
   * </p>
   */
  public java.lang.Object getVar() {
    if (null != this._var) {
      return this._var;
    }
    ValueBinding _vb = getValueBinding("var"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.Object) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>var</code> property.</p>
   */
  public void setVar(java.lang.Object _var) {
    this._var = _var;
  }


  private java.lang.String width;

  /**
   * <p>Return the value of the <code>width</code> property.  Contents:</p><p>
   * Tree width--in pixels or percentage
   * </p>
   */
  public java.lang.String getWidth() {
    if (null != this.width) {
      return this.width;
    }
    ValueBinding _vb = getValueBinding("width"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>width</code> property.</p>
   */
  public void setWidth(java.lang.String width) {
    this.width = width;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[14];
    _values[0] = super.saveState(_context);
    _values[1] = dir;
    _values[2] = this.enableSelect ? Boolean.TRUE : Boolean.FALSE;
    _values[3] = this.enableSelect_set ? Boolean.TRUE : Boolean.FALSE;
    _values[4] = height;
    _values[5] = lang;
    _values[6] = this.rootVisibleFlag ? Boolean.TRUE : Boolean.FALSE;
    _values[7] = this.rootVisibleFlag_set ? Boolean.TRUE : Boolean.FALSE;
    _values[8] = scrollNum;
    _values[9] = styleClass;
    _values[10] = systemIconStyle;
    _values[11] = value;
    _values[12] = _var;
    _values[13] = width;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.dir = (java.lang.String) _values[1];
    this.enableSelect = ((Boolean) _values[2]).booleanValue();
    this.enableSelect_set = ((Boolean) _values[3]).booleanValue();
    this.height = (java.lang.String) _values[4];
    this.lang = (java.lang.String) _values[5];
    this.rootVisibleFlag = ((Boolean) _values[6]).booleanValue();
    this.rootVisibleFlag_set = ((Boolean) _values[7]).booleanValue();
    this.scrollNum = (java.lang.String) _values[8];
    this.styleClass = (java.lang.String) _values[9];
    this.systemIconStyle = (java.lang.String) _values[10];
    this.value = (java.lang.Object) _values[11];
    this._var = (java.lang.Object) _values[12];
    this.width = (java.lang.String) _values[13];
  }


}
