/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.component.html;


import java.io.IOException;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.ValueBinding;


/**
 * <p>By default, the <code>rendererType</code> property must be set to "<code>TreeNodeAttr</code>" This value can be changed by calling the <code>setRendererType()</code> method.</p>
*/
public class HtmlTreeNodeAttr extends com.ibm.faces.bf.component.UITreeNodeAttr {


  public HtmlTreeNodeAttr() {
    super();
    setRendererType("TreeNodeAttr"); //$NON-NLS-1$
  }


  /*
   * <p>The standard component type for this component.</p>
   */
   public static final String COMPONENT_TYPE = "com.ibm.faces.bf.HtmlTreeNodeAttr"; //$NON-NLS-1$


  private java.lang.String attributeName;

  /**
   * <p>Return the value of the <code>attributeName</code> property.  Contents:</p><p>
   * Attribute name of the Java class that will be displayed
   * 				as the label of the node.
   * </p>
   */
  public java.lang.String getAttributeName() {
    if (null != this.attributeName) {
      return this.attributeName;
    }
    ValueBinding _vb = getValueBinding("attributeName"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>attributeName</code> property.</p>
   */
  public void setAttributeName(java.lang.String attributeName) {
    this.attributeName = attributeName;
  }


  private java.lang.String childValue;

  /**
   * <p>Return the value of the <code>childValue</code> property.  Contents:</p><p>
   * Value for child nodes
   * </p>
   */
  public java.lang.String getChildValue() {
    if (null != this.childValue) {
      return this.childValue;
    }
    ValueBinding _vb = getValueBinding("childValue"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>childValue</code> property.</p>
   */
  public void setChildValue(java.lang.String childValue) {
    this.childValue = childValue;
  }


  private java.lang.String className;

  /**
   * <p>Return the value of the <code>className</code> property.  Contents:</p><p>
   * The fully qualified class name of the kind of objects to
   * 				be shown in this node
   * </p>
   */
  public java.lang.String getClassName() {
    if (null != this.className) {
      return this.className;
    }
    ValueBinding _vb = getValueBinding("className"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>className</code> property.</p>
   */
  public void setClassName(java.lang.String className) {
    this.className = className;
  }


  private java.lang.String closeIcon;

  /**
   * <p>Return the value of the <code>closeIcon</code> property.  Contents:</p><p>
   * The icon to be displayed when this tree node is
   * 				collapsed.
   * </p>
   */
  public java.lang.String getCloseIcon() {
    if (null != this.closeIcon) {
      return this.closeIcon;
    }
    ValueBinding _vb = getValueBinding("closeIcon"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>closeIcon</code> property.</p>
   */
  public void setCloseIcon(java.lang.String closeIcon) {
    this.closeIcon = closeIcon;
  }


  private java.lang.String enableDrop;

  /**
   * <p>Return the value of the <code>enableDrop</code> property.  Contents:</p><p>
   * Boolean to indicate if node is valid drop target
   * </p>
   */
  public java.lang.String getEnableDrop() {
    if (null != this.enableDrop) {
      return this.enableDrop;
    }
    ValueBinding _vb = getValueBinding("enableDrop"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>enableDrop</code> property.</p>
   */
  public void setEnableDrop(java.lang.String enableDrop) {
    this.enableDrop = enableDrop;
  }


  private java.lang.String oncollapse;

  /**
   * <p>Return the value of the <code>oncollapse</code> property.  Contents:</p><p>
   * The handler to be called when the OnCollapse event is
   * 				fired.
   * </p>
   */
  public java.lang.String getOncollapse() {
    if (null != this.oncollapse) {
      return this.oncollapse;
    }
    ValueBinding _vb = getValueBinding("oncollapse"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>oncollapse</code> property.</p>
   */
  public void setOncollapse(java.lang.String oncollapse) {
    this.oncollapse = oncollapse;
  }


  private java.lang.String ondragenterover;

  /**
   * <p>Return the value of the <code>ondragenterover</code> property.  Contents:</p><p>
   * The handler to be called when the Ondragenterover event is
   * 				fired.
   * </p>
   */
  public java.lang.String getOndragenterover() {
    if (null != this.ondragenterover) {
      return this.ondragenterover;
    }
    ValueBinding _vb = getValueBinding("ondragenterover"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>ondragenterover</code> property.</p>
   */
  public void setOndragenterover(java.lang.String ondragenterover) {
    this.ondragenterover = ondragenterover;
  }


  private java.lang.String onexpand;

  /**
   * <p>Return the value of the <code>onexpand</code> property.  Contents:</p><p>
   * The handler to be called when the OnExpand event is
   * 				fired.
   * </p>
   */
  public java.lang.String getOnexpand() {
    if (null != this.onexpand) {
      return this.onexpand;
    }
    ValueBinding _vb = getValueBinding("onexpand"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onexpand</code> property.</p>
   */
  public void setOnexpand(java.lang.String onexpand) {
    this.onexpand = onexpand;
  }


  private java.lang.String onhighlight;

  /**
   * <p>Return the value of the <code>onhighlight</code> property.  Contents:</p><p>
   * The handler to be called when the OnHighlight event is
   * 				fired.
   * </p>
   */
  public java.lang.String getOnhighlight() {
    if (null != this.onhighlight) {
      return this.onhighlight;
    }
    ValueBinding _vb = getValueBinding("onhighlight"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onhighlight</code> property.</p>
   */
  public void setOnhighlight(java.lang.String onhighlight) {
    this.onhighlight = onhighlight;
  }


  private java.lang.String onselect;

  /**
   * <p>Return the value of the <code>onselect</code> property.  Contents:</p><p>
   * The handler to be called when the OnSelect event is
   * 				fired.
   * </p>
   */
  public java.lang.String getOnselect() {
    if (null != this.onselect) {
      return this.onselect;
    }
    ValueBinding _vb = getValueBinding("onselect"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onselect</code> property.</p>
   */
  public void setOnselect(java.lang.String onselect) {
    this.onselect = onselect;
  }


  private java.lang.String onunselect;

  /**
   * <p>Return the value of the <code>onunselect</code> property.  Contents:</p><p>
   * The handler to be called when the OnUnSelect event is
   * 				fired.
   * </p>
   */
  public java.lang.String getOnunselect() {
    if (null != this.onunselect) {
      return this.onunselect;
    }
    ValueBinding _vb = getValueBinding("onunselect"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>onunselect</code> property.</p>
   */
  public void setOnunselect(java.lang.String onunselect) {
    this.onunselect = onunselect;
  }


  private java.lang.String openIcon;

  /**
   * <p>Return the value of the <code>openIcon</code> property.  Contents:</p><p>
   * The icon to be displayed when this tree node is
   * 				expanded.
   * </p>
   */
  public java.lang.String getOpenIcon() {
    if (null != this.openIcon) {
      return this.openIcon;
    }
    ValueBinding _vb = getValueBinding("openIcon"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>openIcon</code> property.</p>
   */
  public void setOpenIcon(java.lang.String openIcon) {
    this.openIcon = openIcon;
  }


  private java.lang.String referenceName;

  /**
   * <p>Return the value of the <code>referenceName</code> property.  Contents:</p><p>
   * Comma delimited reference name string of the Java class
   * 				that will e displayed as child nodes of this node.
   * </p>
   */
  public java.lang.String getReferenceName() {
    if (null != this.referenceName) {
      return this.referenceName;
    }
    ValueBinding _vb = getValueBinding("referenceName"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>referenceName</code> property.</p>
   */
  public void setReferenceName(java.lang.String referenceName) {
    this.referenceName = referenceName;
  }


  private java.lang.String showSystemIcon;

  /**
   * <p>Return the value of the <code>showSystemIcon</code> property.  Contents:</p><p>
   * Flag to decide whether +/- should be shown with icon.
   * 				False means if should not. Default value is True
   * </p>
   */
  public java.lang.String getShowSystemIcon() {
    if (null != this.showSystemIcon) {
      return this.showSystemIcon;
    }
    ValueBinding _vb = getValueBinding("showSystemIcon"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>showSystemIcon</code> property.</p>
   */
  public void setShowSystemIcon(java.lang.String showSystemIcon) {
    this.showSystemIcon = showSystemIcon;
  }


  private java.lang.String _var;

  /**
   * <p>Return the value of the <code>var</code> property.  Contents:</p><p>
   * var for child table
   * </p>
   */
  public java.lang.String getVar() {
    if (null != this._var) {
      return this._var;
    }
    ValueBinding _vb = getValueBinding("var"); //$NON-NLS-1$
    if (_vb != null) {
      return (java.lang.String) _vb.getValue(getFacesContext());
    } else {
      return null;
    }
  }

  /**
   * <p>Set the value of the <code>var</code> property.</p>
   */
  public void setVar(java.lang.String _var) {
    this._var = _var;
  }


  public Object saveState(FacesContext _context) {
    Object _values[] = new Object[16];
    _values[0] = super.saveState(_context);
    _values[1] = attributeName;
    _values[2] = childValue;
    _values[3] = className;
    _values[4] = closeIcon;
    _values[5] = enableDrop;
    _values[6] = oncollapse;
    _values[7] = ondragenterover;
    _values[8] = onexpand;
    _values[9] = onhighlight;
    _values[10] = onselect;
    _values[11] = onunselect;
    _values[12] = openIcon;
    _values[13] = referenceName;
    _values[14] = showSystemIcon;
    _values[15] = _var;
    return _values;
  }


  public void restoreState(FacesContext _context, Object _state) {
    Object _values[] = (Object[]) _state;
    super.restoreState(_context, _values[0]);
    this.attributeName = (java.lang.String) _values[1];
    this.childValue = (java.lang.String) _values[2];
    this.className = (java.lang.String) _values[3];
    this.closeIcon = (java.lang.String) _values[4];
    this.enableDrop = (java.lang.String) _values[5];
    this.oncollapse = (java.lang.String) _values[6];
    this.ondragenterover = (java.lang.String) _values[7];
    this.onexpand = (java.lang.String) _values[8];
    this.onhighlight = (java.lang.String) _values[9];
    this.onselect = (java.lang.String) _values[10];
    this.onunselect = (java.lang.String) _values[11];
    this.openIcon = (java.lang.String) _values[12];
    this.referenceName = (java.lang.String) _values[13];
    this.showSystemIcon = (java.lang.String) _values[14];
    this._var = (java.lang.String) _values[15];
  }


}
