/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.listeners;

import javax.faces.component.UIComponent;
import javax.faces.event.AbortProcessingException;
import javax.faces.event.ActionEvent;
import javax.faces.event.ActionListener;
import javax.faces.event.PhaseId;

import com.ibm.faces.bf.component.UIClientData;
import com.ibm.faces.bf.renderkit.ELUtil;
import com.ibm.odcb.jrender.diff.DiffException;
import com.ibm.odcb.jrender.diff.DiffProcessor.DiffedObjectsLists;
import com.ibm.odcb.jrender.emitters.WDO4JSEmitter;
import com.ibm.odcb.jrender.misc.Streamer;

/**
 * @author fenil
 */
public class DiffListener implements ActionListener {

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.faces.event.ActionListener#processAction(javax.faces.event.ActionEvent)
	 */
	public void processAction(ActionEvent event)
			throws AbortProcessingException {
		UIComponent component = event.getComponent();
		if(component instanceof UIClientData){
			UIClientData data = (UIClientData)component;
			String diff = data.getDiffStr();
			WDO4JSEmitter emitter = new WDO4JSEmitter();
			emitter.Init(data.getValue(), new ELUtil(data).getModelName());
			try {
				//TODO Check if creating a new instance of ELUtil is the best way to do this
				//maybe ELUtil.getModelName can set the model name on the component and that can be reused
				DiffedObjectsLists diffedObjectsLists = emitter.Import(diff);
				data.setDiffedObjectsLists(diffedObjectsLists);
			} catch (DiffException e) {
				Streamer.error.Header().println("Auto diff processing error");
				e.printStackTrace();
			}
		}
	}

	public PhaseId getPhaseId() {
		return PhaseId.INVOKE_APPLICATION;
	}
}