/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.portal;
import javax.faces.context.ExternalContext;
import com.ibm.odcb.jrender.misc.Config;
import com.ibm.odcb.jrender.misc.URLRewriter;
/**
 * <p>
 * This class implements the <code>URLRewriter</code> interface and is
 * the concrete implementation of this interface that is used for
 * rewriting resource URL's when running in the JSF environment.
 * </p>
 * @see URLRewriter
 * @author fenils
 */
public class JSFURLRewriter implements URLRewriter
{
	private ExternalContext context = null;
	private static String pathPrefix = null;
	public JSFURLRewriter(ExternalContext context)
	{
		this.context = context;
		//RATLC01083006
		if(pathPrefix == null)
			pathPrefix = Config.getString(Config.PROP_PATH_PREFIX);
	}
	/* (non-Javadoc)
	 * @see com.ibm.odcb.jrender.misc.URLRewriter#Rewrite(java.lang.String)
	 */
	public String Rewrite(String Url)
	{
		if (pathPrefix != null)
		{
			if (Url.startsWith("/"))
			{
				Url = pathPrefix + Url;
			}
			else
			{
				Url = pathPrefix + "/" + Url;
			}
		}
		//this was altered to add support for wsrp
		String theEncodedURL = context.encodeResourceURL(context.getRequestContextPath()+"/"+Url);
		return theEncodedURL;
	}
}
