/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.renderkit;

import java.io.IOException;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

import com.ibm.faces.bf.component.UIGraphDraw;
import com.ibm.odcb.jrender.emitters.GraphDrawEmitter;
import com.ibm.odcb.jrender.misc.Streamer;

/**
 * Renderer for {@link com.ibm.faces.bf.component.UIGraphDrawDataSeries UIGraphDrawDataSeries} component. 
 * <p> 
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.GraphDrawDataSeriesTag}<br>
 * <b>Components:</b> {@link com.ibm.faces.bf.component.UIGraphDrawDataSeries}
 * </p> 
 * @see BrowserFrameworkRenderer 
 * @author Vidya Rao
 */
public class GraphDrawDataSeriesRenderer extends BrowserFrameworkRenderer {
	/*
	 * @see javax.faces.render.Renderer#encodeEnd(javax.faces.context.FacesContext, javax.faces.component.UIComponent)
	 */
	public void encodeEnd(FacesContext context, UIComponent component) throws IOException {
		Streamer.trace.Header().println("enter encodeEnd() of GraphDrawDataSeriesRenderer.java");
		if (context == null) {
			throw new NullPointerException();
		}
		//call super.encodeEnd to setup the elutil
		super.encodeEnd(context, component);
		String id = (String)component.getAttributes().get(ID);
		String attributeName = (String)component.getAttributes().get(ATTRIBUTE_NAME);
		String seriesName = (String)component.getAttributes().get(SERIES_NAME);
		if (seriesName == null) {
			seriesName = "Series " + attributeName; 
		}
		String groupOperation = (String)component.getAttributes().get(GROUP_OPERATION);
		if (groupOperation == null) {
			groupOperation = "None";
		}
		Streamer.trace.Header().println("id = " + id + ", seriesName = " + seriesName + ", attributeName = " + attributeName + ", group op = " + groupOperation);

		UIGraphDraw myParent = (UIGraphDraw)(component.getParent().getParent());
		if (myParent == null)
		{
			Streamer.error.Header().println("The Parent GraphDraw is null!");
			throw new IOException("The Parent GraphDraw is null!");
		}
		
		String eAttributeName = attributeName;
		
		Streamer.trace.Header().println("eAttributeName = " + eAttributeName + ", group op = " + groupOperation);
		
		GraphDrawEmitter emitter = (GraphDrawEmitter)myParent.getEmitter();
		emitter.addDataSeries(id, seriesName, eAttributeName, groupOperation);
		
		Streamer.trace.Header().println("exit encodeEnd() of GraphDrawDataSeriesRenderer.java");
	}
	
	private static final String ID = "id";	
	private static final String SERIES_NAME = "seriesName";
	private static final String ATTRIBUTE_NAME = "attributeName";
	private static final String GROUP_OPERATION = "groupOperation";
}
