/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.renderkit;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Locale;
import java.util.Map;
import java.util.StringTokenizer;

import javax.faces.component.UIColumn;
import javax.faces.component.UIComponent;
import javax.faces.component.UIViewRoot;
import javax.faces.component.html.HtmlOutputText;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.el.ValueBinding;

import javax.faces.application.Application;

////#IF# SDO
import org.eclipse.emf.ecore.sdo.impl.DynamicEDataObjectImpl;
import org.eclipse.emf.ecore.util.EcoreEList;
////#END#

////#IF# WDO
//import com.ibm.etools.wdo.datagraph.impl.DynamicDataObjectImpl;
//import com.ibm.websphere.sdo.internal.DataListAccessBeanImpl;
////#END#

import com.ibm.faces.bf.component.UIBrowserFramework;
import com.ibm.faces.bf.component.UITree;
import com.ibm.faces.bf.component.html.HtmlTree;
import com.ibm.faces.bf.component.html.HtmlTreeColumnData;
import com.ibm.faces.bf.component.html.HtmlTreeNodeAttr;
import com.ibm.faces.bf.portal.JSFURLRewriter;
import com.ibm.faces.bf.util.InitializationUtil;
import com.ibm.faces.bf.util.ODCContextHelper;
import com.ibm.faces.component.IScriptContributor;
import com.ibm.faces.component.UIScriptCollector;
import com.ibm.faces.component.html.HtmlDataXml;
import com.ibm.faces.component.html.HtmlScriptCollector;
import com.ibm.odcb.jrender.emitters.NodeAttributeEmitterHelper;
import com.ibm.odcb.jrender.emitters.TreeViewEmitter;
import com.ibm.odcb.jrender.emitters.WDO4JSEmitter;
import com.ibm.odcb.jrender.mediators.PageContext;
import com.ibm.odcb.jrender.misc.ClassIntrospector;
import com.ibm.odcb.jrender.misc.Config;
import com.ibm.odcb.jrender.misc.Streamer;
import com.ibm.odcb.jrender.misc.StringUtil;
import com.ibm.odcb.jrender.misc.URLRewriter;
import com.ibm.odcb.jrender.misc.ValueInspector;
import com.ibm.odcb.jrender.misc.Utils;

/**
 * Renderer for {@link com.ibm.faces.bf.component.UITree UITree} component.
 * The renderer renders aggregates the child {@link com.ibm.faces.bf.component.UITreeNodeAttr} nodes of the
 * <code>UITree</code> component and renders the Tree View as one control on the page.
 * <p> 
 * <b>Tags:</b> {@link com.ibm.faces.bf.taglib.TreeTag}<br>
 * <b>Components:</b> {@link com.ibm.faces.bf.component.UITree}
 * </p> 
 * @see BrowserFrameworkRenderer  
 * @author Jianren Li
 */
public class TreeRenderer extends BrowserFrameworkRenderer implements IScriptContributor {
	
	// this gut is used to hold the name of the spacer data columns
	private String JWL_BLANK = "____JWL____";
	
	/**
		  * This method retrieves the data bean for the tree and initializes treeViewEmitter.
		  * @param context javax.faces.context.FacesContext
		  * @exception IOException - An exception is thrown if encountered an error.
		  **/
	
	public void encodeBegin(FacesContext context, UIComponent component) throws IOException {


		Streamer.trace.Header().println("Entering encodeBegin() of TreeRenderer.java");
		if (context == null) {
			throw new NullPointerException();
		}
		
		//check for page data binding and process it if set
//		processPageDataBinding(context,component);
	
		//call super.encodeBegin to setup elutil
		super.encodeBegin(context, component);
		String id = component.getId();
		Streamer.debug.Header().println("in encodeBegin() of TreeRenderer.java getting id:" + id);
		TreeViewEmitter treeViewEmitter = new TreeViewEmitter();
		((UITree) component).setEmitter(treeViewEmitter);
		
	
	
		
		if(component.getValueBinding("value") != null)
		{
			component.getAttributes().put("isPageData",new Boolean(true));	
		}
	
		
		
		
		Streamer.trace.Header().println("Exiting encodeBegin() of TreeRenderer.java");
		
		
		
		
	}
	/**
	  * This method pushes out all JavaScript code for tree control.
	  * @param context javax.faces.context.FacesContext
	  * @exception IOException - An exception is thrown if exporting fails.
	  **/
	public void encodeEnd(FacesContext context, UIComponent component) throws IOException {
	
		Streamer.trace.Header().println("Entering encodeEnd() of TreeRenderer.java");
		HashMap xmlValues = null;
		boolean isPageDataBinding = false;
		if (component.getAttributes().get("isPageData") != null) {		
			isPageDataBinding = true;
			xmlValues = this.exportXMLData(context, component);
		}
		else if (((UITree)component).getClientBinding() == null)
		{
			return;
		}
		

		UIScriptCollector scriptCollector = UIScriptCollector.find(component);
		scriptCollector.register(this, component);
		
		
		if (context == null) {
			throw new NullPointerException();
		}
		super.encodeEnd(context, component);
		
		TreeViewEmitter treeViewEmitter = (TreeViewEmitter)((UITree)component).getEmitter();
		try {
			
			
			if (isPageDataBinding) {
				
					String modelName = (String)xmlValues.get("modelName");
			
					String rootId = (String)xmlValues.get("rootID");
				
					treeViewEmitter.Init(modelName, rootId);
					
					String lis = JSUtil.registerUIStateListenerJS(component, context);
					if(lis != null)
						scriptCollector.addScriptOnce(lis, UIScriptCollector.ADD_AT_BOTTOM);
					
					
				}
				else {
				
				Object rootBean = null;
				
					//Fix for defect 284542 -> Tree should be bound to its root object and not the root of the model
					//rootBean = this.elUtil.getRootObject();
				
					
					rootBean = this.elUtil.resolveWholeExpressionToObject();
					String rootId = null;
		
					//We need to get rootId from WDO4JSEmitter based on the root Java object passed
					//PathTokenizer tokenizer = new PathTokenizer(this.getStrippedString(component));
					//String rootBeanName = tokenizer.getRoot();
					WDO4JSEmitter aWDO4JSEmitter =
						(WDO4JSEmitter) ODCContextHelper.getEmitter(context, this.elUtil.getModelName());
					rootId = aWDO4JSEmitter.getExportIDByObject(rootBean);
					Streamer.debug.Header().println("inside encodeBegin() of TreeRenderer.java rootId from emitter:" + rootId);
					//we also need to retrieve the JavaScript modelName from WDO4JSEmitter
					
					treeViewEmitter.Init(this.elUtil.getModelName(), rootId);
				}
			
			
			PageContext pageContext = ODCContextHelper.getODCPageContext(context);
			
			Map m = component.getAttributes();
			
			treeViewEmitter.setDir((String)m.get("dir"));
			treeViewEmitter.setLang((String)m.get("lang"));
			
			treeViewEmitter.exportSpan(context.getResponseWriter(), pageContext);
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
			Streamer.debug.Header().println(
				"Exception occurred during tree code export in encodeEnd() of TreeRenderer.java");
			throw new IOException();
		}
		
		 
	}
	/**
	  * This method receives a state string from a browser and store it inside
	  * the stateBean, which will be used when next time the tree is rendered to restore
	  * its UI state.
	  * @param context javax.faces.context.FacesContext
	  * @exception IOException - An exception is thrown if encountered an error.
	  **/
	public void decode(FacesContext context, UIComponent component) {
		Streamer.trace.Header().println("Entering decode() of TreeRenderer.java");
		if (context == null) {
			throw new NullPointerException();
		}
		String odcTreeState1 = null;
		Map requestParameterMap = context.getExternalContext().getRequestParameterMap();
		odcTreeState1 = (String) requestParameterMap.get(component.getClientId(context) + "UIS");
		((UITree) component).setStateString(odcTreeState1);
		Streamer.debug.Header().println("in decode() of TreeRenderer.java odcTreeState1:" + odcTreeState1);
		Streamer.trace.Header().println("Exiting decode() of TreeRenderer.java");
	}
	
	private HashMap exportXMLData(FacesContext context, UIComponent component)
	{
		Object value = ((HtmlTree)component).getValue();
	//	String var = (String)((HtmlTree)component).getAttributes().get("_var");
		HtmlDataXml xmlComp = new HtmlDataXml();
		
		xmlComp.setTransient(true);
		
		
		
		xmlComp.setValue(value);
		xmlComp.setVar("varroot");
		

		xmlComp.setValueBinding("value",component.getValueBinding("value"));
				
		String rootID = "";
		
	
		HtmlDataXml tmpXmlComp;
		
		// This nodes map will keep a record of what the nodes are children of.
		HashMap nodesMap = new HashMap();
		HashMap nodesCycleMap = new HashMap();
		
				
		ValueInspector vi = new ValueInspector(value);
				
		UIViewRoot viewRoot = context.getViewRoot();
		
	
		getScriptCollector(viewRoot.getChildren().iterator()).getChildren().add(xmlComp);
		
		TreeViewEmitter treeViewEmitter = (TreeViewEmitter)((UITree)component).getEmitter();
		
		int nodeCount = 0;
		boolean hasValues = true;
		boolean isSDO = false;
		
		Application application = context.getApplication();
		
		int ks = 0;
		while (hasValues && !isSDO)
		{	
			if (ks > 0)	hasValues = false;
			
			boolean dataGraphRoot = false;
			
			for (int i=0; i<component.getChildren().size(); i++)
			{
				
				dataGraphRoot = false;
				if (component.getChildren().get(i) instanceof HtmlTreeNodeAttr) {
				
					
					String newReference = "";
					String className = ((HtmlTreeNodeAttr)component.getChildren().get(i)).getClassName();
					////#IF# SDO
					if (className.indexOf("commonj.sdo.DataObject") != -1)
					////#END#
					////#IF# WDO
                                        //if (className.indexOf("com.ibm.etools.wdo") != -1)
                                        ////#END#
					{
						isSDO = true;
					}
					
					
					String shortClassName = (className.indexOf(".")==-1)?className:className.substring(className.lastIndexOf(".")+1);
					
					if ( ks > 0 ) {
											
						if  (nodesCycleMap.get(shortClassName) == null)
						{
							continue;					
						}
						else if (((Integer)nodesCycleMap.get(shortClassName)).intValue() < 1)
						{
							continue;
						}
						else {
				//			nodesCycleMap.put(shortClassName,new Integer(((Integer)nodesCycleMap.get(shortClassName)).intValue()-1));
						}
						
					}	
					

					////#IF# SDO
					if (className.indexOf("commonj.sdo.DataObject") != -1)
					////#END#
					////#IF# WDO
                                        //if (className.indexOf("com.ibm.etools.wdo") != -1)
                                        ////#END#
					{
						
						shortClassName = className.substring(className.lastIndexOf("`")+1,className.length()-1);
						
						if (shortClassName.equals("DataGraphRoot"))
						{
							dataGraphRoot = true;
							xmlComp.getAttributes().put("DataGraphRoot",shortClassName);
							
						//	continue;
						}
					}
					else {
						shortClassName = (className.indexOf(".")==-1)?className:className.substring(className.lastIndexOf(".")+1);
					}
					
					String attributeName = ((HtmlTreeNodeAttr)component.getChildren().get(i)).getAttributeName(); 
					String nodeLabel = ((HtmlTreeNodeAttr)component.getChildren().get(i)).getNodeLabel();
					NodeAttributeEmitterHelper node = null;
					if (ks <1 ) 
					{
						node = (NodeAttributeEmitterHelper)treeViewEmitter.getNodes().get(nodeCount);
					}
					String referenceName = ((HtmlTreeNodeAttr)component.getChildren().get(i)).getReferenceName();
	
					
					if (nodesMap.get(shortClassName) != null)
					{
						tmpXmlComp = (HtmlDataXml)nodesMap.get(shortClassName);	
						
						nodesCycleMap.put(shortClassName,new Integer(((Integer)nodesCycleMap.get(shortClassName)).intValue()-1));
						boolean hasValue = vi.hasValue(((HtmlTreeNodeAttr)component.getChildren().get(i)).getAttributeName(),shortClassName);
						
						if(!hasValue && ks > 0)
						{
							continue;
						}
						
						hasValues = hasValues?hasValues:hasValue;
						
					}
					else {
						
						tmpXmlComp = xmlComp;
					}
					
					tmpXmlComp.getAttributes().put("javaClassName",shortClassName);
					
					
					String parentVar = (String)tmpXmlComp.getVar();
									
					
					HtmlTreeNodeAttr treeNode = (HtmlTreeNodeAttr)component.getChildren().get(i);
					
					if (!dataGraphRoot)  ///////////////////////////start data graph root
					{	
										
						if (attributeName != null)
						{	
						
							ValueBinding nodeValue = application.createValueBinding("#{"+parentVar+"."+attributeName+"}");
										
							UIColumn thecolumn = new UIColumn();
							
							// If the first child use its attribute as the rootid
							
							if (i == 0)
							{
								rootID = treeNode.getAttributeName();				
							}
											
							HtmlOutputText theOutputText = new HtmlOutputText();
											
							theOutputText.setValueBinding("value",(ValueBinding)nodeValue);
							thecolumn.getChildren().add(theOutputText);
							tmpXmlComp.getChildren().add(thecolumn);	
							
						}
						else 
						{
							
							
							if (i == 0)
							{
								rootID = "root";
							}
						
							
						}
						
						ValueBinding colValue = null;
						
						// Set up the data for the Tree Table columns
						for (int k=0; k<treeNode.getChildren().size(); k++)
						{
							if (treeNode.getChildren().get(k) instanceof HtmlTreeColumnData)
							{
								String colAttributeName = ((HtmlTreeColumnData)treeNode.getChildren().get(k)).getAttributeName(); 
								
								if(colAttributeName != null)
									colValue = application.createValueBinding("#{"+parentVar+"."+colAttributeName+"}");
								
								UIColumn colDataColumn = new UIColumn();
								HtmlOutputText colOutputText = null;
								
									colOutputText = new HtmlOutputText();
								if(colAttributeName == null)
								{
									HtmlOutputText ncolOutputText = new HtmlOutputText();
									ncolOutputText.setValue(JWL_BLANK);
									colDataColumn.getFacets().put("header", ncolOutputText);
								}
								
								if(colAttributeName != null)
									colOutputText.setValueBinding("value",(ValueBinding)colValue);
								colDataColumn.getChildren().add(colOutputText);
								tmpXmlComp.getChildren().add(colDataColumn);
							}
							
						}	
											
						if (ks < 1) {
							node = (NodeAttributeEmitterHelper)treeViewEmitter.getNodes().get(nodeCount);
						}
												
						
						if ( referenceName != null && !referenceName.equals("")) {
											
							StringTokenizer st = new StringTokenizer(referenceName, ",");
							
							
							ValueBinding vb = null;
							
							while (st.hasMoreTokens()) {
								String tok = st.nextToken();
								tok = tok.trim();
								
								UIColumn dataColumn = new UIColumn();
								tmpXmlComp.getChildren().add(dataColumn);
							
								vb = application.createValueBinding("#{"+parentVar+"."+tok+"}");
								
								HtmlDataXml childXmlComp = new HtmlDataXml();
								childXmlComp.setValueBinding("value",vb);
														
								String tmpVar = "var"+tok+ks;
							
								
								dataColumn.getChildren().add(childXmlComp);
								
								childXmlComp.setVar(tmpVar);
								
								String theClassName = tok;
							
								ValueBinding vbXml = component.getValueBinding("value");
								
								if (vbXml != null)
								{
									Object treeValue = vbXml.getValue(context);
									Class rootClass = treeValue.getClass();
									ClassIntrospector c = new ClassIntrospector();
									
									if (!isSDO) {
										String tmpClassName = c.getAttributeClassName(rootClass, tok);
										
										if (tmpClassName != null) theClassName = tmpClassName.charAt(tmpClassName.length()-1) == ';'?tmpClassName.substring(tmpClassName.lastIndexOf(".")+1,tmpClassName.length()-1):tmpClassName.substring(tmpClassName.lastIndexOf(".")+1);
									}
									else
									{


                                                                                ////#IF# SDO
										Object objects[] = ((EcoreEList)treeValue).toArray();
                                                                                String name = (String)((DynamicEDataObjectImpl)objects[0]).eClass().getName().toString();
										DynamicEDataObjectImpl eli = ((DynamicEDataObjectImpl)objects[0]);
										////#END#
										
										////#IF# WDO
                                                                                //Object objects[] = ((DataListAccessBeanImpl)treeValue).getDataList().toArray();
                                                                                //DynamicDataObjectImpl eli = ((DynamicDataObjectImpl)objects[0]);
                                                                                ////#END#

										theClassName = c.getEClassNamefromObject(eli,tok);
										
									
											
									
									}
								}
								
								nodesMap.put(theClassName,childXmlComp);
								
								int childcount = nodesCycleMap.get(theClassName)==null?0:((Integer)nodesCycleMap.get(theClassName)).intValue(); 
								childcount++;
								nodesCycleMap.put(theClassName,(new Integer(childcount)));
								
						
								vi.setClassObject(shortClassName,theClassName,tok);
								
													
								// Make a new reference that will be emitted that xmldata will understand
								if (newReference.equals(""))
								{
									newReference = theClassName;
								}
								else
								{	
									newReference = newReference.concat(",").concat(theClassName);
								}
								
								
							}
							
							referenceName = newReference;
							
							if (ks<1) {
							
							try{
								
								if (referenceName != null && !referenceName.equals("")) {
									
									StringTokenizer nst = new StringTokenizer(referenceName, ",");
									//loop thru all individual references
									while (nst.hasMoreTokens()) {
										String tok = nst.nextToken();
										node.addStyleMap(attributeName, nodeLabel, tok);
									}
														
								}
						
							}
							catch(Exception ex) {
								
							}
							
							}
						}
						else
						{
							if (ks <1 ) 
							{
							try {
								node.addStyleMap(attributeName, nodeLabel,  null);
							}
							catch (Exception ex)
							{
								
							}
							
							}
						}	
						
					} ////////////////////////////////////////// end if datagraph if
					else {
						
						try {
						node.addStyleMap(null,nodeLabel,referenceName);
						}
						catch(Exception ex){
							
						}
					}
					
					nodeCount++;
				}
				
				
			}
			ks++;
		}
		
		
		
		
		try {
			xmlComp.encodeBegin(context);
			xmlComp.encodeChildren(context);
			xmlComp.encodeEnd(context);
		
			
		}
			
		
		
		catch (Exception e)
		{
			System.out.println(e.toString());
		}
		
		
		String modelName = xmlComp.getClientId(context).replaceAll(":","_");
		
		HashMap returnValues  = new HashMap();
		
		returnValues.put("modelName",modelName);
		returnValues.put("rootID",rootID);
		
		return returnValues;

	}
	
	private HtmlScriptCollector getScriptCollector(Iterator components)
	{
		
		while(components.hasNext())
		{
			UIComponent comp = (UIComponent)components.next();
			
			if ( comp instanceof HtmlScriptCollector )
			{
				return (HtmlScriptCollector)comp;
				
			}
			if ( !comp.getChildren().isEmpty() )
			{	
				return getScriptCollector(comp.getChildren().iterator());
			}
		}
		
		return null;
	}
	
	
	public void contributeScript(FacesContext context, UIComponent component) throws IOException {
		
		ResponseWriter writer = context.getResponseWriter();
		
		boolean isPageDataBinding = false;
		if (((Boolean)(component.getAttributes().get("isPageData"))) != null) {		
			isPageDataBinding = true;
		}
		
		
	//	ResponseWriterBuffer writer = new ResponseWriterBuffer();
		TreeViewEmitter treeViewEmitter = (TreeViewEmitter)((UITree)component).getEmitter();
		try {

			
			
			
			
			String id = component.getId();
			Streamer.debug.Header().println("in encodeBegin() of TreeRenderer.java getting id:" + id);
			String systemIconStyle = (String) component.getAttributes().get("systemIconStyle");
			Streamer.debug.Header().println(
				"in encodeBegin() of TreeRenderer.java getting systemIconStyle:" + systemIconStyle);
		
			Boolean rootVisibleFlag = (Boolean) component.getAttributes().get("rootVisibleFlag");
			Boolean enableSelect = (Boolean) component.getAttributes().get("enableSelect");
			Boolean userHighlight = (Boolean) component.getAttributes().get("userHighlight");
			String width = (String) component.getAttributes().get("width");
			String height = (String) component.getAttributes().get("height");
			String styleClass = (String) component.getAttributes().get("styleClass");
			
//			Changed to be added as f:attributes
			String workPlaceFlagHelper = (String)component.getAttributes().get("workPlaceFlag");
			boolean workPlaceFlag = false;
			if(workPlaceFlagHelper!=null)
				workPlaceFlag = workPlaceFlagHelper.trim().equalsIgnoreCase("true");
			String dynamicFlagHelper = (String)component.getAttributes().get("dynamicFlag");
			boolean dynamicFlag = false;
			if(dynamicFlagHelper!=null)
				dynamicFlag= dynamicFlagHelper.trim().equalsIgnoreCase("true");
			
			
			
	

			//Since this is optional                                                     
			if (systemIconStyle != null) {
				treeViewEmitter.setSystemIconStyle(systemIconStyle);
			}
			if (rootVisibleFlag != null) {
				treeViewEmitter.setRootVisibleFlag(rootVisibleFlag.booleanValue());
			}
			
			//Set values that are entered as f:attributes
			treeViewEmitter.setWorkPlaceFlag(workPlaceFlag);
			treeViewEmitter.setDynamicFlag(dynamicFlag);
			
			if (userHighlight != null) 
			{
				treeViewEmitter.setUserHighlight(userHighlight.booleanValue());
			}
			else
			{
				treeViewEmitter.setUserHighlight(false);
			}
			if (enableSelect != null) {
				treeViewEmitter.setEnableSelect(enableSelect.booleanValue());
			}
			if (width != null) {
				treeViewEmitter.setTreeWidth(width);
			}
			if (height != null) {
				treeViewEmitter.setTreeHeight(height);
			}
			if (styleClass != null) {
				treeViewEmitter.setStyleClass(styleClass);
			}
			//Add global tree events
			UITree treeComp = (UITree) component;
			String onnodeexpand = JSUtil.trimEventHandler(treeComp.getOnnodeexpand());
			treeViewEmitter.setOnnodeexpand(onnodeexpand);
			String onnodecollapse = JSUtil.trimEventHandler(treeComp.getOnnodecollapse());
			treeViewEmitter.setOnnodecollapse(onnodecollapse);		
			String onnodehighlight = JSUtil.trimEventHandler(treeComp.getOnnodehighlight());
			treeViewEmitter.setOnnodehighlight(onnodehighlight);
			String onnodeselect = JSUtil.trimEventHandler(treeComp.getOnnodeselect());
			treeViewEmitter.setOnnodeselect(onnodeselect);
			String onnodeunselect = JSUtil.trimEventHandler(treeComp.getOnnodeunselect());
			treeViewEmitter.setOnnodeunselect(onnodeunselect);
			String onnodedrop = JSUtil.trimEventHandler(treeComp.getOnnodedrop());
			treeViewEmitter.setOnnodedrop(onnodedrop);
			String onnodedragenterover = JSUtil.trimEventHandler(treeComp.getOnnodedragenterover());
			treeViewEmitter.setOnnodedragenterover(onnodedragenterover);
			
			PageContext pageContext = ODCContextHelper.getODCPageContext(context);
			
			
			treeViewEmitter.setIsPageData(isPageDataBinding);
			//TODO
			boolean reinit = false;
			URLRewriter urlRewriter = Utils.getURLRewriter(pageContext, context);
			if (urlRewriter == null)
				reinit = true;
						
			if (isPageDataBinding) {
			
				
				// I don't think this gets called by the original tree as it assumed alot of 
				// the initialization was taken care of by the client data which it depended on
				// since we are removing this dependency include it here.
					//////////////////need to check if URLRewriter exists when not using client data 
				//TODO		
				//URLRewriter urlRewriter = (URLRewriter) pageContext.getContextVariable("URL_REWRITER");
				if (reinit) {
					//URLRewriterFactory factory = URLRewriterFactoryCreator.getURLRewriterFactory();
					//urlRewriter = factory.createURLRewriter(context);
					
					//TODO
					//urlRewriter = new JSFURLRewriter(context.getExternalContext());
					//pageContext.addContextVariable("URL_REWRITER", urlRewriter);
					
					//pageContext.addContextVariable("URL_PREFIX", URLPrinter._prefix);
					//pageContext.addContextVariable("URL_POSTFIX", URLPrinter._postfix);
					pageContext.addContextVariable(
						"DEBUG_MODE",
						Config.getInteger(Config.PROP_CLIENT_DEBUG_MODE) == 1 ? "YES" : "NO");
					Locale localeObj = context.getViewRoot().getLocale();
					String localeStr = null;
					if (localeObj != null) {
						localeStr = localeObj.toString();
	
					} else {
						localeStr = Config.getString(Config.PROP_CLIENT_LOCALE);
	
					}
					//((UITabbedPanel)component).setLocale(localeStr);
					pageContext.addContextVariable("CLIENT_LOCALE", localeStr);
					final int logLevel = Config.getInteger(Config.PROP_CLIENT_LOG_LEVEL);
					String logLevelString = String.valueOf(logLevel);
					pageContext.addContextVariable("LOG_LEVEL", logLevelString);
				}
			
				/////////////////////////////////////
				/// Print out all the js includes and stuff.
				//	The tree when using the script collector is within a script block
				// so this must be ended before includes are output
				writer.endElement("script"); 
				InitializationUtil.printIncludes(writer, context, pageContext);
					
				writer.startElement("script type=\"text/javascript\"", component);
			}
			
			
			
			treeViewEmitter.Export(new PrintWriter(writer), pageContext); 
		} catch (Exception e) {
			e.printStackTrace();
			Streamer.debug.Header().println(
				"Exception occurred during tree code export in encodeEnd() of TreeRenderer.java");
			throw new IOException();
		}
		String treeName = null;
	
		treeName = StringUtil.encodeString(treeViewEmitter.CONTROL_VAR + treeViewEmitter.getExportID());
	//	writer.startElement("script type=\"text/javascript\"", component);
		JSUtil.registerControl(context, component, treeName);
	//	writer.endElement("script");
		String stateString = ((UIBrowserFramework) component).getStateString();
		if (!(stateString == null || stateString.equals(""))) {
	//		writer.startElement("script type=\"text/javascript\"", component);
			writer.write(treeName + ".restoreUIState(\"" + stateString + "\");");
//			writer.endElement("script");
		}
		
	//	writer.startElement("script type=\"text/javascript\"", component);
		return;
	}
	
}
