/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.taglib;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.bf.component.UIDataGridCol;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class DataGridColTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(DataGridColTag.class);

    //
    // Instance Variables
    //

    private java.lang.String attributeName;

    private java.lang.String alignment;
    private java.lang.String colHead;
    private java.lang.String readOnly;
    private java.lang.String underline;
    private java.lang.String width;

    //
    // Setter Methods
    //

    public void setAttributeName(java.lang.String attributeName) {
        this.attributeName = attributeName;
    }

    public void setAlignment(java.lang.String alignment) {
        this.alignment = alignment;
    }

    public void setColHead(java.lang.String colHead) {
        this.colHead = colHead;
    }

    public void setReadOnly(java.lang.String readOnly) {
        this.readOnly = readOnly;
    }

    public void setUnderline(java.lang.String underline) {
        this.underline = underline;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "DataGridCol";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.bf.HtmlDataGridCol"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIDataGridCol datagridcolComponent = (UIDataGridCol)component;

        if (attributeName != null) {
            if (isValueReference(attributeName)) {
                ValueBinding vb = TagUtil.getValueBinding(attributeName);
                datagridcolComponent.setValueBinding("attributeName", vb); //$NON-NLS-1$
            } else {
                datagridcolComponent.setAttributeName(attributeName);
            }
        }
        if (alignment != null) {
            if (isValueReference(alignment)) {
                ValueBinding vb = TagUtil.getValueBinding(alignment);
                datagridcolComponent.setValueBinding("alignment", vb); //$NON-NLS-1$
            } else {
                datagridcolComponent.getAttributes().put("alignment", alignment); //$NON-NLS-1$
            }
        }
        if (colHead != null) {
            if (isValueReference(colHead)) {
                ValueBinding vb = TagUtil.getValueBinding(colHead);
                datagridcolComponent.setValueBinding("colHead", vb); //$NON-NLS-1$
            } else {
                datagridcolComponent.getAttributes().put("colHead", colHead); //$NON-NLS-1$
            }
        }
        if (readOnly != null) {
            if (isValueReference(readOnly)) {
                ValueBinding vb = TagUtil.getValueBinding(readOnly);
                datagridcolComponent.setValueBinding("readOnly", vb); //$NON-NLS-1$
            } else {
                boolean _readOnly = new Boolean(readOnly).booleanValue();
                datagridcolComponent.getAttributes().put("readOnly", _readOnly ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (underline != null) {
            if (isValueReference(underline)) {
                ValueBinding vb = TagUtil.getValueBinding(underline);
                datagridcolComponent.setValueBinding("underline", vb); //$NON-NLS-1$
            } else {
                boolean _underline = new Boolean(underline).booleanValue();
                datagridcolComponent.getAttributes().put("underline", _underline ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                datagridcolComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                datagridcolComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
