/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.taglib;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.bf.component.UIDataGrid;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class DataGridTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(DataGridTag.class);

    //
    // Instance Variables
    //

    private java.lang.String onfilter;
    private java.lang.String onhighlight;
    private java.lang.String onpage;
    private java.lang.String onrowadd;
    private java.lang.String onrowremove;
    private java.lang.String onselect;
    private java.lang.String onselectall;
    private java.lang.String onsort;
    private java.lang.String onunselect;
    private java.lang.String onunselectall;

    private java.lang.String allowColumnHide;
    private java.lang.String allowRowAddAndDelete;
    private java.lang.String multiSelection;
    private java.lang.String navBarPosition;
    private java.lang.String pageSize;
    private java.lang.String rowFilter;
    private java.lang.String scrollSize;
    private java.lang.String selectionColAlignment;
    private java.lang.String selectionColName;
    private java.lang.String selectionColWidth;
    private java.lang.String showRowIndex;
    private java.lang.String showSelectionColumn;
    private java.lang.String styleClass;
    private java.lang.String width;

    //
    // Setter Methods
    //

    public void setOnfilter(java.lang.String onfilter) {
        this.onfilter = onfilter;
    }

    public void setOnhighlight(java.lang.String onhighlight) {
        this.onhighlight = onhighlight;
    }

    public void setOnpage(java.lang.String onpage) {
        this.onpage = onpage;
    }

    public void setOnrowadd(java.lang.String onrowadd) {
        this.onrowadd = onrowadd;
    }

    public void setOnrowremove(java.lang.String onrowremove) {
        this.onrowremove = onrowremove;
    }

    public void setOnselect(java.lang.String onselect) {
        this.onselect = onselect;
    }

    public void setOnselectall(java.lang.String onselectall) {
        this.onselectall = onselectall;
    }

    public void setOnsort(java.lang.String onsort) {
        this.onsort = onsort;
    }

    public void setOnunselect(java.lang.String onunselect) {
        this.onunselect = onunselect;
    }

    public void setOnunselectall(java.lang.String onunselectall) {
        this.onunselectall = onunselectall;
    }

    public void setAllowColumnHide(java.lang.String allowColumnHide) {
        this.allowColumnHide = allowColumnHide;
    }

    public void setAllowRowAddAndDelete(java.lang.String allowRowAddAndDelete) {
        this.allowRowAddAndDelete = allowRowAddAndDelete;
    }

    public void setMultiSelection(java.lang.String multiSelection) {
        this.multiSelection = multiSelection;
    }

    public void setNavBarPosition(java.lang.String navBarPosition) {
        this.navBarPosition = navBarPosition;
    }

    public void setPageSize(java.lang.String pageSize) {
        this.pageSize = pageSize;
    }

    public void setRowFilter(java.lang.String rowFilter) {
        this.rowFilter = rowFilter;
    }

    public void setScrollSize(java.lang.String scrollSize) {
        this.scrollSize = scrollSize;
    }

    public void setSelectionColAlignment(java.lang.String selectionColAlignment) {
        this.selectionColAlignment = selectionColAlignment;
    }

    public void setSelectionColName(java.lang.String selectionColName) {
        this.selectionColName = selectionColName;
    }

    public void setSelectionColWidth(java.lang.String selectionColWidth) {
        this.selectionColWidth = selectionColWidth;
    }

    public void setShowRowIndex(java.lang.String showRowIndex) {
        this.showRowIndex = showRowIndex;
    }

    public void setShowSelectionColumn(java.lang.String showSelectionColumn) {
        this.showSelectionColumn = showSelectionColumn;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "DataGrid";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.bf.HtmlDataGrid"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIDataGrid datagridComponent = (UIDataGrid)component;

        if (onfilter != null) {
            if (isValueReference(onfilter)) {
                ValueBinding vb = TagUtil.getValueBinding(onfilter);
                datagridComponent.setValueBinding("onfilter", vb); //$NON-NLS-1$
            } else {
                datagridComponent.setOnfilter(onfilter);
            }
        }
        if (onhighlight != null) {
            if (isValueReference(onhighlight)) {
                ValueBinding vb = TagUtil.getValueBinding(onhighlight);
                datagridComponent.setValueBinding("onhighlight", vb); //$NON-NLS-1$
            } else {
                datagridComponent.setOnhighlight(onhighlight);
            }
        }
        if (onpage != null) {
            if (isValueReference(onpage)) {
                ValueBinding vb = TagUtil.getValueBinding(onpage);
                datagridComponent.setValueBinding("onpage", vb); //$NON-NLS-1$
            } else {
                datagridComponent.setOnpage(onpage);
            }
        }
        if (onrowadd != null) {
            if (isValueReference(onrowadd)) {
                ValueBinding vb = TagUtil.getValueBinding(onrowadd);
                datagridComponent.setValueBinding("onrowadd", vb); //$NON-NLS-1$
            } else {
                datagridComponent.setOnrowadd(onrowadd);
            }
        }
        if (onrowremove != null) {
            if (isValueReference(onrowremove)) {
                ValueBinding vb = TagUtil.getValueBinding(onrowremove);
                datagridComponent.setValueBinding("onrowremove", vb); //$NON-NLS-1$
            } else {
                datagridComponent.setOnrowremove(onrowremove);
            }
        }
        if (onselect != null) {
            if (isValueReference(onselect)) {
                ValueBinding vb = TagUtil.getValueBinding(onselect);
                datagridComponent.setValueBinding("onselect", vb); //$NON-NLS-1$
            } else {
                datagridComponent.setOnselect(onselect);
            }
        }
        if (onselectall != null) {
            if (isValueReference(onselectall)) {
                ValueBinding vb = TagUtil.getValueBinding(onselectall);
                datagridComponent.setValueBinding("onselectall", vb); //$NON-NLS-1$
            } else {
                datagridComponent.setOnselectall(onselectall);
            }
        }
        if (onsort != null) {
            if (isValueReference(onsort)) {
                ValueBinding vb = TagUtil.getValueBinding(onsort);
                datagridComponent.setValueBinding("onsort", vb); //$NON-NLS-1$
            } else {
                datagridComponent.setOnsort(onsort);
            }
        }
        if (onunselect != null) {
            if (isValueReference(onunselect)) {
                ValueBinding vb = TagUtil.getValueBinding(onunselect);
                datagridComponent.setValueBinding("onunselect", vb); //$NON-NLS-1$
            } else {
                datagridComponent.setOnunselect(onunselect);
            }
        }
        if (onunselectall != null) {
            if (isValueReference(onunselectall)) {
                ValueBinding vb = TagUtil.getValueBinding(onunselectall);
                datagridComponent.setValueBinding("onunselectall", vb); //$NON-NLS-1$
            } else {
                datagridComponent.setOnunselectall(onunselectall);
            }
        }
        if (allowColumnHide != null) {
            if (isValueReference(allowColumnHide)) {
                ValueBinding vb = TagUtil.getValueBinding(allowColumnHide);
                datagridComponent.setValueBinding("allowColumnHide", vb); //$NON-NLS-1$
            } else {
                boolean _allowColumnHide = new Boolean(allowColumnHide).booleanValue();
                datagridComponent.getAttributes().put("allowColumnHide", _allowColumnHide ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (allowRowAddAndDelete != null) {
            if (isValueReference(allowRowAddAndDelete)) {
                ValueBinding vb = TagUtil.getValueBinding(allowRowAddAndDelete);
                datagridComponent.setValueBinding("allowRowAddAndDelete", vb); //$NON-NLS-1$
            } else {
                boolean _allowRowAddAndDelete = new Boolean(allowRowAddAndDelete).booleanValue();
                datagridComponent.getAttributes().put("allowRowAddAndDelete", _allowRowAddAndDelete ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (multiSelection != null) {
            if (isValueReference(multiSelection)) {
                ValueBinding vb = TagUtil.getValueBinding(multiSelection);
                datagridComponent.setValueBinding("multiSelection", vb); //$NON-NLS-1$
            } else {
                boolean _multiSelection = new Boolean(multiSelection).booleanValue();
                datagridComponent.getAttributes().put("multiSelection", _multiSelection ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (navBarPosition != null) {
            if (isValueReference(navBarPosition)) {
                ValueBinding vb = TagUtil.getValueBinding(navBarPosition);
                datagridComponent.setValueBinding("navBarPosition", vb); //$NON-NLS-1$
            } else {
                int _navBarPosition = new Integer(navBarPosition).intValue();
                if (_navBarPosition != Integer.MIN_VALUE) {
                    datagridComponent.getAttributes().put("navBarPosition", new Integer(_navBarPosition)); //$NON-NLS-1$
                }
            }
        }
        if (pageSize != null) {
            if (isValueReference(pageSize)) {
                ValueBinding vb = TagUtil.getValueBinding(pageSize);
                datagridComponent.setValueBinding("pageSize", vb); //$NON-NLS-1$
            } else {
                int _pageSize = new Integer(pageSize).intValue();
                if (_pageSize != Integer.MIN_VALUE) {
                    datagridComponent.getAttributes().put("pageSize", new Integer(_pageSize)); //$NON-NLS-1$
                }
            }
        }
        if (rowFilter != null) {
            if (isValueReference(rowFilter)) {
                ValueBinding vb = TagUtil.getValueBinding(rowFilter);
                datagridComponent.setValueBinding("rowFilter", vb); //$NON-NLS-1$
            } else {
                datagridComponent.getAttributes().put("rowFilter", rowFilter); //$NON-NLS-1$
            }
        }
        if (scrollSize != null) {
            if (isValueReference(scrollSize)) {
                ValueBinding vb = TagUtil.getValueBinding(scrollSize);
                datagridComponent.setValueBinding("scrollSize", vb); //$NON-NLS-1$
            } else {
                datagridComponent.getAttributes().put("scrollSize", scrollSize); //$NON-NLS-1$
            }
        }
        if (selectionColAlignment != null) {
            if (isValueReference(selectionColAlignment)) {
                ValueBinding vb = TagUtil.getValueBinding(selectionColAlignment);
                datagridComponent.setValueBinding("selectionColAlignment", vb); //$NON-NLS-1$
            } else {
                datagridComponent.getAttributes().put("selectionColAlignment", selectionColAlignment); //$NON-NLS-1$
            }
        }
        if (selectionColName != null) {
            if (isValueReference(selectionColName)) {
                ValueBinding vb = TagUtil.getValueBinding(selectionColName);
                datagridComponent.setValueBinding("selectionColName", vb); //$NON-NLS-1$
            } else {
                datagridComponent.getAttributes().put("selectionColName", selectionColName); //$NON-NLS-1$
            }
        }
        if (selectionColWidth != null) {
            if (isValueReference(selectionColWidth)) {
                ValueBinding vb = TagUtil.getValueBinding(selectionColWidth);
                datagridComponent.setValueBinding("selectionColWidth", vb); //$NON-NLS-1$
            } else {
                datagridComponent.getAttributes().put("selectionColWidth", selectionColWidth); //$NON-NLS-1$
            }
        }
        if (showRowIndex != null) {
            if (isValueReference(showRowIndex)) {
                ValueBinding vb = TagUtil.getValueBinding(showRowIndex);
                datagridComponent.setValueBinding("showRowIndex", vb); //$NON-NLS-1$
            } else {
                boolean _showRowIndex = new Boolean(showRowIndex).booleanValue();
                datagridComponent.getAttributes().put("showRowIndex", _showRowIndex ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (showSelectionColumn != null) {
            if (isValueReference(showSelectionColumn)) {
                ValueBinding vb = TagUtil.getValueBinding(showSelectionColumn);
                datagridComponent.setValueBinding("showSelectionColumn", vb); //$NON-NLS-1$
            } else {
                boolean _showSelectionColumn = new Boolean(showSelectionColumn).booleanValue();
                datagridComponent.getAttributes().put("showSelectionColumn", _showSelectionColumn ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                datagridComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                datagridComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                datagridComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                datagridComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
