/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.taglib;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.bf.component.UIGraphDraw;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class GraphDrawTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(GraphDrawTag.class);

    //
    // Instance Variables
    //

    private java.lang.String value;

    private java.lang.String bar;
    private java.lang.String firstChart;
    private java.lang.String height;
    private java.lang.String line;
    private java.lang.String pie;
    private java.lang.String showHGridlinesBar;
    private java.lang.String showHGridlinesLine;
    private java.lang.String showLabel;
    private java.lang.String showLegend;
    private java.lang.String showVGridlinesLine;
    private java.lang.String splitYAxis;
    private java.lang.String styleClass;
    private java.lang.String title;
    private java.lang.String width;
    private java.lang.String xaxisTitle;
    private java.lang.String yaxisDivisions;
    private java.lang.String yaxisTitle;

    //
    // Setter Methods
    //

    public void setValue(java.lang.String value) {
        this.value = value;
    }

    public void setBar(java.lang.String bar) {
        this.bar = bar;
    }

    public void setFirstChart(java.lang.String firstChart) {
        this.firstChart = firstChart;
    }

    public void setHeight(java.lang.String height) {
        this.height = height;
    }

    public void setLine(java.lang.String line) {
        this.line = line;
    }

    public void setPie(java.lang.String pie) {
        this.pie = pie;
    }

    public void setShowHGridlinesBar(java.lang.String showHGridlinesBar) {
        this.showHGridlinesBar = showHGridlinesBar;
    }

    public void setShowHGridlinesLine(java.lang.String showHGridlinesLine) {
        this.showHGridlinesLine = showHGridlinesLine;
    }

    public void setShowLabel(java.lang.String showLabel) {
        this.showLabel = showLabel;
    }

    public void setShowLegend(java.lang.String showLegend) {
        this.showLegend = showLegend;
    }

    public void setShowVGridlinesLine(java.lang.String showVGridlinesLine) {
        this.showVGridlinesLine = showVGridlinesLine;
    }

    public void setSplitYAxis(java.lang.String splitYAxis) {
        this.splitYAxis = splitYAxis;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setTitle(java.lang.String title) {
        this.title = title;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }

    public void setXaxisTitle(java.lang.String xaxisTitle) {
        this.xaxisTitle = xaxisTitle;
    }

    public void setYaxisDivisions(java.lang.String yaxisDivisions) {
        this.yaxisDivisions = yaxisDivisions;
    }

    public void setYaxisTitle(java.lang.String yaxisTitle) {
        this.yaxisTitle = yaxisTitle;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "GraphDraw";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.bf.HtmlGraphDraw"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UIGraphDraw graphdrawComponent = (UIGraphDraw)component;

        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                graphdrawComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                graphdrawComponent.setValue(value);
            }
        }
        if (bar != null) {
            if (isValueReference(bar)) {
                ValueBinding vb = TagUtil.getValueBinding(bar);
                graphdrawComponent.setValueBinding("bar", vb); //$NON-NLS-1$
            } else {
                boolean _bar = new Boolean(bar).booleanValue();
                graphdrawComponent.getAttributes().put("bar", _bar ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (firstChart != null) {
            if (isValueReference(firstChart)) {
                ValueBinding vb = TagUtil.getValueBinding(firstChart);
                graphdrawComponent.setValueBinding("firstChart", vb); //$NON-NLS-1$
            } else {
                graphdrawComponent.getAttributes().put("firstChart", firstChart); //$NON-NLS-1$
            }
        }
        if (height != null) {
            if (isValueReference(height)) {
                ValueBinding vb = TagUtil.getValueBinding(height);
                graphdrawComponent.setValueBinding("height", vb); //$NON-NLS-1$
            } else {
                graphdrawComponent.getAttributes().put("height", height); //$NON-NLS-1$
            }
        }
        if (line != null) {
            if (isValueReference(line)) {
                ValueBinding vb = TagUtil.getValueBinding(line);
                graphdrawComponent.setValueBinding("line", vb); //$NON-NLS-1$
            } else {
                boolean _line = new Boolean(line).booleanValue();
                graphdrawComponent.getAttributes().put("line", _line ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (pie != null) {
            if (isValueReference(pie)) {
                ValueBinding vb = TagUtil.getValueBinding(pie);
                graphdrawComponent.setValueBinding("pie", vb); //$NON-NLS-1$
            } else {
                boolean _pie = new Boolean(pie).booleanValue();
                graphdrawComponent.getAttributes().put("pie", _pie ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (showHGridlinesBar != null) {
            if (isValueReference(showHGridlinesBar)) {
                ValueBinding vb = TagUtil.getValueBinding(showHGridlinesBar);
                graphdrawComponent.setValueBinding("showHGridlinesBar", vb); //$NON-NLS-1$
            } else {
                boolean _showHGridlinesBar = new Boolean(showHGridlinesBar).booleanValue();
                graphdrawComponent.getAttributes().put("showHGridlinesBar", _showHGridlinesBar ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (showHGridlinesLine != null) {
            if (isValueReference(showHGridlinesLine)) {
                ValueBinding vb = TagUtil.getValueBinding(showHGridlinesLine);
                graphdrawComponent.setValueBinding("showHGridlinesLine", vb); //$NON-NLS-1$
            } else {
                boolean _showHGridlinesLine = new Boolean(showHGridlinesLine).booleanValue();
                graphdrawComponent.getAttributes().put("showHGridlinesLine", _showHGridlinesLine ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (showLabel != null) {
            if (isValueReference(showLabel)) {
                ValueBinding vb = TagUtil.getValueBinding(showLabel);
                graphdrawComponent.setValueBinding("showLabel", vb); //$NON-NLS-1$
            } else {
                boolean _showLabel = new Boolean(showLabel).booleanValue();
                graphdrawComponent.getAttributes().put("showLabel", _showLabel ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (showLegend != null) {
            if (isValueReference(showLegend)) {
                ValueBinding vb = TagUtil.getValueBinding(showLegend);
                graphdrawComponent.setValueBinding("showLegend", vb); //$NON-NLS-1$
            } else {
                boolean _showLegend = new Boolean(showLegend).booleanValue();
                graphdrawComponent.getAttributes().put("showLegend", _showLegend ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (showVGridlinesLine != null) {
            if (isValueReference(showVGridlinesLine)) {
                ValueBinding vb = TagUtil.getValueBinding(showVGridlinesLine);
                graphdrawComponent.setValueBinding("showVGridlinesLine", vb); //$NON-NLS-1$
            } else {
                boolean _showVGridlinesLine = new Boolean(showVGridlinesLine).booleanValue();
                graphdrawComponent.getAttributes().put("showVGridlinesLine", _showVGridlinesLine ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (splitYAxis != null) {
            if (isValueReference(splitYAxis)) {
                ValueBinding vb = TagUtil.getValueBinding(splitYAxis);
                graphdrawComponent.setValueBinding("splitYAxis", vb); //$NON-NLS-1$
            } else {
                boolean _splitYAxis = new Boolean(splitYAxis).booleanValue();
                graphdrawComponent.getAttributes().put("splitYAxis", _splitYAxis ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                graphdrawComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                graphdrawComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (title != null) {
            if (isValueReference(title)) {
                ValueBinding vb = TagUtil.getValueBinding(title);
                graphdrawComponent.setValueBinding("title", vb); //$NON-NLS-1$
            } else {
                graphdrawComponent.getAttributes().put("title", title); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                graphdrawComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                graphdrawComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
        if (xaxisTitle != null) {
            if (isValueReference(xaxisTitle)) {
                ValueBinding vb = TagUtil.getValueBinding(xaxisTitle);
                graphdrawComponent.setValueBinding("xaxisTitle", vb); //$NON-NLS-1$
            } else {
                graphdrawComponent.getAttributes().put("xaxisTitle", xaxisTitle); //$NON-NLS-1$
            }
        }
        if (yaxisDivisions != null) {
            if (isValueReference(yaxisDivisions)) {
                ValueBinding vb = TagUtil.getValueBinding(yaxisDivisions);
                graphdrawComponent.setValueBinding("yaxisDivisions", vb); //$NON-NLS-1$
            } else {
                graphdrawComponent.getAttributes().put("yaxisDivisions", yaxisDivisions); //$NON-NLS-1$
            }
        }
        if (yaxisTitle != null) {
            if (isValueReference(yaxisTitle)) {
                ValueBinding vb = TagUtil.getValueBinding(yaxisTitle);
                graphdrawComponent.setValueBinding("yaxisTitle", vb); //$NON-NLS-1$
            } else {
                graphdrawComponent.getAttributes().put("yaxisTitle", yaxisTitle); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
