/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.taglib;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.bf.component.UITabbedPanel;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class TabbedPanelTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(TabbedPanelTag.class);

    //
    // Instance Variables
    //

    private java.lang.String oncancel;
    private java.lang.String onfinish;
    private java.lang.String oninitialpanelshow;
    private java.lang.String onpanelenter;
    private java.lang.String onpanelexit;

    private java.lang.String height;
    private java.lang.String initialPanelId;
    private java.lang.String layout;
    private java.lang.String numOfTabs;
    private java.lang.String showBackNextButton;
    private java.lang.String showTabs;
    private java.lang.String slantActiveLeft;
    private java.lang.String slantActiveRight;
    private java.lang.String slantInactiveLeft;
    private java.lang.String slantInactiveRight;
    private java.lang.String styleClass;
    private java.lang.String variableTabLength;
    private java.lang.String width;

    //
    // Setter Methods
    //

    public void setOncancel(java.lang.String oncancel) {
        this.oncancel = oncancel;
    }

    public void setOnfinish(java.lang.String onfinish) {
        this.onfinish = onfinish;
    }

    public void setOninitialpanelshow(java.lang.String oninitialpanelshow) {
        this.oninitialpanelshow = oninitialpanelshow;
    }

    public void setOnpanelenter(java.lang.String onpanelenter) {
        this.onpanelenter = onpanelenter;
    }

    public void setOnpanelexit(java.lang.String onpanelexit) {
        this.onpanelexit = onpanelexit;
    }

    public void setHeight(java.lang.String height) {
        this.height = height;
    }

    public void setInitialPanelId(java.lang.String initialPanelId) {
        this.initialPanelId = initialPanelId;
    }

    public void setLayout(java.lang.String layout) {
        this.layout = layout;
    }

    public void setNumOfTabs(java.lang.String numOfTabs) {
        this.numOfTabs = numOfTabs;
    }

    public void setShowBackNextButton(java.lang.String showBackNextButton) {
        this.showBackNextButton = showBackNextButton;
    }

    public void setShowTabs(java.lang.String showTabs) {
        this.showTabs = showTabs;
    }

    public void setSlantActiveLeft(java.lang.String slantActiveLeft) {
        this.slantActiveLeft = slantActiveLeft;
    }

    public void setSlantActiveRight(java.lang.String slantActiveRight) {
        this.slantActiveRight = slantActiveRight;
    }

    public void setSlantInactiveLeft(java.lang.String slantInactiveLeft) {
        this.slantInactiveLeft = slantInactiveLeft;
    }

    public void setSlantInactiveRight(java.lang.String slantInactiveRight) {
        this.slantInactiveRight = slantInactiveRight;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setVariableTabLength(java.lang.String variableTabLength) {
        this.variableTabLength = variableTabLength;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "TabbedPanel";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.bf.HtmlTabbedPanel"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UITabbedPanel tabbedpanelComponent = (UITabbedPanel)component;

        if (oncancel != null) {
            if (isValueReference(oncancel)) {
                ValueBinding vb = TagUtil.getValueBinding(oncancel);
                tabbedpanelComponent.setValueBinding("oncancel", vb); //$NON-NLS-1$
            } else {
                tabbedpanelComponent.setOncancel(oncancel);
            }
        }
        if (onfinish != null) {
            if (isValueReference(onfinish)) {
                ValueBinding vb = TagUtil.getValueBinding(onfinish);
                tabbedpanelComponent.setValueBinding("onfinish", vb); //$NON-NLS-1$
            } else {
                tabbedpanelComponent.setOnfinish(onfinish);
            }
        }
        if (oninitialpanelshow != null) {
            if (isValueReference(oninitialpanelshow)) {
                ValueBinding vb = TagUtil.getValueBinding(oninitialpanelshow);
                tabbedpanelComponent.setValueBinding("oninitialpanelshow", vb); //$NON-NLS-1$
            } else {
                tabbedpanelComponent.setOninitialpanelshow(oninitialpanelshow);
            }
        }
        if (onpanelenter != null) {
            if (isValueReference(onpanelenter)) {
                ValueBinding vb = TagUtil.getValueBinding(onpanelenter);
                tabbedpanelComponent.setValueBinding("onpanelenter", vb); //$NON-NLS-1$
            } else {
                tabbedpanelComponent.setOnpanelenter(onpanelenter);
            }
        }
        if (onpanelexit != null) {
            if (isValueReference(onpanelexit)) {
                ValueBinding vb = TagUtil.getValueBinding(onpanelexit);
                tabbedpanelComponent.setValueBinding("onpanelexit", vb); //$NON-NLS-1$
            } else {
                tabbedpanelComponent.setOnpanelexit(onpanelexit);
            }
        }
        if (height != null) {
            if (isValueReference(height)) {
                ValueBinding vb = TagUtil.getValueBinding(height);
                tabbedpanelComponent.setValueBinding("height", vb); //$NON-NLS-1$
            } else {
                tabbedpanelComponent.getAttributes().put("height", height); //$NON-NLS-1$
            }
        }
        if (initialPanelId != null) {
            if (isValueReference(initialPanelId)) {
                ValueBinding vb = TagUtil.getValueBinding(initialPanelId);
                tabbedpanelComponent.setValueBinding("initialPanelId", vb); //$NON-NLS-1$
            } else {
                tabbedpanelComponent.getAttributes().put("initialPanelId", initialPanelId); //$NON-NLS-1$
            }
        }
        if (layout != null) {
            if (isValueReference(layout)) {
                ValueBinding vb = TagUtil.getValueBinding(layout);
                tabbedpanelComponent.setValueBinding("layout", vb); //$NON-NLS-1$
            } else {
                tabbedpanelComponent.getAttributes().put("layout", layout); //$NON-NLS-1$
            }
        }
        if (numOfTabs != null) {
            if (isValueReference(numOfTabs)) {
                ValueBinding vb = TagUtil.getValueBinding(numOfTabs);
                tabbedpanelComponent.setValueBinding("numOfTabs", vb); //$NON-NLS-1$
            } else {
                int _numOfTabs = new Integer(numOfTabs).intValue();
                if (_numOfTabs != Integer.MIN_VALUE) {
                    tabbedpanelComponent.getAttributes().put("numOfTabs", new Integer(_numOfTabs)); //$NON-NLS-1$
                }
            }
        }
        if (showBackNextButton != null) {
            if (isValueReference(showBackNextButton)) {
                ValueBinding vb = TagUtil.getValueBinding(showBackNextButton);
                tabbedpanelComponent.setValueBinding("showBackNextButton", vb); //$NON-NLS-1$
            } else {
                boolean _showBackNextButton = new Boolean(showBackNextButton).booleanValue();
                tabbedpanelComponent.getAttributes().put("showBackNextButton", _showBackNextButton ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (showTabs != null) {
            if (isValueReference(showTabs)) {
                ValueBinding vb = TagUtil.getValueBinding(showTabs);
                tabbedpanelComponent.setValueBinding("showTabs", vb); //$NON-NLS-1$
            } else {
                boolean _showTabs = new Boolean(showTabs).booleanValue();
                tabbedpanelComponent.getAttributes().put("showTabs", _showTabs ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (slantActiveLeft != null) {
            if (isValueReference(slantActiveLeft)) {
                ValueBinding vb = TagUtil.getValueBinding(slantActiveLeft);
                tabbedpanelComponent.setValueBinding("slantActiveLeft", vb); //$NON-NLS-1$
            } else {
                int _slantActiveLeft = new Integer(slantActiveLeft).intValue();
                if (_slantActiveLeft != Integer.MIN_VALUE) {
                    tabbedpanelComponent.getAttributes().put("slantActiveLeft", new Integer(_slantActiveLeft)); //$NON-NLS-1$
                }
            }
        }
        if (slantActiveRight != null) {
            if (isValueReference(slantActiveRight)) {
                ValueBinding vb = TagUtil.getValueBinding(slantActiveRight);
                tabbedpanelComponent.setValueBinding("slantActiveRight", vb); //$NON-NLS-1$
            } else {
                int _slantActiveRight = new Integer(slantActiveRight).intValue();
                if (_slantActiveRight != Integer.MIN_VALUE) {
                    tabbedpanelComponent.getAttributes().put("slantActiveRight", new Integer(_slantActiveRight)); //$NON-NLS-1$
                }
            }
        }
        if (slantInactiveLeft != null) {
            if (isValueReference(slantInactiveLeft)) {
                ValueBinding vb = TagUtil.getValueBinding(slantInactiveLeft);
                tabbedpanelComponent.setValueBinding("slantInactiveLeft", vb); //$NON-NLS-1$
            } else {
                int _slantInactiveLeft = new Integer(slantInactiveLeft).intValue();
                if (_slantInactiveLeft != Integer.MIN_VALUE) {
                    tabbedpanelComponent.getAttributes().put("slantInactiveLeft", new Integer(_slantInactiveLeft)); //$NON-NLS-1$
                }
            }
        }
        if (slantInactiveRight != null) {
            if (isValueReference(slantInactiveRight)) {
                ValueBinding vb = TagUtil.getValueBinding(slantInactiveRight);
                tabbedpanelComponent.setValueBinding("slantInactiveRight", vb); //$NON-NLS-1$
            } else {
                int _slantInactiveRight = new Integer(slantInactiveRight).intValue();
                if (_slantInactiveRight != Integer.MIN_VALUE) {
                    tabbedpanelComponent.getAttributes().put("slantInactiveRight", new Integer(_slantInactiveRight)); //$NON-NLS-1$
                }
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                tabbedpanelComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                tabbedpanelComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (variableTabLength != null) {
            if (isValueReference(variableTabLength)) {
                ValueBinding vb = TagUtil.getValueBinding(variableTabLength);
                tabbedpanelComponent.setValueBinding("variableTabLength", vb); //$NON-NLS-1$
            } else {
                boolean _variableTabLength = new Boolean(variableTabLength).booleanValue();
                tabbedpanelComponent.getAttributes().put("variableTabLength", _variableTabLength ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                tabbedpanelComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                tabbedpanelComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
