/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.taglib;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.bf.component.UITreeNodeAttr;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class TreeNodeAttrTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(TreeNodeAttrTag.class);

    //
    // Instance Variables
    //

    private java.lang.String nodeLabel;
    private java.lang.String value;

    private java.lang.String attributeName;
    private java.lang.String childValue;
    private java.lang.String className;
    private java.lang.String closeIcon;
    private java.lang.String enableDrop;
    private java.lang.String oncollapse;
    private java.lang.String ondragenterover;
    private java.lang.String onexpand;
    private java.lang.String onhighlight;
    private java.lang.String onselect;
    private java.lang.String onunselect;
    private java.lang.String openIcon;
    private java.lang.String referenceName;
    private java.lang.String showSystemIcon;
    private java.lang.String _var;

    //
    // Setter Methods
    //

    public void setNodeLabel(java.lang.String nodeLabel) {
        this.nodeLabel = nodeLabel;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }

    public void setAttributeName(java.lang.String attributeName) {
        this.attributeName = attributeName;
    }

    public void setChildValue(java.lang.String childValue) {
        this.childValue = childValue;
    }

    public void setClassName(java.lang.String className) {
        this.className = className;
    }

    public void setCloseIcon(java.lang.String closeIcon) {
        this.closeIcon = closeIcon;
    }

    public void setEnableDrop(java.lang.String enableDrop) {
        this.enableDrop = enableDrop;
    }

    public void setOncollapse(java.lang.String oncollapse) {
        this.oncollapse = oncollapse;
    }

    public void setOndragenterover(java.lang.String ondragenterover) {
        this.ondragenterover = ondragenterover;
    }

    public void setOnexpand(java.lang.String onexpand) {
        this.onexpand = onexpand;
    }

    public void setOnhighlight(java.lang.String onhighlight) {
        this.onhighlight = onhighlight;
    }

    public void setOnselect(java.lang.String onselect) {
        this.onselect = onselect;
    }

    public void setOnunselect(java.lang.String onunselect) {
        this.onunselect = onunselect;
    }

    public void setOpenIcon(java.lang.String openIcon) {
        this.openIcon = openIcon;
    }

    public void setReferenceName(java.lang.String referenceName) {
        this.referenceName = referenceName;
    }

    public void setShowSystemIcon(java.lang.String showSystemIcon) {
        this.showSystemIcon = showSystemIcon;
    }

    public void setVar(java.lang.String _var) {
        this._var = _var;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "TreeNodeAttr";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.bf.HtmlTreeNodeAttr"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UITreeNodeAttr treenodeattrComponent = (UITreeNodeAttr)component;

        if (nodeLabel != null) {
            if (isValueReference(nodeLabel)) {
                ValueBinding vb = TagUtil.getValueBinding(nodeLabel);
                treenodeattrComponent.setValueBinding("nodeLabel", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.setNodeLabel(nodeLabel);
            }
        }
        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                treenodeattrComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.setValue(value);
            }
        }
        if (attributeName != null) {
            if (isValueReference(attributeName)) {
                ValueBinding vb = TagUtil.getValueBinding(attributeName);
                treenodeattrComponent.setValueBinding("attributeName", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("attributeName", attributeName); //$NON-NLS-1$
            }
        }
        if (childValue != null) {
            if (isValueReference(childValue)) {
                ValueBinding vb = TagUtil.getValueBinding(childValue);
                treenodeattrComponent.setValueBinding("childValue", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("childValue", childValue); //$NON-NLS-1$
            }
        }
        if (className != null) {
            if (isValueReference(className)) {
                ValueBinding vb = TagUtil.getValueBinding(className);
                treenodeattrComponent.setValueBinding("className", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("className", className); //$NON-NLS-1$
            }
        }
        if (closeIcon != null) {
            if (isValueReference(closeIcon)) {
                ValueBinding vb = TagUtil.getValueBinding(closeIcon);
                treenodeattrComponent.setValueBinding("closeIcon", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("closeIcon", closeIcon); //$NON-NLS-1$
            }
        }
        if (enableDrop != null) {
            if (isValueReference(enableDrop)) {
                ValueBinding vb = TagUtil.getValueBinding(enableDrop);
                treenodeattrComponent.setValueBinding("enableDrop", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("enableDrop", enableDrop); //$NON-NLS-1$
            }
        }
        if (oncollapse != null) {
            if (isValueReference(oncollapse)) {
                ValueBinding vb = TagUtil.getValueBinding(oncollapse);
                treenodeattrComponent.setValueBinding("oncollapse", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("oncollapse", oncollapse); //$NON-NLS-1$
            }
        }
        if (ondragenterover != null) {
            if (isValueReference(ondragenterover)) {
                ValueBinding vb = TagUtil.getValueBinding(ondragenterover);
                treenodeattrComponent.setValueBinding("ondragenterover", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("ondragenterover", ondragenterover); //$NON-NLS-1$
            }
        }
        if (onexpand != null) {
            if (isValueReference(onexpand)) {
                ValueBinding vb = TagUtil.getValueBinding(onexpand);
                treenodeattrComponent.setValueBinding("onexpand", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("onexpand", onexpand); //$NON-NLS-1$
            }
        }
        if (onhighlight != null) {
            if (isValueReference(onhighlight)) {
                ValueBinding vb = TagUtil.getValueBinding(onhighlight);
                treenodeattrComponent.setValueBinding("onhighlight", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("onhighlight", onhighlight); //$NON-NLS-1$
            }
        }
        if (onselect != null) {
            if (isValueReference(onselect)) {
                ValueBinding vb = TagUtil.getValueBinding(onselect);
                treenodeattrComponent.setValueBinding("onselect", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("onselect", onselect); //$NON-NLS-1$
            }
        }
        if (onunselect != null) {
            if (isValueReference(onunselect)) {
                ValueBinding vb = TagUtil.getValueBinding(onunselect);
                treenodeattrComponent.setValueBinding("onunselect", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("onunselect", onunselect); //$NON-NLS-1$
            }
        }
        if (openIcon != null) {
            if (isValueReference(openIcon)) {
                ValueBinding vb = TagUtil.getValueBinding(openIcon);
                treenodeattrComponent.setValueBinding("openIcon", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("openIcon", openIcon); //$NON-NLS-1$
            }
        }
        if (referenceName != null) {
            if (isValueReference(referenceName)) {
                ValueBinding vb = TagUtil.getValueBinding(referenceName);
                treenodeattrComponent.setValueBinding("referenceName", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("referenceName", referenceName); //$NON-NLS-1$
            }
        }
        if (showSystemIcon != null) {
            if (isValueReference(showSystemIcon)) {
                ValueBinding vb = TagUtil.getValueBinding(showSystemIcon);
                treenodeattrComponent.setValueBinding("showSystemIcon", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("showSystemIcon", showSystemIcon); //$NON-NLS-1$
            }
        }
        if (_var != null) {
            if (isValueReference(_var)) {
                ValueBinding vb = TagUtil.getValueBinding(_var);
                treenodeattrComponent.setValueBinding("_var", vb); //$NON-NLS-1$
            } else {
                treenodeattrComponent.getAttributes().put("_var", _var); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
