/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002, 2003 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
*/

package com.ibm.faces.bf.taglib;


import com.ibm.faces.util.StaticMethodBinding;
import com.ibm.faces.util.TagUtil;
import java.io.IOException;
import javax.faces.component.UIComponent;
import com.ibm.faces.bf.component.UITree;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.el.MethodBinding;
import javax.faces.webapp.UIComponentTag;
import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class TreeTag extends UIComponentTag {


    public static Log log = LogFactory.getLog(TreeTag.class);

    //
    // Instance Variables
    //


    private java.lang.String dir;
    private java.lang.String enableSelect;
    private java.lang.String height;
    private java.lang.String lang;
    private java.lang.String onnodecollapse;
    private java.lang.String onnodedragenterover;
    private java.lang.String onnodedrop;
    private java.lang.String onnodeexpand;
    private java.lang.String onnodehighlight;
    private java.lang.String onnodeselect;
    private java.lang.String onnodeunselect;
    private java.lang.String rootVisibleFlag;
    private java.lang.String scrollNum;
    private java.lang.String styleClass;
    private java.lang.String systemIconStyle;
    private java.lang.String value;
    private java.lang.String _var;
    private java.lang.String width;

    //
    // Setter Methods
    //

    public void setDir(java.lang.String dir) {
        this.dir = dir;
    }

    public void setEnableSelect(java.lang.String enableSelect) {
        this.enableSelect = enableSelect;
    }

    public void setHeight(java.lang.String height) {
        this.height = height;
    }

    public void setLang(java.lang.String lang) {
        this.lang = lang;
    }

    public void setOnnodecollapse(java.lang.String onnodecollapse) {
        this.onnodecollapse = onnodecollapse;
    }

    public void setOnnodedragenterover(java.lang.String onnodedragenterover) {
        this.onnodedragenterover = onnodedragenterover;
    }

    public void setOnnodedrop(java.lang.String onnodedrop) {
        this.onnodedrop = onnodedrop;
    }

    public void setOnnodeexpand(java.lang.String onnodeexpand) {
        this.onnodeexpand = onnodeexpand;
    }

    public void setOnnodehighlight(java.lang.String onnodehighlight) {
        this.onnodehighlight = onnodehighlight;
    }

    public void setOnnodeselect(java.lang.String onnodeselect) {
        this.onnodeselect = onnodeselect;
    }

    public void setOnnodeunselect(java.lang.String onnodeunselect) {
        this.onnodeunselect = onnodeunselect;
    }

    public void setRootVisibleFlag(java.lang.String rootVisibleFlag) {
        this.rootVisibleFlag = rootVisibleFlag;
    }

    public void setScrollNum(java.lang.String scrollNum) {
        this.scrollNum = scrollNum;
    }

    public void setStyleClass(java.lang.String styleClass) {
        this.styleClass = styleClass;
    }

    public void setSystemIconStyle(java.lang.String systemIconStyle) {
        this.systemIconStyle = systemIconStyle;
    }

    public void setValue(java.lang.String value) {
        this.value = value;
    }

    public void setVar(java.lang.String _var) {
        this._var = _var;
    }

    public void setWidth(java.lang.String width) {
        this.width = width;
    }


    //
    // General Methods
    //

    public String getRendererType() { return "Tree";  } //$NON-NLS-1$
    public String getComponentType() { return "com.ibm.faces.bf.HtmlTree"; } //$NON-NLS-1$

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        UITree treeComponent = (UITree)component;

        if (dir != null) {
            if (isValueReference(dir)) {
                ValueBinding vb = TagUtil.getValueBinding(dir);
                treeComponent.setValueBinding("dir", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("dir", dir); //$NON-NLS-1$
            }
        }
        if (enableSelect != null) {
            if (isValueReference(enableSelect)) {
                ValueBinding vb = TagUtil.getValueBinding(enableSelect);
                treeComponent.setValueBinding("enableSelect", vb); //$NON-NLS-1$
            } else {
                boolean _enableSelect = new Boolean(enableSelect).booleanValue();
                treeComponent.getAttributes().put("enableSelect", _enableSelect ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (height != null) {
            if (isValueReference(height)) {
                ValueBinding vb = TagUtil.getValueBinding(height);
                treeComponent.setValueBinding("height", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("height", height); //$NON-NLS-1$
            }
        }
        if (lang != null) {
            if (isValueReference(lang)) {
                ValueBinding vb = TagUtil.getValueBinding(lang);
                treeComponent.setValueBinding("lang", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("lang", lang); //$NON-NLS-1$
            }
        }
        if (onnodecollapse != null) {
            if (isValueReference(onnodecollapse)) {
                ValueBinding vb = TagUtil.getValueBinding(onnodecollapse);
                treeComponent.setValueBinding("onnodecollapse", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("onnodecollapse", onnodecollapse); //$NON-NLS-1$
            }
        }
        if (onnodedragenterover != null) {
            if (isValueReference(onnodedragenterover)) {
                ValueBinding vb = TagUtil.getValueBinding(onnodedragenterover);
                treeComponent.setValueBinding("onnodedragenterover", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("onnodedragenterover", onnodedragenterover); //$NON-NLS-1$
            }
        }
        if (onnodedrop != null) {
            if (isValueReference(onnodedrop)) {
                ValueBinding vb = TagUtil.getValueBinding(onnodedrop);
                treeComponent.setValueBinding("onnodedrop", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("onnodedrop", onnodedrop); //$NON-NLS-1$
            }
        }
        if (onnodeexpand != null) {
            if (isValueReference(onnodeexpand)) {
                ValueBinding vb = TagUtil.getValueBinding(onnodeexpand);
                treeComponent.setValueBinding("onnodeexpand", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("onnodeexpand", onnodeexpand); //$NON-NLS-1$
            }
        }
        if (onnodehighlight != null) {
            if (isValueReference(onnodehighlight)) {
                ValueBinding vb = TagUtil.getValueBinding(onnodehighlight);
                treeComponent.setValueBinding("onnodehighlight", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("onnodehighlight", onnodehighlight); //$NON-NLS-1$
            }
        }
        if (onnodeselect != null) {
            if (isValueReference(onnodeselect)) {
                ValueBinding vb = TagUtil.getValueBinding(onnodeselect);
                treeComponent.setValueBinding("onnodeselect", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("onnodeselect", onnodeselect); //$NON-NLS-1$
            }
        }
        if (onnodeunselect != null) {
            if (isValueReference(onnodeunselect)) {
                ValueBinding vb = TagUtil.getValueBinding(onnodeunselect);
                treeComponent.setValueBinding("onnodeunselect", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("onnodeunselect", onnodeunselect); //$NON-NLS-1$
            }
        }
        if (rootVisibleFlag != null) {
            if (isValueReference(rootVisibleFlag)) {
                ValueBinding vb = TagUtil.getValueBinding(rootVisibleFlag);
                treeComponent.setValueBinding("rootVisibleFlag", vb); //$NON-NLS-1$
            } else {
                boolean _rootVisibleFlag = new Boolean(rootVisibleFlag).booleanValue();
                treeComponent.getAttributes().put("rootVisibleFlag", _rootVisibleFlag ? Boolean.TRUE : Boolean.FALSE); //$NON-NLS-1$
            }
        }
        if (scrollNum != null) {
            if (isValueReference(scrollNum)) {
                ValueBinding vb = TagUtil.getValueBinding(scrollNum);
                treeComponent.setValueBinding("scrollNum", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("scrollNum", scrollNum); //$NON-NLS-1$
            }
        }
        if (styleClass != null) {
            if (isValueReference(styleClass)) {
                ValueBinding vb = TagUtil.getValueBinding(styleClass);
                treeComponent.setValueBinding("styleClass", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("styleClass", styleClass); //$NON-NLS-1$
            }
        }
        if (systemIconStyle != null) {
            if (isValueReference(systemIconStyle)) {
                ValueBinding vb = TagUtil.getValueBinding(systemIconStyle);
                treeComponent.setValueBinding("systemIconStyle", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("systemIconStyle", systemIconStyle); //$NON-NLS-1$
            }
        }
        if (value != null) {
            if (isValueReference(value)) {
                ValueBinding vb = TagUtil.getValueBinding(value);
                treeComponent.setValueBinding("value", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("value", value); //$NON-NLS-1$
            }
        }
        if (_var != null) {
            if (isValueReference(_var)) {
                ValueBinding vb = TagUtil.getValueBinding(_var);
                treeComponent.setValueBinding("_var", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("_var", _var); //$NON-NLS-1$
            }
        }
        if (width != null) {
            if (isValueReference(width)) {
                ValueBinding vb = TagUtil.getValueBinding(width);
                treeComponent.setValueBinding("width", vb); //$NON-NLS-1$
            } else {
                treeComponent.getAttributes().put("width", width); //$NON-NLS-1$
            }
        }
    }

    //
    // Methods From TagSupport
    //

    public int doStartTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doStartTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public int doEndTag() throws JspException {
        int rc = 0;
        try {
            rc = super.doEndTag();
        } catch (JspException e) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), e);
            }
            throw e;
        } catch (Throwable t) {
            if (log.isDebugEnabled()) {
                log.debug(getDebugString(), t);
            }
            throw new JspException(t);
        }
        return rc;
    }

    public String getDebugString() {
        String result = "id: "+this.getId()+" class: "+this.getClass().getName(); //$NON-NLS-1$ $NON-NLS-2$
        return result;
    }

}
