/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.faces.bf.util;

import java.io.IOException;
import java.util.Locale;

import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.servlet.ServletRequest;
import javax.servlet.http.HttpServletRequest;

import com.ibm.faces.bf.portal.JSFURLRewriter;
import com.ibm.odcb.jrender.emitters.InitializationEmitter;
import com.ibm.odcb.jrender.mediators.ExportException;
import com.ibm.odcb.jrender.mediators.PageContext;
import com.ibm.odcb.jrender.misc.Streamer;
/**
 * @author kaushal
 *
 */
public class InitializationUtil 
{
	public static void printIncludes(ResponseWriter writer, FacesContext context, PageContext pageContext) throws IOException
	{
		HttpServletRequest httpReq = (HttpServletRequest)context.getExternalContext().getRequest();
		String contextRoot = httpReq.getContextPath();
		
		ServletRequest servReq = (ServletRequest)context.getExternalContext().getRequest();
		String serverName = servReq.getServerName();
		int portNumber = servReq.getServerPort();
		
		InitializationEmitter Init =
					new InitializationEmitter(new JSFURLRewriter(context.getExternalContext()),
											  serverName, portNumber);
		Locale locale = context.getViewRoot().getLocale();
		if (locale != null)
		{
			Init.setLocale(locale.toString());
		}
		
		try
		{
			Init.Export(writer, pageContext);
			Streamer.trace.Header().println("Initialized JS variables and included JS files; after InitializationEmitter.export...");
		}
		catch(ExportException ee)
		{
			Streamer.error.Header().printStackTrace(ee);
		}
		catch (IOException e)
		{
			Streamer.error.Header().printStackTrace(e);
			e.printStackTrace();
		}
	}
}
