/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2003, 2006 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
package com.ibm.odc.jsf.components.taglib.rte;

import javax.faces.context.FacesContext;
import javax.faces.webapp.UIComponentTag;
import javax.servlet.jsp.PageContext;

/**
 * @author wangs
 */
public abstract class BxFacesTag extends UIComponentTag {
	private String starterJsp = null;
	
	private String renderType = null;
	
	private String componentType = null;
	
	protected PageContext pageContext = null;
	//private String jsp = ".ibmjsfres/DocEditor/jsf/RteStarter.jsp";
		
	
	/**
	 * Set the starter jsp fullpath. 
	 * 
	 * @param starterJsp The fullpath for starter jsp page
	 */
	protected  void setStarterJsp (String starterJsp) {
		this.starterJsp = starterJsp;
	}
	
	protected String getStarterJsp()
	{
		return this.starterJsp;
	}
	
	/**
	 * Set the render type
	 * 
	 * @param renderType The render type
	 */
	protected  void setRenderType (String renderType) {
		this.renderType = renderType;
	}
	
	/**
	 * Set the component type
	 * 
	 * @param componentType The UI component type
	 */
	protected  void setComponentType (String componentType) {
		this.componentType = componentType;
	}
	
	/**
	 * Set the attributes to be passed to the ServletRequest to starter jsp. This 
	 * method must be called within the overided doStartTag() method
	 * 
	 * @param name The attribute name
	 * @param val  The attribute value
	 */
	protected void setRequestAttr (String name, Object val) {
		if (pageContext == null)
		{
			FacesContext facesContext = FacesContext.getCurrentInstance();
			pageContext = (javax.servlet.jsp.PageContext) facesContext.getExternalContext().getContext();
		}
		pageContext.getRequest().setAttribute(name, val);
	}
	
	public String getLocalRendererType() {
		return renderType; // @see faces-config.xml
	}
	
	/**
	 * @see javax.faces.webapp.FacesTag#createComponent()
	 */	
	public String getComponentType() { 
		return componentType; // @see faces-config.xml
	} 

	/**
	 * doStartTag() is replaced by various JSF methods, notably createComponent() & overrideProperties()
	 */
/*	
	public int doStartTag() throws JspException {
		return EVAL_BODY_INCLUDE;
	}	

	public int doEndTag() throws JspException {
		if (DEBUG) System.out.println("GetEditor::doStartTag:Entered");

		String resource = starterJsp.startsWith("/") ? starterJsp : "/" + starterJsp;
        
		if (DEBUG) System.out.println("GetEditor::doStartTag:Dispatching to resource = " + resource);
		try {
			//pageContext.setAttribute("com_ibm_pvc_wps_docEditor_MyEditor", aEditor, PageContext.REQUEST_SCOPE);
			//pageContext.setAttribute("attr0", "this is a test", PageContext.SESSION_SCOPE);			
			//ServletRequest req = pageContext.getRequest();
			//req.setAttribute("attr1", "this is attr1");
			
			pageContext.include(resource);
			if (DEBUG) System.out.println("GetEditor::doStartTag:Included JSP " + resource);
		}
		catch (Exception t) {
			if (DEBUG) System.out.println("GetEditor::doEndTag:ERROR THROWABLE: " + t.getMessage());
			throw new JspException (t);
		}		
		return EVAL_PAGE;
	}
*/
}

