/************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corp. 2003.  All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation.  This sample code is
 * not part of any standard or IBM product and is provided to you
 * solely for the purpose of assisting you in the development of
 * your applications.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have
 * been advised of the possibility of such damages.
 *************************************************************************/

package com.ibm.odcb.jrender.diff;

import com.ibm.odcb.jrender.misc.Streamer;

/**
 * @author ldh
 *
 * Default Diff handler.  No action on updates (dummy handler).
 */
public class BaseHandler implements DiffHandler
 {
   public void handle(DiffInfo diff) throws DiffException
    {  
      switch (diff.getCrud())
       {
         case 'C': handleCreate(diff); break;
         case 'U': handleUpdate(diff); break;
         case 'D': handleDelete(diff); break;
         case 'A': handleAdd   (diff); break;
         case 'R': handleRemove(diff); break;
       }
    }
   protected void handleCreate(DiffInfo diff) throws DiffException
    {
      Streamer.debug.Header().println("Default do-nothing handler invoked to create a "+diff.getEClassName());
    }
   protected void handleUpdate(DiffInfo diff) throws DiffException
    {
      Streamer.debug.Header().println("Default do-nothing handler invoked to update a "+diff.getEClassName());
    }
   protected void handleDelete(DiffInfo diff) throws DiffException
    {
      Streamer.debug.Header().println("Default do-nothing handler invoked to delete a "+diff.getEClassName());
    }
   protected void handleAdd(DiffInfo diff) throws DiffException
    {
      Streamer.debug.Header().println("Default do-nothing handler invoked to add a "+diff.getEClassName());
    }
   protected void handleRemove(DiffInfo diff) throws DiffException
    {
      Streamer.debug.Header().println("Default do-nothing handler invoked to remove a "+diff.getEClassName());
    }
   public Object find(DiffInfo Diff) throws DiffException
    {
      return null;
    }
   public String getId(DiffInfo Diff, boolean Original)
    {
      return Diff.getEClassName()+": BaseHandler";
    }
 }
