/************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corp. 2003.  All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation.  This sample code is
 * not part of any standard or IBM product and is provided to you
 * solely for the purpose of assisting you in the development of
 * your applications.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have
 * been advised of the possibility of such damages.
 *************************************************************************/
package com.ibm.odcb.jrender.diff;

/**
 * @author Titania Gupta
 *
 * Application specific custom handlers you implement to handle or
 * persist the changes made to the objects contained within a Diff.
 * Saving these changes to a database is an example of what a DiffHandler can be used for.
 */
public interface DiffHandler
 {
   public static final String COPYRIGHT = com.ibm.odcb.utilities.IBMCopyright.SHORT_COPYRIGHT;

   /**
    * Application specific custom code to handle or persist the changes made to an object of a given type
    * contained within a Diff.  Writing these changes to a datastore is an example implementation.
    * @param theDiff The DiffInfo containing all the information about this object:
    *                 it's current state, it's original state, it's list of ancestors,
    *                 and the <u>C<u>reate, <u>R<u>ead, <u>U<u>pdate, or <u>D<u>elete action on the object.
    * @see   <code>DiffInfo<code>
    */
   public void   handle(DiffInfo Diff) throws DiffException, Exception;
   public Object find  (DiffInfo Diff) throws DiffException, Exception;
   public String getId (DiffInfo Diff, boolean Original);
 }
