/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.odcb.jrender.emitters;

/**
 * @author Breffni Coffey <br>
 * <code>ColDataEmitterHelper</code> is a helper class for the <code>NodeAttributeEmitterHelper</code>.
 * This class supplies the metadata to the <code>NodeAttributeEmitterHelper</code> to construct a column.
 */

public class BehaviorEmitter 
{
	private String targetAction, event, behaviorAction, onActionFunction;

	/**
	 * @param attributeName The _eAttributeName to set.
	 */
	public void addTargetAction(String targetAction) 
	{
		this.targetAction= targetAction;
	}
	/**
	 * @param attributeName The _eAttributeName to set.
	 */
	public void addEvent(String event ) 
	{
		this.event = event;
	}
	/**
	 * @param attributeName The _eAttributeName to set.
	 */
	public void addBehaviorAction(String behaviorAction ) 
	{
		this.behaviorAction = behaviorAction;
	}
	/**
	 * @param attributeName The _eAttributeName to set.
	 */
	public void addOnActionFunction(String onActionFunction ) 
	{
		this.onActionFunction = onActionFunction;
	}

	/**
	 * @return Returns the behaviorAction.
	 */
	public String getBehaviorAction() {
		return behaviorAction;
	}
	/**
	 * @return Returns the event.
	 */
	public String getEvent() {
		return event;
	}
	/**
	 * @return Returns the onActionFunction.
	 */
	public String getOnActionFunction() {
		return onActionFunction;
	}
	/**
	 * @return Returns the targetAction.
	 */
	public String getTargetAction() {
		return targetAction;
	}
}
