/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.odcb.jrender.emitters;

/**
 * @author Breffni Coffey <br>
 * <code>ColAttrEmitterHelper</code> is a helper class for the <code>TreeTableEmitter</code>.
 * This class supplies the metadata to the <code>TreeTableEmitter</code> to construct a column.
 */

public class ColAttrEmitterHelper 
{
	protected String width, id, label;
	
	/**
	 * Associates a width with a column
	 * @param v the width of the column.
	 */
	public void addWidth(String v) {
		width=v;
	}
	
	/**
	 * Associates an id with a column
	 * @param v the width of the column.
	 */
	public void addId(String v) {
		id=v;
	}
	
	/**
	 * Associates a label header with a column
	 * @param v the label for the column.
	 */
	public void addLabel(String v) {
		label=v;
	}

	/**
	 * @return Returns the id.
	 */
	public String getId() {
		return id;
	}
	/**
	 * @return Returns the width.
	 */
	public String getWidth() {
		return width;
	}
	/**
	 * @param label The label to set.
	 */
	public String getLabel() {
		return label;
	}
}
