/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

/*
 * Created on Apr 30, 2003
 *
 */
package com.ibm.odcb.jrender.emitters;

import java.io.IOException;
import java.io.Writer;

import com.ibm.odcb.jrender.mediators.ExportException;
import com.ibm.odcb.jrender.mediators.PageContext;
import com.ibm.odcb.jrender.misc.Streamer;


/**
 * @author Kaushal <br>
 * Java interface to emit code for assigning a Label to an HTML control
 */
public class LabelEmitter extends BaseEmitter {

	public static final String COPYRIGHT = com.ibm.odcb.utilities.IBMCopyright.SHORT_COPYRIGHT;

	// Constructors; default one is empty; second one does all the work.
	// If object is instantiated with default one, developer has to call
	// set() methods to set class variables.
	public LabelEmitter()
	{
		super("ODCLabel");
	}

	// Class variables	
    protected String _FormHTMLElementID;
    protected String _Text;
	protected String _modelName;
	protected String _eObjectID;
	protected String _eAttributeName;
	
	// init() initializes all class variables.
	public void Init(String modelName, String eObjectID, String eAttributeName, String FormHTMLElementID, String Text)
	{
		_modelName = modelName;
		_eObjectID = eObjectID;
		_eAttributeName = eAttributeName;
		_FormHTMLElementID = FormHTMLElementID;
		_Text = Text;
	}

	// All set functions to initialize class instance variables.

    public void setText(String Text)
     {
       _Text = Text;
     }

    public void setFormHTMLElementID(String FormHTMLElementID)
     {
       _FormHTMLElementID = FormHTMLElementID;
     }

	public void setModelName(String modelName)
	{
		_modelName = modelName;
	}
	public void setEObjectID(String eObjectID)
	{
		_eObjectID = eObjectID;
	}
	public void setEAttributeName(String eAttributeName)
	{
		_eAttributeName = eAttributeName;
	}

	/**
	 * Export method emits code to render a label and associate it with an HTML control
	 * @param out	Writer output stream to write the generated code to
	 * @param PC	Page Context
	 */
	public void Export(Writer out, PageContext PC) throws ExportException, IOException
	{
		Streamer.trace.Header().println("Entering LabelEmitter export...");
		_varIndex = PC.NextInstanceCount();
		out.write("<label for=\""+_FormHTMLElementID+"\">"+_Text+"</label>");out.write("\n");
		out.write("<script type=\"text/javascript\">");out.write("\n");
		out.write("var "+ADAPTER_VAR+_varIndex+" = new PropertyBinder(findEObjectByXMIID(WDO4JSModelRoot_"+_modelName+".Root,'"+_eObjectID+"')"
                                                                                +",'"+_eAttributeName+"'"
                                                                                +",document.getElementById('"+CONTROL_VAR+_varIndex+"')"
                                                                                +",'value', null);");
		out.write("\n");
		out.write(ADAPTER_VAR+_varIndex+".DataBind();");out.write("\n");
		out.write("</script>");out.write("\n");
		Streamer.trace.Header().println("Exiting LabelEmitter export...");
	}
}