/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

/*
 * Created on Apr 30, 2003
 *
 */
package com.ibm.odcb.jrender.emitters;

import java.io.IOException;
import java.io.Writer;

import com.ibm.odcb.jrender.mediators.ExportException;
import com.ibm.odcb.jrender.mediators.PageContext;
import com.ibm.odcb.jrender.misc.Streamer;


/**
 * @author Kaushal <br>
 * Output emitter spits out html/JavaScript code for an Output control and the associated property binder.
 */
public class OutputTextEmitter extends BaseEmitter {

	public static final String COPYRIGHT = com.ibm.odcb.utilities.IBMCopyright.SHORT_COPYRIGHT;

	/**
	 * @author kaushal
	 * Constructors; default one is empty, it just calls the BaseEmitter with the appropriate
	 * component name.
	 */
	public OutputTextEmitter()
	{
		super("ODCTextOutput");
	}

	// Class variables	
	protected String _modelName;
	protected String _eObjectID;
	protected String _eAttributeName;
	
	// init() initializes all class variables.
	public void Init(String modelName, String eObjectID, String eAttributeName)
	{
		_modelName = modelName;
		_eObjectID = eObjectID;
		_eAttributeName = eAttributeName;
	}

	// All set functions to initialize class instance variables.
	public void setModelName(String modelName)
	{
		_modelName = modelName;
	}
	public void setEObjectID(String eObjectID)
	{
		_eObjectID = eObjectID;
	}
	public void setEAttributeName(String eAttributeName)
	{
		_eAttributeName = eAttributeName;
	}
	
	// Export function exports / emits Java Script code for Button HTML element
	public void Export(Writer out, PageContext PC) throws ExportException,IOException
	{
		Streamer.trace.Header().println("Entering OutputTextEmitter export...");
		_varIndex = PC.NextInstanceCount();
		out.write("<span id=\""+CONTROL_VAR+_varIndex+"\"></span>"); out.write("\n");
		out.write("<script type=\"text/javascript\">"); out.write("\n");
		out.write("var "+ADAPTER_VAR+_varIndex+" = new PropertyBinder(findEObjectByXMIID(WDO4JSModelRoot_"+_modelName+".Root,'"+_eObjectID+"')"
                                                                                +",'"+_eAttributeName+"'"
                                                                                +",document.getElementById('"+CONTROL_VAR+_varIndex+"')"
                                                                                +",'innerHTML', null);");
		out.write("\n");
		out.write(ADAPTER_VAR+_varIndex+".DataBind();"); out.write("\n");

		// Registering control not needed: being done in JSF (July 30, 2003)
		//out.write(PAGE_CONTROL_VAR+".registerControl(\""+CONTROL_VAR+_varIndex+"\", "+CONTROL_VAR+_varIndex+");"); out.write("\n");

		out.write("</script>"); out.write("\n");
		Streamer.trace.Header().println("Exiting OutputTextEmitter export...");
	}
}