/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//  
//OCO Source Materials
//  
//5724-E76 and 5724-E77
//  
// Copyright IBM Corp.  2003
//  
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

/*
 * Created on Apr 9, 2003
 *
 */
package com.ibm.odcb.jrender.emitters;

import com.ibm.odcb.jrender.misc.Streamer;

/**
 * Helper class for the <code>TabbedPanelEmitter</code>. This class is used
 * to specify the information for the individual panels in the tabbed panel.
 * @author fenil
 */
public class PanelEmitter {

	protected String  _panelDisplayName; 
	protected String  _panelID;

	protected String _tabIcon;
	protected String _parentPane;
	
	protected String  _OnEnter;
	protected String  _OnExit;
    protected boolean _FinishCancelButton;
    
    //RATLC01082051 - add properties, added as necessary to methods
    protected boolean _disbaleFinish;
    protected boolean _disableCancel;
    
    protected boolean _disableTab;
	
	/**
	 * Constructor.
	 * @param panelDisplayName the label to be displayed on this panel
	 * @param panelID the id for this panel
	 * @param OnEnter the event handler for the the &quot;onenter&quot; event.
	 * @param OnExit the event handler for the &quot;onexit&quot; event.
	 * @param FinishCancelButton specifies whether you want to show the finish and cancel buttons for this panel.
	 */
	public PanelEmitter(String panelDisplayName,
						String panelID,
						String OnEnter,
						String OnExit,
						boolean FinishCancelButton,
						boolean disableFinish,
						boolean disableCancel,
						String tabIcon,
						String parentPane,
						boolean disableTab)
	{
		this.Init(panelDisplayName, 
				  panelID,
				  OnEnter,
				  OnExit, 
				  FinishCancelButton,
				  disableFinish,
				  disableCancel,
				  tabIcon,
				  parentPane,
				  disableTab);
	}
	
	/**
	 * Initializer for this <code>PanelEmitter</code>. Same as the constructor.
	 * @param panelDisplayName
	 * @param panelID
	 * @param OnEnter
	 * @param OnExit
	 * @param FinishCancelButton
	 */
	public void Init(String panelDisplayName, 
					 String panelID,
					 String OnEnter,
					 String OnExit,
					 boolean FinishCancelButton,
					 boolean disableFinish,
					 boolean disableCancel,
					 String tabIcon,
					 String parentPane,
					 boolean disableTab)
	{
		_panelDisplayName = panelDisplayName;
		_panelID = panelID;
		_OnEnter = OnEnter;
		_OnExit = OnExit;
		_FinishCancelButton = FinishCancelButton;
		_disbaleFinish = disableFinish;
		_disableCancel = disableCancel;
		_tabIcon = tabIcon;
		_parentPane = parentPane;
		_disableTab = disableTab;
		
		Streamer.debug.Header().println("Panel display name: "+this._panelDisplayName+"\n"+
										"panel ID: "+this._panelID+"\n"
										);					 
	}
	// End addition 9/16/2003 by Kaushal
		
	public String getPanelDisplayName() { return _panelDisplayName; }
	public String getPanelID() { return _panelID; }
	public String getOnEnter() { return _OnEnter; }
	public String getOnExit() { return _OnExit; }
	public String getTabIcon() { return this._tabIcon; }
	public String getParentPane() { return this._parentPane; }
	public boolean getDisableTab() { return this._disableTab; }
}
