/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

package com.ibm.odcb.jrender.mediators;

import java.util.Iterator;

import com.ibm.odcb.jrender.mediators.gen.WDO4JSMappings;
import com.ibm.odcb.jrender.mediators.gen.ecore.EClassMap;
import com.ibm.odcb.jrender.mediators.gen.ecore.EFeatureMap;
import com.ibm.odcb.jrender.mediators.gen.ecore.EPackageMap;
import com.ibm.odcb.jrender.misc.Streamer;
import com.ibm.odcb.jrender.utilities.EMapGen;

/**
 * @author tgupta
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MappingsMerger
 {
   public MappingsMerger()
    {
    }
   
   // This method is pre-Dublin untested and unfinished code for merging universes. It is not currrently in use
   // - Adam
   public static WDO4JSMappings mergeWithCurrentUniverse(WDO4JSMappings newUniverse, boolean mergeIfEMapExists) throws ExportException, Exception
    {
      
   	

   	  Streamer.status.Header().println("MappingsMerger: Getting current Universe");
      WDO4JSMappings currentUniverse = MediatorFactory.getInstance().getUniverse();
      Streamer.status.Header().println("MappingsMerger: Successfully obtained the current Universe");

      // Iterating through the EPackageMaps in the new Universe
      
      Iterator newit = newUniverse.getEPackageMapsIterator();
      while (newit.hasNext())
       {
         EPackageMap NewEPM = (EPackageMap) newit.next();
         EPackageMap CurrentEPM = currentUniverse.getEPackageMap(NewEPM.getName());
//         Map mergedList = new HashMap();
         if (CurrentEPM != null && mergeIfEMapExists)
          {
            Streamer.status.Header().println("MappingsMerger: Merging with current mappings for EPackage '"+NewEPM.getName()+"'.");
            // new for client data event handling: need to merge EPackages before iterating through EClassMaps
            mergeEPackageMaps(NewEPM, CurrentEPM);
            // Iterating through the EClassMaps in the new Universe for the EPackage
            Iterator emapit = newUniverse.getEClassMapsForEPackageIterator(NewEPM.getName());
            while (emapit.hasNext())
             {
               EClassMap NewECM     = (EClassMap) emapit.next();
               EClassMap CurrentECM = (EClassMap) CurrentEPM.getEClassMapsByJavaComplexName().get(NewECM.getJavaComplexName());
               mergeEClassMaps(NewECM,CurrentECM);
//               mergedList.put(MergedECM.getComplexName(),MergedECM);
             }
          }
         else
          {
            Streamer.status.Header().println("MappingsMerger: Adding new mappings for EPackage '"+NewEPM.getName()+"'.");
//            mergedList = newUniverse.getEClassMapsForEPackageIterator(NewEPM.getName());
          }
         
         //update the universe for this package
         
         currentUniverse.addEPackageMap(NewEPM, true);
//         currentUniverse = mergeUniverse(CurrentEPM, currentUniverse, NewEPM, mergedList);
         Streamer.status.Header().println("MappingsMerger: The new mappings for EPackage '"+NewEPM.getName()+"' have been successfully added to/merged with the current universe.");
      }
       return currentUniverse;
   }
   
   //new in JWL 2.1 - needed for Client Data Event Handling
   public static void mergeEPackageMaps(EPackageMap newepm, EPackageMap oldepm)
   {
   	if (oldepm != null)
   	{
   		//EPackage params needed for Client Data Event Handling
   		if(oldepm.getJSURI() != null)
   		{
   			newepm.setJSURI(oldepm.getJSURI());
   		}
   		if(oldepm.getOnCreate() != null)
   		{
   			newepm.setOnCreate(oldepm.getOnCreate());
   		}
   		if(oldepm.getOnDelete() != null)
   		{
   			newepm.setOnDelete(oldepm.getOnDelete());
   		}
   		if(oldepm.getOnUpdate() != null)
   		{
   			newepm.setOnUpdate(oldepm.getOnUpdate());
   		}
   		// End Client Data Event Handling
   		
   		//Adam - not sure if this is needed here
   		newepm.setEMapResourceName(oldepm.getEMapResourceName());
   		newepm.setEMapXMLFileName(oldepm.getEMapXMLFileName());
   		newepm.setClientECoreResource(oldepm.getClientECoreResource());
   		newepm.setRootEClassMap(oldepm.getRootEClassMap());
   		newepm.setRootEClassMapName(oldepm.getRootEClassMapName());
   		//to here
   		
   	}
   }
   
   // Adam - JWL 2.1 changing this from mergeEmaps to mergeEClassMaps because of introduction of mergeEPackageMaps
   public static void mergeEClassMaps(EClassMap newem, EClassMap oldem)
    {
      if (oldem != null) //an emap exists for this class, so, save the customized mappings
       {         
         newem.setExport(oldem.getExport());
         newem.setDiffOnRefresh(oldem.isDiffOnRefresh());
         newem.setExtraName(oldem.getExtraName());
         //iterate through the child eattributes and ereferences
         Iterator newfit = newem.getEFeatureMapIterator();
         while (newfit.hasNext())
          {
            EFeatureMap newf = (EFeatureMap) newfit.next();
            EFeatureMap oldf = oldem.getEFeatureMapByEFeatureName(newf.getEFeatureName());
            if (oldf != null)//emap exists for this feature, so, save it
             {
               //set to the old ID value only if cardinality is not many
               if (newf.isMany() == false)
                {
                  newf.setID(oldf.isID());
                }
               else
                {
                  newf.setID(false);
                }
               if (newf.getGetter().equals(EMapGen.ACCESS_METHOD_NEEDED))
                {
                  newf.setGet(oldf.getGetter());
                }
               if (newf.getSetter() != null && newf.getSetter().equals(EMapGen.ACCESS_METHOD_NEEDED))
                {
                  newf.setSetter(oldf.getSetter());
                }
             }
          }
         //add client attributes if any (formerly called calculated attributes)
         newem.addClientAttributes(oldem.getClientAttributesIterator());
       }
   }
   
//   private WDO4JSMappings mergeUniverse(EPackageMap CurrentEPM, WDO4JSMappings currentUniverse,
//                                        EPackageMap NewEPM, Map mergedECMs )
//    {
      //update the universe for this package
      //remove old
//      if (CurrentEPM != null)
//      {
        //remove EClassifiers
//        Iterator oldit = CurrentEPM.getEClassifiers().iterator();
//        while (oldit.hasNext())
//        {
//         EClassifier ec = (EClassifier) oldit.next();
//         currentUniverse.removeEClassifier(ec);
//        }
        //remove EPackage
//        currentUniverse.removeEPackageMap(CurrentEPM.getName());
        //remove EClassMaps
//        Iterator mapit = currentUniverse.getEClassMapsForEPackage(existingPkg.getName()).values().iterator();
//        while (mapit.hasNext())
//        {
//         EClassMap em = (EClassMap) mapit.next();
//         currentUniverse.removeEClassMap(em);
//        }     
//      }
      
      //add new EPackage
//      currentUniverse.addEPackageMap(NewEPM, true);
      //add new EClassifiers
//      Iterator ecit = pkg.getEClassifiers().iterator();
//      while (ecit.hasNext())
//      {
//        EClassifier ec = (EClassifier) ecit.next();
//        currentUniverse.addEClassifier(ec);
//      }
      //add new EClassMaps
//      Iterator mergeit = mergedECMs.values().iterator();
//      while (mergeit.hasNext())
//      {
//        EClassMap em = (EClassMap) mergeit.next();
//        currentUniverse.addEClassMap(em);
//      }   
//      return currentUniverse;
//   }

/*   
   public static WDO4JSMappings removeMappings(EPackageMap existingPkg, 
                                               WDO4JSMappings currentUniverse)
   {
      if (existingPkg != null)
      {
        //remove EClassifiers
        Iterator oldit = existingPkg.getEClassifiers().iterator();
        while (oldit.hasNext())
        {
         EClassifier ec = (EClassifier) oldit.next();
         currentUniverse.removeEClassifier(ec);
        }
        //remove EPackage
        currentUniverse.removeEPackageMap(existingPkg.getName());
        //remove EClassMaps
        Iterator mapit = currentUniverse.getEClassMapsForEPackage(existingPkg.getName()).values().iterator();
        while (mapit.hasNext())
        {
         EClassMap em = (EClassMap) mapit.next();
         currentUniverse.removeEClassMap(em);
        }     
      }
      return currentUniverse;
   }
*/

/*
   public static WDO4JSMappings addMappings(EPackageMap pkg, WDO4JSMappings currentUniverse, HashMap eClassMaps)
    {   
      if (pkg != null)
       {
         //add new EPackage
         currentUniverse.addEPackage(pkg,true);
         //add new EClassifiers
         Iterator ecit = pkg.getEClassifiers().iterator();
         while (ecit.hasNext())
          {
            EClassifier ec = (EClassifier) ecit.next();
            currentUniverse.addEClassifier(ec);
          }
       }
      //add new EClassMaps
      Iterator mergeit = eClassMaps.values().iterator();
      while (mergeit.hasNext())
       {
         EClassMap em = (EClassMap) mergeit.next();
         currentUniverse.addEClassMap(em);
       }
      return currentUniverse;
    }
*/
 }
