/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.odcb.jrender.mediators.gen;

import java.util.Iterator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import com.ibm.odcb.jrender.misc.EMFHelper;
import com.ibm.odcb.jrender.misc.Streamer;


public class EcoreLoader
 {
   public EcoreLoader(WDO4JSMappings universe)
    {
      _Universe = universe;
    }

   protected WDO4JSMappings _Universe;

   public boolean load(String resourceURI)
    {
      boolean ok = true;
      Resource res = EMFHelper.getResourceFromStream(resourceURI);
      if (res != null)
       {
         EPackage EP = (EPackage) res.getContents().get(0);
         _Universe.addEPackage(EP, true);   
       }
      else
       {
         Streamer.error.Header().println(resourceURI + ": the ecore loading failed");
         ok = false;
        }
       return ok;
    }

   public boolean load(URI uri)
    {
      boolean OK = true;
      try
       {  
         EMFHelper.initSDO();
         ResourceSet resSet = new ResourceSetImpl();
         Resource res = EMFHelper.load(resSet, uri);
         EPackage EP = (EPackage) res.getContents().get(0);
         _Universe.addEPackage(EP, false);   
       }
      catch (Exception e)
       {
         Streamer.error.Header().println("ecore loading failed");
         Streamer.error.Header().printStackTrace(e);
         return false;
       }
      return OK;
    }

/*
     private void addEPackageToUniverse(Resource res)
     {
      EPackage EP = (EPackage) res.getContents().get(0);
      _Universe.addEPackage(EP, true);   
     }
*/
//  public ResourceSet resSet;



//   public static void addEPackageToUniverse(EPackage pkg, WDO4JSMappings universe)
//    {
//      Streamer.status.Header().println("Loading Ecore EPackage: " + pkg.getName());
//      Iterator it = pkg.getEClassifiers().iterator();
//      while (it.hasNext())
//       {         
//         EClass ec = (EClass) it.next();
//         Streamer.status.Header().println("adding ECLASSIFIER: " + ec.getName());
//         universe.addEClass(ec, true);
//       }
//      universe.addEPackage(pkg, true);
//      Streamer.status.Header().println("Finished Loading Ecore EPackage: " + pkg.getName());
//    }

   public static void main(String[] args) {
     try {
        String path = "";
        
        try {
          path = args[0];
        }
        catch (Exception e) {
           System.out.println("Error parsing arguments!  No ecore filename found.");
           return;
        }
        
      URI ecoreURI = URI.createFileURI(path);
      WDO4JSMappings Universe = new WDO4JSMappings();
      EcoreLoader el = new EcoreLoader(Universe);
      boolean OK = el.load(ecoreURI);
      Streamer.status.Header().println("Finished loading ecore: OK=" + OK);
      Iterator it = Universe.getEClassesIterator();
      Streamer.status.Header().println("The following EClasses were added:");
      while (it.hasNext()) {
         EClass m = (EClass) it.next();
         Streamer.status.Header().println( m.getEPackage().getName() + "`" + m.getName() );
         Iterator at = m.getEAttributes().iterator();
         while (at.hasNext())
         {
            EAttribute ea = (EAttribute) at.next();
            Streamer.status.Header().println("  - EAttribute: " + ea.getName());
        Streamer.status.Header().println("         eType: " + ea.getEType());
         }
         Iterator er = m.getEReferences().iterator();
         while (er.hasNext())
         {
            EReference ref = (EReference) er.next();
            Streamer.status.Header().println("  - EReference: " + ref.getName());
        Streamer.status.Header().println("         eType: " + ref.getEType());
         }
      }
     }
     catch (Exception e) {
        Streamer.error.Header().println("Error loading ecore:");
        e.printStackTrace();
     }
   }
}
