/////////////////////////////////////////////////////////////////////////
//  IBM Confidential
//  
//  OCO Source Materials
//  
//  PID xxxx-xxx
//  
//   Copyright IBM Corp.  2003
//  
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////



package com.ibm.odcb.jrender.mediators.gen;

import com.ibm.odcb.jrender.diff.DiffException;
import com.ibm.odcb.jrender.diff.generators.DiffProcessorGenerator;
import com.ibm.odcb.jrender.mediators.ExportException;
import com.ibm.odcb.jrender.mediators.gen.ecore.EClassMap;
import com.ibm.odcb.jrender.mediators.gen.ecore.EPackageMap;
import com.ibm.odcb.jrender.misc.Streamer;

import java.io.*;
import java.util.*;


public class MappingGen extends Object
 {
   public static final String COPYRIGHT = com.ibm.odcb.utilities.IBMCopyright.SHORT_COPYRIGHT;

   /*public MappingGen(String Directory, String Package)
    {
      _Directory = Directory;
      _Package   = Package  ;
    }*/
    
   public MappingGen()
    {
    }


   //protected String _Directory;
   //protected String _Package  ;

   public static String getFileNameWithoutExtention(String FileName)
    {
      int  j = FileName.lastIndexOf(".emap");
      int  i = FileName.lastIndexOf(File.separatorChar, j);
      return FileName.substring(i+1,j);
    }

   // if EPackageName is null, then we build everything. Otherwise, we build only the stuff 
   // for the EPackage specified. If Rebuild is true, then we rebuild the mediators even if
   // their associated EMap file has not changed. Should generally be called with false, unless
   // a full re-gen is necessary.
   public boolean GenMediators(WDO4JSMappings Universe, String EPackageName, boolean ForceRegeneration) 
   throws FileNotFoundException, ExportException, DiffException, ClassNotFoundException
    {
      com.ibm.odcb.jrender.mediators.gen.generators.Generator.Init();
      com.ibm.odcb.jrender.diff.generators.DiffHandlerGenerator   DiffHandlerGen   = new com.ibm.odcb.jrender.diff.generators.DiffHandlerGenerator();
      com.ibm.odcb.jrender.diff.generators.DiffProcessorGenerator DiffProcessorGen = new DiffProcessorGenerator    ();

      Iterator I1 = Universe.getEPackageMapsIterator();
      while (I1.hasNext() == true)
       {
         EPackageMap EPM = (EPackageMap) I1.next();
         if (EPackageName != null && EPackageName.equals(EPM.getName()) == false)
          continue;
         Streamer.status.Header().println("Generating mediators for EPackage '"+EPM.getName()+"'.");
         Iterator I2 = EPM.getEClassMapsByJavaComplexName().values().iterator();
         while (I2.hasNext() == true)
          {
            EClassMap ECM = (EClassMap) I2.next();
            Streamer.status.Header().println("Generating mediators for EClass '"+ECM.getJavaComplexName()+"'/'"+ECM.getExport()+"'.");
            String SubDir = ECM.getXMLFileSource().substring(0, ECM.getXMLFileSource().lastIndexOf(".emap"));
	         new File(SubDir).mkdir();
            String SubPackage = (ECM.getSourceEmapName().substring( 0, ECM.getSourceEmapName().lastIndexOf(".emap") )).replace('/', '.');
            for (int i = 0; i < com.ibm.odcb.jrender.mediators.gen.generators.Generator.MEDIATOR_KEYS.length; ++i)
             {
               com.ibm.odcb.jrender.mediators.gen.generators.Generator G 
                  = com.ibm.odcb.jrender.mediators.gen.generators.Generator.getGenerator(
                      com.ibm.odcb.jrender.mediators.gen.generators.Generator.MEDIATOR_KEYS[i]);
               G.genMediator(ECM, SubDir, SubPackage, ForceRegeneration);
             }
            if (EPM.getRootEClassMap() != null)
            {
              DiffHandlerGen  .gen(EPM.getRootEClassMapTransformed(), ECM, SubDir, SubPackage);
              DiffProcessorGen.gen(EPM, SubDir, SubPackage);
            }
            else
            {
            	Streamer.warning.Header().println("RootEClass was not found for EPackage "+ EPM.getName()+".  DiffHandlers will not be generated for this EPackage.  To generate Diffhandlers, add the \"root_eclass_name\" property to the EMap file, then regenerate Mediators.");
            }
           }
       }
      return true;
    }
 }

