/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.odcb.jrender.mediators.gen;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;

import com.ibm.odcb.jrender.mediators.gen.ecore.EClassMap;
import com.ibm.odcb.jrender.mediators.gen.ecore.EPackageMap;
import com.ibm.odcb.jrender.misc.IntWrapper;
import com.ibm.odcb.jrender.misc.Streamer;

public class WDO4JSMappings
 {
   public static final String COPYRIGHT = com.ibm.odcb.utilities.IBMCopyright.SHORT_COPYRIGHT;

   public WDO4JSMappings()
    {
    }

//   public HashMap _EPackagesByName       = new HashMap(7) ;   //   A hash of all EPackages by name
//   public HashMap eMapResourceNamesByEPackage = new HashMap(7); // A has of the Resource names of emaps per epackage.  This is the relative path.
//   public HashMap eMapXMLFileNamesByEPackage = new HashMap(7); // A has of the XML file names of emaps per epackage.  This is the relative path.
//   protected ResourceSet _ClientEcoreResourcesByEcoreName = new ResourceSetImpl() ;   //   A hash of all the generated Client EPackages by fully qualified resource name of the ecore file
//   public Map _EClassMapsByEcoreName  = new HashMap(7) ;   //   A hash of all EclassMaps by Ecorename

   protected Map _EPackagesByNames                 = new HashMap(7) ;   // A hash of all Eclasses by EcoreName
   protected Map _EPackageMapsByName               = new HashMap(7);

   protected Map _EClassesByEPackageAndEClassNames = new HashMap(7) ;   // A hash of all Eclasses by EcoreName
   protected Map _EClassMapsByExport               = new HashMap(7) ;   // A hash of all EclassMaps by export
   protected Map _EClassMapsByJavaComplexName      = new HashMap(7) ;   // A hash of all EClassMaps by it's Java (application) class name as specified in the emap.
   protected Map _EClassMapsByECoreComplexName     = new HashMap(7) ;   // A hash of all EClassMaps by it's ECore class name as specified in the emap.

   protected IntWrapper _Error = new IntWrapper(0);
   
   protected ResourceSet clientEcoreResSet = new ResourceSetImpl();


/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
///  G  E  T  T  E  R  S    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//   public Iterator getEClassMapsIterator  () { return _EClassMapsByExport .values().iterator(); }
//   public Iterator getEClassifiersIterator() { return _EClassesByEcoreName.values().iterator(); }
//   public Iterator getEPackageMapsIterator() { return _EPackageMapsByName .values().iterator(); }

   public int getError()
    {
      return _Error.getValue();
    }

   public EClassMap getEClassMapByExport(String export)
    {
      return (EClassMap) _EClassMapsByExport.get(export); 
    }
    
   /**
    * gets the EClassMap for the given Application class or view of the class as specified in the emap.
    * @param appClassName the fully qualified application class name as specified in the emap.
    * @return the EClassMap
    */
   public EClassMap getEClassMapByJavaComplexName(String JavaComplexName)
    {
      return (EClassMap) _EClassMapsByJavaComplexName.get(JavaComplexName);
    }
   public EClassMap getEClassMapByJavaComplexName(String JavaClassName, String ExtraName)
    {
      return getEClassMapByJavaComplexName(EClassMap.MakeComplexName(JavaClassName, ExtraName));
    }

   public EClassMap getEClassMapByEPackageAndECoreComplexName(String EPackageName, String ECoreComplexName)
    {
      return (EClassMap) _EClassMapsByECoreComplexName.get(MakeMapName(EPackageName, ECoreComplexName));
    }
   public EClassMap getEClassMapByEPackageAndECoreComplexName(String EPackageName, String EClassName, String ExtraName)
    {
      return getEClassMapByEPackageAndECoreComplexName(EPackageName, EClassMap.MakeComplexName(EClassName, ExtraName));
    }

   /**
    * Gets the EClassifier given it's full ECore name of the form "EPackageName`EClassName"
    */
//   public EClassifier getEClassifier(String ecoreName)
//    {
//      return (EClassifier) _EClassesByEcoreName.get(ecoreName);
//    } 
   
   public EClassifier getEClassifier(String EPackageName, String EClassName)
    {
      return (EClassifier) _EClassesByEPackageAndEClassNames.get(MakeMapName(EPackageName,EClassName));
    } 
    
   public EPackageMap getEPackageMap(String ePackageName)
    {
      return (EPackageMap) _EPackageMapsByName.get(ePackageName);
    }   
    
   public Iterator getEClassMapsForEPackageIterator(String ePackageName)
    {
      EPackageMap EPM = (EPackageMap) _EPackageMapsByName.get(ePackageName);
      return EPM.getEClassMapsByJavaComplexName().values().iterator();
//      HashMap map = new HashMap(8);
//      Iterator it = getEClassMapsIterator();
//      while (it.hasNext())
//       {
//         EClassMap M = (EClassMap) it.next();
//         if (M.getEPackageName().equals(ePackageName))         
//          {
//            map.put(M.getExport(), M);
//          }
//       }
//      return map;
    } 

   public Iterator getEClassMapsIterator()
    {
      return _EClassMapsByJavaComplexName.values().iterator();
    }

   public Iterator getEPackageMapsIterator()
    {
      return _EPackageMapsByName.values().iterator();
    }

   public Iterator getEClassesIterator()
    {
      return _EClassesByEPackageAndEClassNames.values().iterator();
    }

   public Iterator getEPackagesIterator()
    {
      return _EPackagesByNames.values().iterator();
    }

//   public Iterator getEPackagesIterator   () { return _EPackagesByName.values().iterator(); }
//   public Iterator getClientEcoreResourcesIterator() { return _ClientEcoreResourcesByEcoreName.getResources().iterator(); }


//    public EClassMap getEClassMapByEcoreName(String ePackageName, String eClassName, String ExtraName)
//     { 
//       String Name = MakeMapName(ePackageName, eClassName, ExtraName);
//       return (EClassMap) _EClassMapsByEcoreName.get(Name);
//     }

//    public Resource getClientEcoreResource(String clientEcoreName){
//   return _ClientEcoreResourcesByEcoreName.getResource(URI.createURI(clientEcoreName), true);
//    }
    
//    public ResourceSet getClientEcoreResourceSet()
//    {
//       return _ClientEcoreResourcesByEcoreName;
//    }
//
// public String getEMapXMLFileNameForEPackage(String ePackageName)
// {
//    return (String) eMapXMLFileNamesByEPackage.get(ePackageName);
// }
// public String getEMapResourceNameForEPackage(String ePackageName)
// {
//    return (String) eMapResourceNamesByEPackage.get(ePackageName);
// }



/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
///  A D D E R S    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
/////////////////////////////////////////////////////////////////////////////////////////////////////////////     
   public boolean addEPackage(EPackage EP, boolean Replace)
    {
      EPackage Dupe = (EPackage) _EPackagesByNames.get(EP.getName());
      if (Dupe != null)
       {
         if (Replace == false)
          {
            Streamer.error.Header().println("EPackage '"+EP.getName() + "' already exists. Cannot add.");
            return false;
          }
         removeEPackageMap(Dupe.getName());
       }
      
      _EPackagesByNames.put(EP.getName(), EP);
      Iterator I = EP.getEClassifiers().iterator();
      while (I.hasNext() == true)
       {
         EClass EC = (EClass) I.next();
         if (addEClass(EC, Replace) == false)
          {
            removeEPackage(EP.getName());
            return false;
          }
       }
      return true;
    }
    
   public boolean addEClass(EClass EC, boolean Replace)
    { 
      EClass DupeEC = (EClass) _EClassesByEPackageAndEClassNames.get(MakeMapName(EC));
      if (DupeEC != null && Replace==false)
       {
         Streamer.error.Header().println("Adding an EClass with a duplicate Complex name '"+MakeMapName(EC)+"'.");
         return false;
       }
      _EClassesByEPackageAndEClassNames.put(MakeMapName(EC), EC);
      return true;
    }

   public boolean addEPackageMap(EPackageMap EPM, boolean Replace)
    {
      EPackageMap Dupe = (EPackageMap) _EPackageMapsByName.get(EPM.getName());
      if (Dupe != null)
       {
         if (Replace == false)
          {
            Streamer.error.Header().println("EPackageMap '"+EPM.getName() + "' already exists. Cannot add.");
            return false;
          }
         removeEPackageMap(Dupe.getName());
       }
      
      _EPackageMapsByName.put(EPM.getName(), EPM);
      EPM.setUniverse(this);
      Iterator I = EPM.getEClassMapsByJavaComplexName().values().iterator();
      while (I.hasNext() == true)
       {
         EClassMap ECM = (EClassMap) I.next();
         if (addEClassMap(ECM, Replace) == false)
          {
            removeEPackageMap(EPM.getName());
            return false;
          }
       }
      return true;
    }

   // Adding an EClassMap to an EPackageMap and the universe
   public boolean addEClassMap(EPackageMap EPM, EClassMap ECM, boolean Replace)
    {
      if (ECM.getEPackageName().equals(EPM.getName()) == false)
       {
         Streamer.error.Header()
                 .println("Adding EClassMap '"+ECM.getJavaComplexName()
                         +"' to EPackageMap '"+EPM.getName()
                         +"', but EClassMap is from EPackageMap '"+ECM.getEPackageName()+".");
         return false;
       }
      EClassMap Dupe = (EClassMap) EPM.getEClassMapsByJavaComplexName().get(ECM.getJavaComplexName());
      if (Dupe != null && Replace==false)
       {
         Streamer.error.Header().println("Adding an EClassMap '"+ECM.getJavaComplexName()+"' that already exists in EPackageMap '"+EPM.getName()+"'.");
         return false;
       }
      EPM.getEClassMapsByJavaComplexName().put(ECM.getJavaComplexName(), ECM);
      return addEClassMap(ECM, Replace);
    }

   // Adding an EClassMap to the universe only (EClassMap is assumed to already be in the EPackageMap)
   public boolean addEClassMap(EClassMap ECM, boolean Replace)
    { 
      EClassMap Dupe = (EClassMap) _EClassMapsByExport.get(ECM.getExport());
      if (Dupe != null && Replace==false)
       {
         Streamer.error.Header().println("Adding a mapping with a duplicate Export name '"+ECM.getExport()+"'.");
         return false;
       }
      _EClassMapsByExport.put(ECM.getExport(), ECM);
      
      Dupe = (EClassMap) _EClassMapsByJavaComplexName.get(ECM.getJavaComplexName());
      if (Dupe != null && Replace==false)
       {
         Streamer.error.Header().println("Adding a mapping with a duplicate Complex Java name '"+ECM.getJavaComplexName()+"'.");
         return false;
       }
      _EClassMapsByJavaComplexName.put(ECM.getJavaComplexName(), ECM);

      String Key = MakeMapName(ECM.getEPackageName(), ECM.getECoreComplexName());
      Dupe = (EClassMap) _EClassMapsByECoreComplexName.get(Key);
      if (Dupe != null && Replace==false)
       {
         Streamer.error.Header().println("Adding a mapping with a duplicate Complex ECore name '"+Key+"'.");
         return false;
       }
      _EClassMapsByECoreComplexName.put(Key, ECM);
      
//      String Key = MakeMapName(ECM.getEPackageName(), ECM.getEClassName());
//      EClass DupeEC = (EClass) _EClassesByEPackageAndEClassNames.get(Key);
//      if (DupeEC != null && Replace==false)
//       {
//         Streamer.error.Header().println("Adding a mapping with a duplicate name '"+Key+"'.");
//         return false;
//       }
//      _EClassesByEPackageAndEClassNames.put(Key, ECM.getEClass());
      
      ECM.setUniverse(this);
      return true;
    }

/*
   public EClassMap addEClassMap(EClassMap M)     
    { 
      //EClassMap Dupe = (EClassMap) _EClassMapsByEcoreName.put(M.getEcoreName(), M);
      EPackageMap EPM = (EPackageMap)_EPackageMapsByName.get(M.getEPackageName());
      String ComplexName = M.getComplexName(); //(M.getEPackageName(), M.getEClassName(), M.getExtraName());
      EClassMap Dupe = (EClassMap)EPM.getEClassMaps().put(ComplexName, M);
      if (Dupe != null)
       {
         Streamer.error.Header().println("Adding a mapping with a duplicate name '"+M.getEcoreName()+"'.");
         //return (EClassMap) _EClassMapsByEcoreName.put(Dupe.getEcoreName(), Dupe);
         return (EClassMap) EPM.getEClassMaps().put(ComplexName, Dupe);
       }
      Dupe = (EClassMap) _EClassMapsByExport.put(M.getExport(), M);
      if (Dupe != null)
       {
         Streamer.error.Header().println("Adding a mapping with a duplicate export '"+M.getExport()+"'.");
         return (EClassMap) _EClassMapsByExport.put(Dupe.getExport(), Dupe);
       }
      if (M.getComplexName() != null)
       {
         Dupe = (EClassMap) _EClassMapsByComplexName.put(M.getComplexName(), M);
       }
      if (Dupe != null)
       {
         Streamer.error.Header().println("Adding a mapping with a duplicate app_class '"+M.getComplexName()+"'.");
         return (EClassMap) _EClassMapsByComplexName.put(Dupe.getComplexName(), Dupe);
       }
      M.setUniverse(this);
      return null;
    }
*/
//   public EClassifier addEClassifier(EClassifier C)
//    {
//      String Key = MakeMapName(C);
//      EClass Dupe = (EClass) _EClassesByEcoreName.put(Key, C);
//      if (Dupe != null)
//       {
//         Streamer.error.Header().println("Adding an EClassifier with a duplicate name '"+Key+"'.");
//         return (EClass) _EClassesByEcoreName.put(Key, Dupe);
//       }
//      return null;
//    }
    
//   public EPackageMap addEPackageMap(EPackageMap P)
//    {
//      return addEPackageMap(P, false);
//    }
    
     
//    public EPackage addClientEcoreResource(String clientEcoreName, Resource clientEcoreResource) {
//       boolean ok = _ClientEcoreResourcesByEcoreName.getResources().add(clientEcoreResource);
//       if (!ok)
//        {
//          Streamer.error.Header().println("Adding a Client Ecore Resource named '"+clientEcoreName + "' failed.");
//        }
//       return null;
//    }
//
// public void addEMapResourceNameForEPackage(String ePackageName, String eMapResourceName)
//    {
//    eMapResourceNamesByEPackage.put(ePackageName, eMapResourceName);     
//  }
//
// public void addEMapXMLFileNameForEPackage(String ePackageName, String eMapXMLFileName) {
//    eMapXMLFileNamesByEPackage.put(ePackageName, eMapXMLFileName);          
// }


/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
///  R  E  M  O  V  E  R  S    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
/////////////////////////////////////////////////////////////////////////////////////////////////////////////     

   public void removeEPackage(String ePackageName)
    {
      EPackage EP = (EPackage) _EPackagesByNames.remove(ePackageName);
      if (EP != null)
       {
         Iterator I = EP.getEClassifiers().iterator();
         while (I.hasNext() == true)
          {
            EClass EC = (EClass) I.next();
            removeEClass(EC);
          }
       }
    } 

   public void removeEClass(EClass EC)
    {
      _EClassesByEPackageAndEClassNames.remove(MakeMapName(EC));      
    }
    
    

   // This method completely removes an EPackageMap and its EClassMaps from the universe.
   public void removeEPackageMap(String ePackageName)
    {
      EPackageMap EPM = (EPackageMap) _EPackageMapsByName.remove(ePackageName);
      if (EPM != null)
       {
         Iterator I = EPM.getEClassMapsByJavaComplexName().values().iterator();
         while (I.hasNext() == true)
          {
            EClassMap ECM = (EClassMap) I.next();
            removeEClassMap(EPM, ECM);
          }
       }
    } 

   public void removeEClassMap(EClassMap ECM)
    {
      EPackageMap EPM = (EPackageMap) _EPackageMapsByName.get(ECM.getEPackageName());
      removeEClassMap(EPM, ECM);
    }

//   public void removeEClassifier(EClassifier C)
//    {
//      _EClassesByEcoreName.remove(C.getEPackage().getName() + _ESEPERATOR + C.getName());
//    }


   // This method cleans up an EClassMap from an EPackageMap, and the universe.
   // The code assumes that the EClassMap supplied does belong to the EPackageMap 
   // supplied.
   protected void removeEClassMap(EPackageMap EPM, EClassMap ECM)
    {
      //LDH-NOTE: Currently, cross EPackage references are not allowed (EClass CA in 
      //  EPackage PA cannot reference EClass CB in EPackage PB), so we have no problems 
      //  with dangling references. If the support is added thie methos should be looked 
      //  into. 
      EPM.getEClassMapsByJavaComplexName().remove(ECM.getJavaComplexName()); 
      _EClassMapsByExport.remove(ECM.getExport());
      _EClassMapsByJavaComplexName .remove(ECM.getJavaComplexName());
      _EClassMapsByECoreComplexName.remove(MakeMapName(ECM.getEPackageName(), ECM.getECoreComplexName()));
      removeEClass(ECM.getEClass());
    }



/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
///  O  T  H  E  R     M  E  T  H  O  D  S    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////   
/////////////////////////////////////////////////////////////////////////////////////////////////////////////     
     
    public void PrintEClassMapByEcoreName()
     { 
       Streamer.debug.Header().println("Printing the list of EClasses in the ECoreName map");
       Iterator I1 = _EPackageMapsByName.values().iterator();
       while (I1.hasNext() == true)
        {
          EPackageMap EPM = (EPackageMap) I1.next();
          Streamer.debug.Header().println("EPackageMap: "+EPM.getName());
          Iterator I2 = EPM.getEClassMapsByJavaComplexName().values().iterator();
          while (I2.hasNext() == true)
           {
            EClassMap ECM = (EClassMap) I2.next();             
            Streamer.debug.Header().println("   EClassMap: "+ECM.getJavaComplexName()+" / "+ECM.getECoreComplexName()+" / "+ECM.getExport());
           }            
        }
        
//       Iterator I = _EClassMapsByEcoreName.keySet().iterator();
//       while (I.hasNext()== true)
//        {
//          String Key = (String) I.next();
//          Streamer.debug.Header().println("   "+Key);
//        }
     }

    
   public boolean Verify()
    {
      boolean OK = true;
      Iterator I = _EPackageMapsByName.values().iterator();
      while (I.hasNext() == true)
       {
         EPackageMap EPM = (EPackageMap) I.next();
         Streamer.status.println()
                 .Header().println("Verifying Mappings for EPackage "+EPM.getName()+".");
         if (EPM.Verify(_Error) == false)
          {
            Streamer.error.Header().println("Mappings for "+EPM.getName()+" failed verification.");
            OK = false;
          }
       }
      if (OK == false)
       {
         Streamer.error.println()
                 .Header().println("The universe verification failed with "+_Error.getValue()+" errors.");
       }
      return OK;
    }


   protected static final String _ESEPARATOR = "`";
   public static String MakeMapName(EClassifier EC)
    {
      return MakeMapName(EC.getEPackage().getName(), EC.getName());
    }
   public static String MakeMapName(String EPackageName, String EClassName)
    {
      return EPackageName+_ESEPARATOR+EClassName;
    }


//   public boolean hasReference(EClassMap m) {
//      return false;
//   }

//   public void removeEClassMap(EClassMap m, boolean b) {
//      
//   }
/**
 * @return
 */
public ResourceSet getClientEcoreResSet() {
	return clientEcoreResSet;
}

/**
 * @param set
 */
public void setClientEcoreResSet(ResourceSet set) {
	clientEcoreResSet = set;
}

public void addClientEcoreResource(Resource res) {
	clientEcoreResSet.getResources().add(res);
}

 }
