/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.odcb.jrender.mediators.gen.ecore;

import java.io.PrintWriter;

import com.ibm.odcb.jrender.mediators.gen.WDO4JSMappings;
import com.ibm.odcb.jrender.misc.IntWrapper;
import com.ibm.odcb.jrender.misc.Streamer;


public class CalculateAttribute extends EFeatureMap
{

    /**
     * Constructor for CalculateAttribute.
     * @param eAttributeName
     * @param isID
     * @param Export
     * @param calculateExpression
     * @param calculatedType
     */
    public CalculateAttribute(
        String eAttributeName,
        boolean isID,
        String calculateExpression,
        String calculatedType)
    {
        super(
            eAttributeName,
            isID,
            calculateExpression,
            calculatedType);
    }
    
  //override this method to avoid errors due to _EFeature and _Get being null
  public boolean Verify(EClassMap M, WDO4JSMappings Universe, IntWrapper Error)
  {
    boolean ok = true;
    Streamer.status.Header().println("Verifying the CalculateAttribute '"+_EFeatureName+"''.");
    if ( _CalculateExpression == null || _CalculateExpression.trim().equals("") )
    {
      Streamer.error.Header().println("The Expression for CalculateAttribute '"+_EFeatureName+"'' cannot be null or empty.");
      ok = false;
      Error.increment();
    }  
    if ( _CalculatedType == null || _CalculatedType.trim().equals("") )
    {
      Streamer.error.Header().println("The Calculated Type CalculateAttribute '"+_EFeatureName+"'' cannot be null or empty.");
      ok = false;
      Error.increment();
    }
    if (ok)
      Streamer.status.Header().println("Verified the CalculateAttribute '"+_EFeatureName+"'': the expression is '" + _CalculateExpression + "' ; the type is '" + _CalculatedType + "'");

    return ok;
  }

  //override this method to avoid errors due to _EFeature and _Get being null
  protected boolean resolveEType( EClassMap M, WDO4JSMappings Universe, IntWrapper Error ) 
  {
    return true;
  }
  
  /**
   * @deprecated - this method will be removed in Version Version 5.1.2
   */
  public PrintWriter printXML(PrintWriter out)
  {
	out.println("      <CalculateAttribute attribute_name=\""+_EFeatureName+"\" expression=\""+_CalculateExpression+"\" type=\""+_CalculatedType+"\" iD=\"false\" />");
	return out;
  }
}
