/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

package com.ibm.odcb.jrender.mediators.gen.generators;

import java.io.IOException;
import java.io.Writer;
import java.util.Iterator;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EDataType;

import com.ibm.odcb.jrender.mediators.gen.ecore.EClassMap;
import com.ibm.odcb.jrender.mediators.gen.ecore.EFeatureMap;
import com.ibm.odcb.jrender.misc.TypesUtil;
import com.ibm.odcb.jrender.diff.DiffHelper;


public class ClientECoreGenerator
 {
   /*
    * @deprecated
    */
   public static void genDateEDataType(Writer out, String beginLine, String endLine, String escape, String name) 
    throws IOException{
	//Out.write(BeginLine+"  <eClassifiers xsi:type="+Escape+"ecore:EDataType"+Escape+" name="+Escape+name+Escape+" instanceClassName="+Escape+"java.util.Date"+Escape+"/>"+EndLine);
	 StringBuffer sb = new StringBuffer();
	 genDateEDataType(sb, beginLine, endLine, escape, name);
	 out.write(sb.toString());
   }
   /*
    * @deprecated
    */ 
   public static void GenOutro(Writer out, Iterator eClassMapsIterator, String beginLine, String endLine, String escape)
   throws IOException
    {
	  /*t.write(BeginLine+"  <eClassifiers xsi:type="+Escape+"ecore:EClass"+Escape+" name="+Escape+DiffHelper.DIFF_ECLASS_NAME+Escape+">"+EndLine
	           +BeginLine+"    <eReferences name="+Escape+DiffHelper.CURRENT_EFEATURE_NAME+Escape+" eType="+Escape+"#//"+DiffHelper.CLIENT_ROOT_ECLASS_NAME+Escape+" lowerBound="+Escape+"1"+Escape+" upperBound="+Escape+"1"+Escape+" containment="+Escape+"true"+Escape+"/>"+EndLine
		       +BeginLine+"    <eReferences name="+Escape+DiffHelper.ORIGINAL_EFEATURE_NAME+Escape+" eType="+Escape+"#//"+DiffHelper.CLIENT_ROOT_ECLASS_NAME+Escape+" lowerBound="+Escape+"1"+Escape+" upperBound="+Escape+"1"+Escape+" containment="+Escape+"true"+Escape+"/>"+EndLine
		       +BeginLine+"  </eClassifiers>"+EndLine
               +BeginLine+"  <eClassifiers xsi:type="+Escape+"ecore:EClass"+Escape+" name="+Escape+"ClientRoot"+Escape+">"+EndLine);
	  //loop through exported EClassifiers and add to EReferences for Current and Original
	  while (EClassMapsIterator.hasNext() == true)
	   {
	     EClassMap M = (EClassMap) EClassMapsIterator.next();
	     Out.write(BeginLine+"    <eReferences name="+Escape+""+M.getExport()+""+Escape+" eType="+Escape+""+CUSTOM_ETYPE_PREFIX+M.getExport()+""+Escape+" lowerBound="+Escape+"0"+Escape+" upperBound="+Escape+"-1"+Escape+" containment="+Escape+"false"+Escape+"/>"+EndLine);
	   }
	  Out.write(BeginLine+"  </eClassifiers>"+EndLine
               +BeginLine+"</ecore:EPackage>"+EndLine);
      */
      
      StringBuffer sb = new StringBuffer();
      genOutro(sb, eClassMapsIterator, beginLine, endLine, escape);
      out.write(sb.toString());
      
    }
	    
   /*
    * @deprecated
    */
   public static void GenEClassifier(Writer out, EClassMap m, String beginLine, String endLine, String escape)
   throws IOException
    {
	  /*Out.write(BeginLine+"  <eClassifiers xsi:type="+Escape+"ecore:EClass"+Escape+" name="+Escape+""+M.getExport()+""+Escape+">"+EndLine
	           +BeginLine+"    <eAttributes name="+Escape+""+EFeatureMap.ODYSSEY_STATUS_FEATURE+""+Escape+" eType="+Escape+"ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EChar"+Escape+"/>"+EndLine
	           +BeginLine+"    <eAttributes name="+Escape+""+EFeatureMap.ODYSSEY_ID_FEATURE+""+Escape+" eType="+Escape+"ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"+Escape+"/>"+EndLine
	           +BeginLine+"    <eAttributes name="+Escape+""+EFeatureMap.XMI_ID_FEATURE+""+Escape+" eType="+Escape+"ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"+Escape+"/>"+EndLine);
	  Iterator it = M.getEFeatureMapIterator();
	  while (it.hasNext() == true)
	   {
		 EFeatureMap ME = (EFeatureMap) it.next();
		 if ( !ME.isCalculateAttribute() )
		  {
		    String s="";
		    String c="";
		    String t="";
		    if (ME.isReference() && ME.getReferenceMap() != null)
		     {
			   s="eReferences";
			   c=" containment="+Escape+""+ME.isContainment()+""+Escape+"";
		     }
		    else
		     {
			   s="eAttributes";
		     }
            t=ME.getEFeatureType();
            if (TypesUtil.isBasicEDataType(t) == true)
		     {
				if (t.equals("WDODate"))
				  t=CUSTOM_ETYPE_PREFIX+t;
				else if (t.equals("WDOBigDecimal"))
				  t=ETYPE_PREFIX+"EDoubleObject";
				else if (t.equals("EJavaObject"))
				  t=ETYPE_PREFIX+"EString";
				else
				  t=ETYPE_PREFIX+t;
		     }
		    else 
		     {
		     	String eType = TypesUtil.getEDataTypeFromJavaType(t);
			   if (eType!=null)
			    {
				    t=ETYPE_PREFIX+eType;
			    }
			   else
			    {
				  //Check to see if it's user defined type.
				  EClassMap refMap = ME.getReferenceMap();
				  if (refMap == null)
				   {
					 boolean typeAsString = true;
					 //Check if it's an EDataType of java.util.Date
                     if (ME.getEFeature() != null)
                      {
                        EClassifier ec = ME.getEFeature().getEType() ;
					    if (ec instanceof EDataType)
					     {
						   String type = TypesUtil.getSimplifiedTypeFromJavaType(ME.getGetType());
						   if (type.equals("date"))
						    {
						      t=CUSTOM_ETYPE_PREFIX+TypesUtil.getRealETypeName(ME.getEFeature().getEType());
						      typeAsString = false;
						    }
                         }
					  }
				     //this is not part of the ecore.  Must treat this as an eAttribute of type String
				     s="eAttributes";
				     c="";
				     if (typeAsString)
				       t=ETYPE_PREFIX+"EString";
				   }
				  else
				   {
				     t=CUSTOM_ETYPE_PREFIX+ME.getReferenceMap().getExport();
				   }
			    }
		     }
            Out.write(BeginLine+"    <"+s+" name="+Escape+""+ME.getEFeatureName()+""+Escape
                                         +" eType="+Escape+""+t+Escape
                                         +" lowerBound="+Escape+""+(ME.getEFeature()==null?0:ME.getEFeature().getLowerBound())+Escape
                                         +" upperBound="+Escape+""+(ME.getEFeature()==null?1:ME.getEFeature().getUpperBound())+Escape
                                         +c+"/>"+EndLine);
	      }
       }
	  Out.write(BeginLine+"  </eClassifiers>"+EndLine);
	  */
	  
	  StringBuffer sb = new StringBuffer();
	  genEClassifier(sb, m, beginLine, endLine, escape);
	  out.write(sb.toString());
	  
    }
	    
   /*
    * @deprecated
    */
   public static void GenIntro(Writer out, EClassMap m, String beginLine, String endLine, String escape)
   throws IOException
    {
		/*Out.write(BeginLine+"<?xml version="+Escape+"1.0"+Escape+" encoding="+Escape+"UTF-8"+Escape+"?>"+EndLine
                 +BeginLine+"<ecore:EPackage xmi:version="+Escape+"2.0"+Escape+" xmlns:xmi="+Escape+"http://www.omg.org/XMI"+Escape+" "
                                      +"xmlns:xsi="+Escape+"http://www.w3.org/2001/XMLSchema-instance"+Escape+" xmlns:ecore="+Escape+"http://www.eclipse.org/emf/2002/Ecore"+Escape+" xmlns:odc="+Escape+"http://www.ibm.com/Odyssey"+Escape
                                      +" name="+Escape+""+M.getEPackageName()+Escape
                                      +" nsURI="+Escape+""+M.getClientEcoreName()+Escape
                                      +" nsPrefix="+Escape+M.getEClass().getEPackage().getNsPrefix()+Escape+">"+EndLine);
        */
		StringBuffer sb = new StringBuffer();
        genIntro(sb, m, beginLine, endLine, escape);
        out.write(sb.toString());	                                      
    }
	    
   public static void genIntro(StringBuffer sb, EClassMap m, String beginLine, String endLine, String escape)
   throws IOException
    {
		sb.append(beginLine).append("<?xml version="+escape+"1.0"+escape)
		  .append(" encoding="+escape+"UTF-8"+escape+"?>")
		  .append(endLine)
		  .append(beginLine)
		  .append("<ecore:EPackage xmi:version="+escape+"2.0"+escape)
		  .append(" xmlns:xmi="+escape+"http://www.omg.org/XMI"+escape)
		  .append(" xmlns:xsi="+escape+"http://www.w3.org/2001/XMLSchema-instance"+escape)
		  .append(" xmlns:ecore="+escape+"http://www.eclipse.org/emf/2002/Ecore"+escape)
		  .append(" xmlns:odc="+escape+"http://www.ibm.com/Odyssey"+escape)
		  .append(" name="+escape+""+m.getEPackageName()+escape)
		  .append(" nsURI="+escape+""+m.getClientEcoreName()+escape)
		  .append(" nsPrefix="+escape+m.getEClass().getEPackage().getNsPrefix()+escape+">")
		  .append(endLine);                                      
    }
    
   protected final static String ETYPE_PREFIX = "ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//";
   protected final static String CUSTOM_ETYPE_PREFIX = "#//";
   protected final static String WDO_ETYPE_PREFIX = "ecore:EDataType http://ibm.com/wdo#//";
   
   public static void genEClassifier(StringBuffer sb, EClassMap m, String beginLine, String endLine, String escape)
   throws IOException
    {
	  sb.append(beginLine)
	    .append("  <eClassifiers xsi:type="+escape+"ecore:EClass"+escape)
		.append(" name="+escape+""+m.getExport()+""+escape+">")
	    .append(endLine)
		.append(beginLine)
		.append("    <eAttributes name="+escape+""+EFeatureMap.ODYSSEY_STATUS_FEATURE+""+escape)
		.append(" eType="+escape+"ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EChar"+escape+"/>")
		.append(endLine).append(beginLine)
		.append("    <eAttributes name="+escape+""+EFeatureMap.ODYSSEY_ID_FEATURE+""+escape)
		.append(" eType="+escape+"ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"+escape+"/>")
		.append(endLine).append(beginLine)
		.append("    <eAttributes name="+escape+""+EFeatureMap.XMI_ID_FEATURE+""+escape)
		.append(" eType="+escape+"ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"+escape+"/>")
		.append(endLine);
		
	  Iterator it = m.getEFeatureMapIterator();
	  while (it.hasNext() == true)
	   {
		 EFeatureMap ME = (EFeatureMap) it.next();
		 if ( ME.isReference() || ME.isID() || (!ME.isCalculateAttribute() && ME.getSetter() != null)  )
		  {
		    String s="";
		    String c="";
		    String t="";
		    if (ME.isReference() && ME.getReferenceMap() != null)
		     {
			   s="eReferences";
			   c=" containment="+escape+""+ME.isContainment()+""+escape+"";
		     }
		    else
		     {
			   s="eAttributes";
		     }
            t=ME.getEFeatureType();
            if (TypesUtil.isBasicEDataType(t) == true)
		     {
				if (t.equals("WDODate"))
				  t=CUSTOM_ETYPE_PREFIX+t;
				else if (t.equals("WDOBigDecimal"))
				  t=WDO_ETYPE_PREFIX+"WDOBigDecimal";
				else if (t.equals("EJavaObject"))
				  t=ETYPE_PREFIX+"EString";
				else
				  t=ETYPE_PREFIX+t;
		     }
		    else 
		     {
		     	String eType = TypesUtil.getEDataTypeFromJavaType(t);
			   if (eType!=null)
			    {
				    t=ETYPE_PREFIX+eType;
			    }
			   else
			    {
				  //Check to see if it's user defined type.
				  EClassMap refMap = ME.getReferenceMap();
				  if (refMap == null)
				   {
					 boolean typeAsString = true;
					 //Check if it's an EDataType of java.util.Date
                     if (ME.getEFeature() != null)
                      {
                        EClassifier ec = ME.getEFeature().getEType() ;
					    if (ec instanceof EDataType)
					     {
						   String type = TypesUtil.getSimplifiedTypeFromJavaType(ME.getGetterType());
						   if (type.equals("date"))
						    {
						      t=CUSTOM_ETYPE_PREFIX+TypesUtil.getRealETypeName(ME.getEFeature().getEType());
						      typeAsString = false;
						    }
                         }
					  }
				     //this is not part of the ecore.  Must treat this as an eAttribute of type String
				     s="eAttributes";
				     c="";
				     if (typeAsString)
				       t=ETYPE_PREFIX+"EString";
				   }
				  else
				   {
				     t=CUSTOM_ETYPE_PREFIX+ME.getReferenceMap().getExport();
				   }
			    }
		     }
		     
            sb.append(beginLine)
			  .append("    <"+s+" name="+escape+""+ME.getEFeatureName()+""+escape)
			  .append(" eType="+escape+""+t+escape)
			  .append(" lowerBound="+escape+""+(ME.getEFeature()==null?0:ME.getEFeature().getLowerBound())+escape)
			  .append(" upperBound="+escape+""+(ME.getEFeature()==null?1:ME.getEFeature().getUpperBound())+escape+c+"/>")
			  .append(endLine);
	      }
       }
       
	  sb.append(beginLine+"  </eClassifiers>").append(endLine);
	  
    }
   
   public static void genOutro(StringBuffer sb, Iterator eClassMapsIterator, String beginLine, String endLine, String escape)
   throws IOException
    {
	  sb.append(beginLine)
	    .append("  <eClassifiers xsi:type="+escape+"ecore:EClass"+escape+" name="+escape+DiffHelper.DIFF_ECLASS_NAME+escape+">")
		.append(endLine).append(beginLine)
		.append("    <eReferences name="+escape+DiffHelper.CURRENT_EFEATURE_NAME+escape+" eType="+escape+"#//"+DiffHelper.CLIENT_ROOT_ECLASS_NAME+escape+" lowerBound="+escape+"1"+escape+" upperBound="+escape+"1"+escape+" containment="+escape+"true"+escape+"/>")
		.append(endLine).append(beginLine)
		.append("    <eReferences name="+escape+DiffHelper.ORIGINAL_EFEATURE_NAME+escape+" eType="+escape+"#//"+DiffHelper.CLIENT_ROOT_ECLASS_NAME+escape+" lowerBound="+escape+"1"+escape+" upperBound="+escape+"1"+escape+" containment="+escape+"true"+escape+"/>")
		.append(endLine).append(beginLine)
		.append("  </eClassifiers>").append(endLine).append(beginLine)
		.append("  <eClassifiers xsi:type="+escape+"ecore:EClass"+escape+" name="+escape+"ClientRoot"+escape+">")
		.append(endLine);
		
	  //loop through exported EClassifiers and add to EReferences for Current and Original
	  while (eClassMapsIterator.hasNext() == true)
	   {
	     EClassMap M = (EClassMap) eClassMapsIterator.next();
	     sb.append(beginLine)
		   .append("    <eReferences name="+escape+""+M.getExport()+""+escape)
		   .append(" eType="+escape+""+CUSTOM_ETYPE_PREFIX+M.getExport()+""+escape+" lowerBound="+escape)
		   .append("0"+escape+" upperBound="+escape+"-1"+escape+" containment="+escape+"false"+escape+"/>")
		   .append(endLine);
	   }
	  
	  sb.append(beginLine).append("  </eClassifiers>").append(endLine).append(beginLine).append("</ecore:EPackage>").append(endLine);
    }

  public static void genDateEDataType(StringBuffer sb, String beginLine, String endLine, String escape, String name) 
    throws IOException{
    	//output should look like the following; the value for name is dynamic
		//<eClassifiers xsi:type="ecore:EDataType" name="Date" instanceClassName="java.util.Date"/>
	sb.append(beginLine)
	  .append("  <eClassifiers xsi:type="+escape)
	  .append("ecore:EDataType"+escape+" name="+escape+name+escape)
	  .append(" instanceClassName="+escape+"java.util.Date"+escape+"/>")
	  .append(endLine);
  }
 }
