/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////


package com.ibm.odcb.jrender.mediators.gen.generators;

import java.io.Writer;
import java.util.HashMap;
import java.util.Iterator;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EDataType;

import com.ibm.odcb.jrender.mediators.MediatorFactory;
import com.ibm.odcb.jrender.mediators.gen.ecore.EPackageMap;
import com.ibm.odcb.jrender.mediators.gen.ecore.EClassMap;
import com.ibm.odcb.jrender.mediators.gen.ecore.EFeatureMap;
import com.ibm.odcb.jrender.misc.Config;
import com.ibm.odcb.jrender.misc.Streamer;
import com.ibm.odcb.jrender.misc.StringUtil;
import com.ibm.odcb.jrender.misc.TypesUtil;

/**
* @author ldh
*
* To change this generated comment edit the template variable "typecomment":
* Window>Preferences>Java>Templates.
* To enable and disable the creation of type comments go to
* Window>Preferences>Java>Code Generation.
*/
public class Object_to_WDO4JS_as_JS_compact extends Generator
{
public static final String COPYRIGHT = com.ibm.odcb.utilities.IBMCopyright.SHORT_COPYRIGHT;

////#IF# SDO
public static final String ODC_SDO_SUPPORT = "SDO";
////#END#

////#IF# WDO
//public static final String ODC_SDO_SUPPORT = "WDO";
////#END#

public static final String ODC_SDO_SUPPORT_VAR = "var ODC_SDO_SUPPORT=\\\""+ODC_SDO_SUPPORT+"\\\";";
public static final String _KEY = "_wdo4js_js";
public String getIdentifier() { return _KEY; }

public void PrintVersionHistory(Writer Out)
{
  try
  {
   Out.write("// Object to JavaScript-WDO4JS Mediator: version 1.\n");
   Out.write("//\n");
   Out.write("//  1   : - Supports references and unicity\n");
   Out.write("//        - Mediators to generic Java classes (through public member variables, explitic and generic gets/sets)\n");
   Out.write("//        - Supports List or Iterator member variables for multiplicity\n");
   Out.write("//        - Supports aliasing\n");
   Out.write("//        - Generate automatic primary keys\n");
   Out.write("//\n");
  }
  catch (java.io.IOException e)
  {
    e.printStackTrace();
  }
}


/*  Example of compact JavaScript API code to gen
var PosClass = new EClass("Pos");
PosClass.addEReferences( [ ["Usr", UClass,1,1,0] , ["Port", PortClass,0,1,1] );   /*[Symbol,Type,Calc,lowerBound,UpperBound]
PosClass.addEAttributes( [ ["Symbol", "string"] , ["Price", "float"] , ["Quantity", "int"] ] );
*/
public void GenSchema(Writer Out, EClassMap M)
{
  try
  {
    //Adam's New EPackage Stuff for JWL 2.1
    String EP = M.getEPackageName()+"_Package";	// EPackage JS var name
    String exp = M.getExport();
    String EC = M.getExport()+"Class";			// EClass JS var name
     
    //Encoding variables for portal
    //Out.write("		FacesContext facesContext = FacesContext.getCurrentInstance();\n");
    Out.write("		boolean isFaces = StringUtil.checkEncoding();\n");
    Out.write("		String model_var = StringUtil.encodeString(\"WDO4JSMR_\"+Ctx.getLastModelName(),isFaces); \n");
    Out.write("		String var = StringUtil.encodeString(\""+exp+"\",isFaces);\n");
    Out.write("		String bean_var = StringUtil.encodeString(\""+M.getEPackageName()+"\",isFaces);\n");
    Out.write("		String class_var = StringUtil.encodeString(\""+exp+"Class\",isFaces);\n");
    Out.write("		String schema_var=StringUtil.encodeString(\"WDO4JSModel_\"+Ctx.getSchemaExportName(),isFaces);\n");
    Out.write("		String encoded_a=StringUtil.encodeString(\"A\",isFaces);\n");
    Out.write("		String encoded_r=StringUtil.encodeString(\"R\",isFaces);\n");
    Out.write("		String encoded_XT1=StringUtil.encodeString(\"XTOTOX1\",isFaces);\n");
    Out.write("		String encoded_XT2=StringUtil.encodeString(\"XTOTOX2\",isFaces);\n");
    Out.write("		String package_var = StringUtil.encodeString(\""+EP+"\",isFaces);\n");
    Out.write("		String root_var= StringUtil.encodeString(\"WDO4JSModelRoot_\"+Ctx.getLastModelName(),isFaces);\n");
   
   //TGupta Note:  Seperate Model and XMILoader into two variables
   //Model will be named WDO4JSModel_<AppclassName>
   //XMILoader will be named WDO4JSModelRoot_<ModelName>
   //this way, each instance of the same bean exported will share the model
   //but will have it's own XMILoader.
  
   Out.write("       boolean FirstTime = Ctx.isFirstSchemaExport();\n");
   Out.write("       if (FirstTime == true)\n");
   Out.write("       	{\n");
   Out.write("          Out.write(\"<script type=\\\"text/javascript\\\"> "+ODC_SDO_SUPPORT_VAR+" var \"+encoded_a+\"; var \"+encoded_XT1+\"=\"+encoded_a+\";\"+ encoded_a+\"=new ECreator().AddEAs; var \"+encoded_r+\"; var \"+encoded_XT2+\"=\"+encoded_r+\";\");\n" );
   Out.write("			Out.write(encoded_r+\"=new ECreator().AddERs; \");\n");
   Out.write("          Out.write(\"var \"+schema_var); Out.write(\"=new EClass(\\\"\");\n" );
   Out.write("			Out.write(model_var); Out.write(\"\\\");\\n\");\n");
   
   Out.write("          Out.write(\"var \"+package_var+\"=new EPackage(\\\"\"+bean_var+\"\\\");\\n\");\n");

   EPackageMap EPM = M.getEPackageMap();
   //Adding the Client Data Event handlers and source
   if(EPM.getJSURI() != null){
   	// must find more efficient way to do this to minimize script blocks
    Out.write("          URLRewriter R = (URLRewriter) Ctx.getContextVariable(InitializationEmitter._ID_URL_REWRITER);\n");
   	Out.write("          Out.write(\"</script><script type=\\\"text/javascript\\\" src=\\\"\" + R.Rewrite(\"" + EPM.getJSURI() + "\") + \"\\\"></script>\\n\");\n");
   	Out.write("          Out.write(\"<script type=\\\"text/javascript\\\">\");\n");
   }
   if( EPM.getOnCreate() != null){
   	Out.write("          Out.write(\"package_var+\".addHandler(\\\"ONCREATE\\\",\\\""+EPM.getOnCreate()+"\\\");\\n\");\n");
   }
   if( EPM.getOnDelete() != null){
   	Out.write("          Out.write(\"package_var+\".addHandler(\\\"ONDELETE\\\",\\\""+EPM.getOnDelete()+"\\\");\\n\");\n");
   }
   if( EPM.getOnUpdate() != null){
   	Out.write("          Out.write(\"package_var+\".addHandler(\\\"ONUPDATE\\\",\\\""+EPM.getOnUpdate()+"\\\");\\n\");\n");
   }
   //End Client Data Event Handler code
   
   Out.write("        }\n");
   Out.write("\n");
   Out.write("       Out.write(\"var \"+class_var+\"=new EClass(\\\"\"+var+\"\\\","+(M.isDiffOnRefresh()?1:0)+");\"); \n");
   //this call also sets pointer to EPackage in EClass
   Out.write("		Out.write(package_var+\".addMemberEClass(\"+class_var+\");\\n\");\n");
   Out.write("      Out.write(encoded_r+\"(\"+schema_var+\",[[\\\"\"+var+\"\\\",\"+class_var+\",0,-1,0,0]]);\\n\");\n");
   Out.write("\n");
   Iterator I = M.getEFeatureMapIterator();
   StringBuffer EAttributesParams = new StringBuffer(128);
   //the third parameter is to indicate iD attribute 1:true; 0:false
   EAttributesParams.append("[[\\\"xmi:id\\\",\\\"id\\\",0]");
   StringBuffer EReferencesParams = new StringBuffer(128);
   HashMap KnownTypes = new HashMap(17);
   while (I.hasNext() == true)
    {
     EFeatureMap EFM = (EFeatureMap) I.next();
     String GetterStr = EFeatureMap.CleanupGetterSetter(EFM.getGetter());
     if ( EFM.isCalculateAttribute() )
     {
       //EAttributesParams.append(",[\\\""+ME.getExport()+"\\\",\\\""+ME.getCalculatedType()+"\\\",1,\\\""+ME.getCalculateExpression()+"\\\","+((int)(ME.isID()?1:0))+"]");
	   EAttributesParams.append(",[\\\""+EFM.getExport()+"\\\",\\\""+EFM.getCalculatedType()+"\\\",1,"+StringUtil.QuoteDoubleAndEscape(EFM.getCalculateExpression(),true)+","+((int)(EFM.isID()?1:0))+"]");
     }
     else
     {
      String Type = TypesUtil.getSimplifiedTypeFromJavaType(EFM.getGetterType());
      Streamer.debug.Header().println("Found type '"+Type+"' for '"+GetterStr+"' from '"+M.getExport()+"'.");
      if (Type != null)
       {
         EAttributesParams.append(",[\\\""+EFM.getExport()+"\\\",\\\""+Type+"\\\",0,"+(EFM.getEFeature()==null?0:EFM.getEFeature().getLowerBound())+","+(EFM.getEFeature()==null?1:EFM.getEFeature().getUpperBound())+","+((int)(EFM.isID()?1:0))+","+(EFM.getSetter()==null?1:0)+"]");
       }
      // If this is not a common type, then it must be a custom type, and therefore, there must be a reference
      else 
       {
         EClassMap MR = EFM.getReferenceMap();
         if (MR != null)
         {
           if (KnownTypes.put(EFM.getEFeatureType(), "A") == null)
            {
              Out.write("       super.ExportSchema(Out, Ctx, \""+MediatorFactory.GenTypeKey(MR.getJavaComplexName(),_KEY)+"\", null);\n");
            }
           EReferencesParams.append(",[\\\""+EFM.getExport()+"\\\",\" + StringUtil.encodeString(\""+MR.getExport()+"Class\",isFaces)+\","+ (EFM.getEFeature()==null?0:EFM.getEFeature().getLowerBound())+","+(EFM.getEFeature()==null?1:EFM.getEFeature().getUpperBound())+","+((int)(EFM.isContainment()?1:0))+","+((int)(EFM.isID()?1:0))+","+(EFM.getSetter()==null?1:0)+"]");
         }
         else
         {
           boolean typeAsString = true;
           //Check if it's an EDataType of java.util.Date
           EClassifier ec = EFM.getEFeature().getEType() ;
		   if (ec instanceof EDataType)
			{
				Type = TypesUtil.getSimplifiedTypeFromJavaType(EFM.getGetterType());
				if (Type != null)
				if (Type.equals("date"))
				{
				  EAttributesParams.append(",[\\\""+EFM.getExport()+"\\\",\\\""+Type+"\\\",0,"+(EFM.getEFeature()==null?0:EFM.getEFeature().getLowerBound())+","+(EFM.getEFeature()==null?1:EFM.getEFeature().getUpperBound())+","+((int)(EFM.isID()?1:0))+","+(EFM.getSetter()==null?1:0)+"]");
				  typeAsString = false;
				}
				
			}
			if (typeAsString)
			{               
             //TGupta Note: This is a reference, but the referenced object is not in the universe.  
             //We will treat this as a String by calling a toString() on the object during data export.
             //so this will be treated as an attribute of type String and not a reference.
             EAttributesParams.append(",[\\\""+EFM.getExport()+"\\\",\\\""+"string"+"\\\",0,"+(EFM.getEFeature()==null?0:EFM.getEFeature().getLowerBound())+","+(EFM.getEFeature()==null?1:EFM.getEFeature().getUpperBound())+","+((int)(EFM.isID()?1:0))+","+(EFM.getSetter()==null?1:0)+"]");
			}
         }
       }
      }
    }

   Out.write("\n");
   
   Out.write("       Out.write(encoded_a+\"(\"+class_var+\","+EAttributesParams.toString()+"]);\\n\");\n");

   if (EReferencesParams.length() != 0)
    {
   	
      EReferencesParams.setCharAt(0, '[');
      Out.write("       Out.write(encoded_r+\"(\"+class_var+\","+EReferencesParams.toString()+"]);\\n\");\n");
    }
   
   Out.write("\n");
 
   // Even though this is JavaScript, we use the same JSL class XMILoader to load the data...
   Out.write("       if (FirstTime == true)\n");
   Out.write("        { \n ");
   Out.write("      	Out.write(\"var \"+root_var); Out.write(\"=new XMILoader(\"+schema_var); Out.write(\", '\"+var+\"', '"+M.getClientEcoreName()+"');\\n\");\n");  
   Out.write("          Out.write(encoded_a+\"=\"+encoded_XT1+\";\"+encoded_r+\"=\"+encoded_XT2+\";</script>\\n\");\n");
   Out.write("        }\n");
  }
  catch (java.io.IOException e)
  {
    e.printStackTrace();
  }
}

/*   public void genXMILoaderExport(Writer Out, EClassMap M)
{
 try
 {
   Out.write("public void exportXMILoader(Writer Out, PageContext Ctx) throws ExportException)");
   Out.write("{");
   Out.write("       boolean FirstTime = Ctx.isFirstSchemaExport();\n");
   Out.write("       if (FirstTime == true)\n");
   Out.write("       {\n");
   Out.write("          Out.write(\"<SCRIPT>\");\n");
   Out.write("          Out.write(\"var WDO4JSModelRoot_\"); Out.write(Ctx.getLastModelName()); Out.write(\"=new XMILoader(WDO4JSModel_\"); Out.write(\""+M.getAppClassName()+"\"); Out.write(\", '"+M.getExport()+"', '"+M.getClientEcoreName()+"');\\n\");\n");
   Out.write("          Out.write(\"</SCRIPT>\\n\");\n");
   Out.write("        }\n");
   Out.write("}");
 }
 catch (java.io.IOException e)
 {
  e.printStackTrace();
 }
}*/

/*
var Port2 = EFactory.create(PortClass);
var Pos56 = EFactory.create(PosClass);
ECreator.Init(Pos56, ["390","MACR","14.75","284"], [U1,Port2, S51]);
ECreator.Init(Port2, ["PJ portfolio 1"], [U1,[ Pos3,Pos5,Pos7,Pos9,Pos11,Pos13,Pos15]]);
*/
protected final int     MEDIATOR_DEBUG_MODE = Config.getInteger(Config.PROP_MEDIATOR_DEBUG_MODE);
protected final String  HEADER= MEDIATOR_DEBUG_MODE == 1 ? "\n                +\"\\n    ," : "\n                +\",";
public void GenData(Writer Out, EClassMap M)
{
  try
  {
  	//Encoding for portal
  	//Out.write(" 		FacesContext facesContext = FacesContext.getCurrentInstance();\n");
  	Out.write("		boolean isFaces = StringUtil.checkEncoding();\n");
  	
  	//Encode parameter
  	Out.write("			Var= StringUtil.encodeString(Var,isFaces);\n");
  	
  	//Encode variables
  	Out.write(" 		String root_var= StringUtil.encodeString(\"WDO4JSModelRoot_\"+Ctx.getLastModelName(),isFaces);\n");
  	Out.write(" 		String var = StringUtil.encodeString(\""+M.getExport()+"\",isFaces);\n");
  	Out.write("  		String class_var = StringUtil.encodeString(\""+M.getExport()+"Class\",isFaces);\n");
  	Out.write("  		String schema_var=StringUtil.encodeString(\"WDO4JSModel_\"+Ctx.getSchemaExportName(),isFaces);\n");
  	Out.write("  		String encoded_c=StringUtil.encodeString(\"C\",isFaces);\n");
  	Out.write("  		String encoded_i=StringUtil.encodeString(\"I\",isFaces);\n");
    Out.write("  		String encoded_XT1=StringUtil.encodeString(\"XTOTOX1\",isFaces);\n");
    Out.write("  		String encoded_XT2=StringUtil.encodeString(\"XTOTOX2\",isFaces);\n");
	 
    Out.write("       	boolean FirstTime = Ctx.isFirstDataExport();\n");
    Out.write("       	if (FirstTime == true)\n");
    
    Out.write("        	Out.write(\"<script type=\\\"text/javascript\\\"> var \"+encoded_c+\"; var \"+encoded_XT1+\"=\"+encoded_c+\"; \"+encoded_c+\"=new EFactory().create; var \"+encoded_i+\"; var \"+encoded_XT2+\"=\"+encoded_i+\"; \"+encoded_i+\"=new ECreator().Init;\\n\");\n");
    Out.write("			\n");
    Out.write("       	if (Obj == null)\n");
    Out.write("        	{\n");
    Out.write("          	Out.write(\"var \"+Var+\" = null;\");\n");
    Out.write("          	return;\n");
    Out.write("        	}\n");
    Out.write("       	Out.write(\"var \"+Var+\" = \"+encoded_c+\"(\"+class_var+\");\");\n");
    Out.write("       	//Counter for arrays \n \t\t int arrLen=0;");

   /////////////////////////////////////////////////////////////////////////////////////////////////////////////
   // Output all the referenced vars first, if any
   Out.write("\n");
   Iterator I = M.getEFeatureMapIterator();
   int i = -1;
   while (I.hasNext() == true)
    {
     ++i;
     EFeatureMap EFM = (EFeatureMap) I.next();
     String GetterStr = EFeatureMap.CleanupGetterSetter(EFM.getGetter());
     if ( !EFM.isCalculateAttribute() )
     {
      if (EFM.getReferenceMap() != null)
       {
         if (!EFM.isMany() && !TypesUtil.isGeneralList(EFM.getGetterType()) )
          {
            Out.write("       String "+EFM.getReferenceMap().getExport()+"Var"+i+"= Mediator.ExportData(Out, Ctx, Obj."+GetterStr+", \""+MediatorFactory.GenTypeKey(EFM.getReferenceMap().getJavaComplexName(),_KEY)+"\", DebugMode);\n");
          }
         else
          {
            Out.write("       Mediator.ExportData(Out, Ctx, Obj."+GetterStr+", \""+MediatorFactory.GenTypeKey(EFM.getReferenceMap().getJavaComplexName(),_KEY)+"\", DebugMode);\n");
            Out.write("       String "+EFM.getReferenceMap().getExport()+"Var"+i+"= Ctx.PopArrayVar(\""+MediatorFactory.GenTypeKey(EFM.getReferenceMap().getJavaComplexName(),_KEY)+"\");\n");
          }
       }
     }
    }

   /////////////////////////////////////////////////////////////////////////////////////////////////////////////
   // Output the main oject with either in-place values, or references to the vars output just above, if any
   StringBuffer EAttributesParams = new StringBuffer(128);
   StringBuffer EReferencesParams = new StringBuffer(128);

   I = M.getEFeatureMapIterator();
   i = -1;
   while (I.hasNext() == true)
    {
      ++i; 
      EFeatureMap EFM = (EFeatureMap) I.next();
      String GetterStr = EFeatureMap.CleanupGetterSetter(EFM.getGetter());
      if (EFM.getReferenceMap() != null)
       {
         String VarStr = EFM.getReferenceMap().getExport()+"Var"+i;
         
         //Parse VarStr and encode each element in it before reassembling them
         Out.write("      String[] varArr"+i+"=StringUtil.splitToArray("+VarStr+",',');\n");  
         Out.write("      "+VarStr+"=\"\";\n");  
         Out.write("      for(arrLen=0;arrLen<varArr"+i+".length;arrLen++)\n");
         Out.write("      {\n");  
         Out.write("	    if("+VarStr+".length()!=0)\n");
         Out.write("	       "+VarStr+"="+VarStr+".concat(\",\");\n");
         Out.write("	    "+VarStr+"="+VarStr+".concat(StringUtil.encodeString(varArr"+i+"[arrLen],isFaces));\n");
         Out.write("      }\n");  
         
         if (EFM.isMany() == false)
          {
            // there is a funny behavior difference between IE and Netscape. Let's say you call a function
            // as follows: f(,,,); In IE, getting the number of parameters returns 4, whereas in Netscape,
            // we get 3. In order to avoid this difference, the last parameter, if empty, should be 
            // explicitely set to null: f(,,,null);
         	EReferencesParams.append(HEADER+"\"+"+(I.hasNext() ? VarStr : "("+VarStr+".length() == 0 ? \"null\":"+ VarStr+")"+(MEDIATOR_DEBUG_MODE == 1 ? " +\"/*"+EFM.getExport()+"*/\"":"")));
            //EReferencesParams.append(",\"+"+ME.getReferenceMap().getExport()+"Var"+i+"+\"");
          }
         else
          {
            EReferencesParams.append(HEADER+"\"+("+VarStr+"==null?\"null\":\"[\"+"+VarStr+"+\"]\")"+(MEDIATOR_DEBUG_MODE == 1 ? " +\"/*"+EFM.getExport()+"*/\"":""));
            //EReferencesParams.append(",[\"+"+ME.getReferenceMap().getExport()+"Var"+i+"+\"]");
          }             
       }
      else // this is not a reference
       {
         if (EFM.isCalculateAttribute()==false)
          {
		    String GetType = EFM.getGetterType();
            char OutputType = TypesUtil.getOutputTypeFromJavaType(GetType);
		    if (TypesUtil.isGeneralList(GetType) == true)  // Arrays, Collections, Lists, ArrayLists
             {
               if (TypesUtil.isArrayOfBasicJavaType(GetType, true) == true)
                EAttributesParams.append(HEADER+"\"+ Mediator.constructArrayString(Obj."+GetterStr+")"+(MEDIATOR_DEBUG_MODE == 1 ? " +\"/*"+EFM.getExport()+"*/\"":""));
               else                      
                EAttributesParams.append(HEADER+"\"+ Mediator.constructArrayString(Obj."+GetterStr+",'"+OutputType+"')"+(MEDIATOR_DEBUG_MODE == 1 ? " +\"/*"+EFM.getExport()+"*/\"":""));                      
		     }
		    else  // This is not a list or array, so we are in single basic types, primitive or boxed
		     {
               //!!!!! ################################################## !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!11
               // LDH-NOTE: There is similar, but very different code in Mediator.FormatBasicTypeOutput. Keep in synch.
               //          Need to look at a way to consolidate
               //!!!!! ################################################## !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!11
               if (OutputType == TypesUtil.TypeInfo._DATE_OUT)
                {
                  EAttributesParams.append(HEADER+"\"+(Obj."+GetterStr+" == null?-1:Obj."+GetterStr+".getTime())"+(MEDIATOR_DEBUG_MODE == 1 ? " +\"/*"+EFM.getExport()+"*/\"":""));
                }
               else if (OutputType == TypesUtil.TypeInfo._CHAR_OUT)
                {
                  EAttributesParams.append(HEADER+"'\"+Obj."+GetterStr+"+\"'\""+(MEDIATOR_DEBUG_MODE == 1 ? " +\"/*"+EFM.getExport()+"*/\"":""));
                }
               else if (OutputType == TypesUtil.TypeInfo._STRING_OUT || OutputType == TypesUtil.TypeInfo._DEFAULT_OUT)
                {
                  // LDH-NOTE: when writing any object in Java, toString() is automatically involved when necesssary. 
                  //          We don't need to push it out, and most importantly, that allows us to deal with NULL 
                  //          pointers automatically as well. For this reason, DEFAULT and STRING cases have been
                  //          combined.
                  EAttributesParams.append(HEADER+"\"+com.ibm.odcb.jrender.misc.StringUtil.QuoteDoubleAndEscape(Obj."+GetterStr+",false, true)"+(MEDIATOR_DEBUG_MODE == 1 ? " +\"/*"+EFM.getExport()+"*/\"":""));
                }
               else
                {
                  EAttributesParams.append(HEADER+"\"+Obj."+GetterStr+""+(MEDIATOR_DEBUG_MODE == 1 ? " +\"/*"+EFM.getExport()+"*/\"":""));
                }
		     }
          }
       }
    }
   Out.write("       Out.write(encoded_i+\"(\"+Var+\",[\\\"\"+Var+\"\\\"\""+EAttributesParams.toString()+"\n                +\"],[\"");
   if (EReferencesParams.length() > 0)
    {
      EReferencesParams.setCharAt(HEADER.length()-1, ' ');
      Out.write(EReferencesParams.toString());
    }
   Out.write("+\"]);\\n\");\n");
   Out.write("\n");

   Out.write("        if (FirstTime == true)\n");
   Out.write("        {  \n" );
   Out.write("  		 Out.write(root_var); Out.write(\".Root.eAdd('\"+var+\"', \"+Var+\");\"); \n");
   Out.write("           Out.write(encoded_c+\"=\"+encoded_XT1+\";\"+encoded_i+\"=\"+encoded_XT2+\";</script>\\n\");\n ");
   Out.write("        }  \n ");
  }			  							
  catch (Exception e)
  {
    Streamer.error.Header().printStackTrace(e);
  }
}   

}