/////////////////////////////////////////////////////////////////////////
//  IBM Confidential
//  
//  OCO Source Materials
//  
//  PID xxxx-xxx
//  
//   Copyright IBM Corp.  2003
//  
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////


package com.ibm.odcb.jrender.mediators.gen.generators;

import java.io.Writer;
import java.util.HashMap;
import java.util.Iterator;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EDataType;

import com.ibm.odcb.jrender.mediators.MediatorFactory;
import com.ibm.odcb.jrender.mediators.gen.ecore.EClassMap;
import com.ibm.odcb.jrender.mediators.gen.ecore.EFeatureMap;
import com.ibm.odcb.jrender.misc.Streamer;
import com.ibm.odcb.jrender.misc.TypesUtil;
 
/**
 * @author ldh
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Object_to_WDO4JS_as_XMI extends Generator
 {
   public static final String COPYRIGHT = com.ibm.odcb.utilities.IBMCopyright.SHORT_COPYRIGHT;
   /**
    * This is the location of the generated ecore files.  This will be part of 
    * the URI that appear in the xmlns tag to identify the EPackage in an XMI document.
    */
   public static final String ECORE_NSURI_PATH = "bin/com/ibm/odcb/wdo4jsmediators/";
 
////#IF# SDO
//   public static final String ODC_SDO_SUPPORT = "SDO";
////#END#

////#IF# WDO
   public static final String ODC_SDO_SUPPORT = "WDO";
////#END#
   
   public static final String ODC_SDO_SUPPORT_VAR = "var ODC_SDO_SUPPORT=\\\""+ODC_SDO_SUPPORT+"\\\";";
   
   public String getArrayVarDelimiter()  { return " ";  }

   public static final String _KEY = "_wdo4js_xmi";
   public String getIdentifier() { return _KEY; }
   
   protected final static String _BlockBegin = /*"<?xml version=\\\\\\\"1.0\\\\\\\" encoding=\\\\\\\"utf-8\\\\\\\" ?>"
                                              +*/"<xmi:XMI xmi:version=\\\\\\\"2.0\\\\\\\" xmlns:xmi=\\\\\\\"http://www.omg.org/XMI\\\\\\\">"
                                              +"  <xmi:Documentation>"
                                              +"  <exporter>Odyssey XMI Serializer</exporter>"
                                              +"  <exporterVersion>1.0</exporterVersion>"
                                              +"  </xmi:Documentation>";
                                              
//   private String escape = "\\\\\\\"";
                                             
   protected final static String _ETypePrefix = "ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//";
   protected final static String _CustomTypePrefix = "#//";
   
   public void PrintVersionHistory(Writer Out)
    {
      try
      {
       Out.write("// Object to XMI-WDO4JS Mediator: version 1.\n");
       Out.write("//");
       Out.write("//  1 : - Supports references and unicity\n");
       Out.write("//      - Mediator to generic Java classes (through public member variables, explitic and generic gets/sets)\n");
       Out.write("//      - Supports ArrayList member variables for multiplicity\n");
       Out.write("//      - No support for XMI Schema yet\n");
      }
      catch (java.io.IOException e)
      {
        e.printStackTrace();
      }
    }
    
   public void GenSchema(Writer Out, EClassMap ECM)
    {   
     try
     {
      String BeginLine= "         Out.write(\"+\\\"";
      String EndLine  = "\\\"\\n\");\n";
      String Escape   = "\\\\\\\"";
      String dateTypeName = "";
      String filesource = ECM.getXMLFileSource();
      
      Out.write("       boolean FirstTime = (Ctx.getExportedSchemaCount()<=0);\n");
	  Out.write("       boolean exportDateEDataType = (Ctx.isExportDateEDataType());\n");
      Out.write("       if (FirstTime == true)\n");
      Out.write("       {\n");
      Out.write("         Out.write(\"<script type=\\\"text/javascript\\\"> "+ODC_SDO_SUPPORT_VAR+" var ecoreSchema = \\\"\\\"\");\n");
      ClientECoreGenerator.GenIntro(Out, ECM, BeginLine, EndLine, Escape);
      Out.write("       }\n");
      Out.write("\n");
      
	  ClientECoreGenerator.GenEClassifier(Out, ECM, BeginLine, EndLine, Escape);

      Out.write("\n");
      Out.write("       Ctx.addToExportedSchemaList(\""+ECM.getExport()+"\");\n");
      //loop through the EReferences and recursively export schema for those not already exported
	  Iterator it = ECM.getEFeatureMapIterator();
      HashMap KnownTypes = new HashMap(17);
	  while (it.hasNext() == true)
	   {
         EFeatureMap ME = (EFeatureMap) it.next();
		 if (ME.isReference() && ME.getReferenceMap() != null && KnownTypes.put(ME.getEFeatureType(), "A") == null)
		  {
            Out.write("       super.ExportSchema(Out, Ctx, \""+MediatorFactory.GenTypeKey(ME.getReferenceMap().getJavaComplexName(),_KEY)+"\", null);\n");
		  }
         //Check if it's an EDataType of java.util.Date
         if (ME.getEFeature() != null)
         {
		   EClassifier ec = ME.getEFeature().getEType() ;
		   if (ec instanceof EDataType)
		    {
			  String type = TypesUtil.getSimplifiedTypeFromJavaType(ME.getGetterType());
			  if (type != null)
			  if (type.equals("date"))
			  {
				dateTypeName = ME.getEFeatureType();
				Out.write("       Ctx.setExportDateEDataType(true);\n");
              }
		    }
		  }
      }
      Out.write("       if (FirstTime == true)\n");
      Out.write("       {\n");
      //add the EDataType entry for Date if needed
	  Out.write("         if (Ctx.isExportDateEDataType())\n");
	  Out.write("         {\n");
	  ClientECoreGenerator.genDateEDataType(Out,BeginLine,EndLine,Escape,dateTypeName);
	  Out.write("         }\n");
      //create Diff EClassifier
	  Iterator It = ECM.getUniverse().getEClassMapsForEPackageIterator(ECM.getEPackageName());
	  ClientECoreGenerator.GenOutro(Out, It, BeginLine, EndLine, Escape);
	  Out.write("         Out.write(\";</script>\\n\");\n");
      Out.write("       }\n");
     }
     catch (java.io.IOException e)
     {
       e.printStackTrace();
     }
    }

   // LDH-NOTE: Testing stuff here. Whether flat or nested data is better. We need to make a choice.
   public boolean NestedMode = false;
   public void GenData(Writer Out, EClassMap ECM)
    {
      if (NestedMode == true)
       GenDataNested(Out, ECM);
      else
       GenDataFlat(Out, ECM);
    }
	
   public void GenDataFlat(Writer Out, EClassMap ECM)
    {
     try
     {
      Out.write("       boolean FirstTime = Ctx.isFirstDataExport();\n");
      Out.write("       if (FirstTime == true)\n");
      Out.write("         Out.write(\"<script type=\\\"text/javascript\\\"> var InstanceData = \\\""+_BlockBegin+"\\\"\\n\");\n");
      Out.write("\n");
	  Out.write("       StringWriter InnerOut = new StringWriter(256);\n");
	  //Out.write("       Writer  InnerOut  = new Writer(InnerData);\n");
	  Out.write("\n");

      Iterator I = ECM.getEFeatureMapIterator();
	  boolean multiCardinal = false;
      int i = -1;
      while (I.hasNext() == true)
       {
        ++i;
        EFeatureMap EFM = (EFeatureMap) I.next();
        String GetterStr = EFeatureMap.CleanupGetterSetter(EFM.getGetter());        
        if ( !EFM.isCalculateAttribute() )
        {
         if (EFM.getReferenceMap() != null)
          {
            if (!EFM.isMany() && !TypesUtil.isGeneralList(EFM.getGetterType()))
             {
               Out.write("       String "+EFM.getReferenceMap().getExport()+"Var"+i+"= Mediator.ExportData(Out, Ctx, Obj."+GetterStr+", \""+MediatorFactory.GenTypeKey(EFM.getReferenceMap().getJavaComplexName(),_KEY)+"\", DebugMode);\n");
             }
            else
             {
               Out.write("       Mediator.ExportData(Out, Ctx, Obj."+GetterStr+", \""+MediatorFactory.GenTypeKey(EFM.getReferenceMap().getJavaComplexName(),_KEY)+"\", DebugMode);\n");
               Out.write("       String "+EFM.getReferenceMap().getExport()+"Var"+i+"= Ctx.PopArrayVar(\""+MediatorFactory.GenTypeKey(EFM.getReferenceMap().getJavaComplexName(),_KEY)+"\");\n");
             }
          }
		  else
		  {	
			if (EFM.isMany() && (TypesUtil.isBasicJavaType(EFM.getGetterType()) || TypesUtil.isArrayOfBasicJavaType(EFM.getGetterType(),false)))
			{
				//the data has to be exported similar to the ereferences
				multiCardinal = true;
				//TGupta NOTE: support list types containing base object types
				//if (TypesUtil.isGeneralList(ME.getGetType()) )
				//{
				   if (TypesUtil.isCollection(EFM.getGetterType()))
					 Out.write("       InnerOut.write(Mediator.constructArrayStringAsXMI(\""+EFM.getExport()+"\", Obj."+GetterStr+".iterator()));\n");
				   else
					 Out.write("       InnerOut.write(Mediator.constructArrayStringAsXMI(\""+EFM.getExport()+"\", Obj."+GetterStr+"));\n");			  
				//}
			}
		  }
        }
       }

      /////////////////////////////////////////////////////////////////////////////////////////////////////////////
      // Output the main oject with either in-place values, or references to the vars output just above, if any
	  Out.write("\n");
	  Out.write  ("       String InnerText = InnerOut.toString();\n");
      Out.write  ("       Out.write(\" + \\\"<"+ECM.getExport()+" xmi:id=\\\\\\\"\"+Var+\"\\\\\\\"");
      I = ECM.getEFeatureMapIterator();
      i = -1;
      while (I.hasNext() == true)
       {
        ++i;
        EFeatureMap EFM = (EFeatureMap) I.next();
        String GetterStr = EFeatureMap.CleanupGetterSetter(EFM.getGetter());        
        if ( !EFM.isCalculateAttribute() )
        {
         if (EFM.getReferenceMap() != null)
          {
            Out.write(" "+EFM.getExport()+"=\\\\\\\"\"+"+EFM.getReferenceMap().getExport()+"Var"+i+"+\"\\\\\\\"");
          }
         else
          {
			String GetType = EFM.getGetterType();
			char TheType = TypesUtil.getOutputTypeFromJavaType(GetType);
         	//TGupta NOTE: support list types containing base object types
          	if (!(EFM.isMany() && (TypesUtil.isBasicJavaType(EFM.getGetterType()) || TypesUtil.isArrayOfBasicJavaType(EFM.getGetterType(),false))))
          	{         		
             if (TheType == TypesUtil.TypeInfo._DEFAULT_OUT || ( TheType != TypesUtil.TypeInfo._NUMBER_OUT && TheType != TypesUtil.TypeInfo._BOOL_OUT) )
              {
                //TGupta-NOTE: If TheType is blank, a toString() must be attempted here for the code to compile
                if (TheType == TypesUtil.TypeInfo._DATE_OUT)
                {
					Out.write(" "+EFM.getExport()+"=\\\\\\\"\"+(Obj."+GetterStr+" == null?-1:Obj."+GetterStr+".getTime())+\"\\\\\\\"");
                }
// LDH-NOTE: when writing any object in Java, toString() is automatically involved when necesssary. 
//          We don't need to push it out, and most importantly, that allows us to deal with NULL 
//          pointers automatically as well. 
				else if (TheType == ' ')
                  Out.write(" "+EFM.getExport()+"=\"+com.ibm.odcb.jrender.misc.StringUtil.QuoteDoubleAndEscapeForXML(Obj."+GetterStr+".toString(),true)+\"");
//TGupta Note: Support primitive arrays here output as ="[1,2,3]"
                else if (TypesUtil.isArrayOfBasicJavaType(EFM.getGetterType(),true))
                {
					Out.write(" "+EFM.getExport()+"=\"+Mediator.constructArrayString(Obj."+GetterStr+")+\"");
                }
                else
                  Out.write(" "+EFM.getExport()+"=\"+com.ibm.odcb.jrender.misc.StringUtil.QuoteDoubleAndEscapeForXML(Obj."+GetterStr+",true)+\"");
              }
             else
              {
				if (TypesUtil.isArrayOfBasicJavaType(EFM.getGetterType(),true))
				{
					Out.write(" "+EFM.getExport()+"=\"+Mediator.constructArrayString(Obj."+GetterStr+")+\"");
				}
				else
    	            Out.write(" "+EFM.getExport()+"=\\\\\\\"\"+Obj."+GetterStr+"+\"\\\\\\\"");
              }
          	}

          }
        }
       }
      //Out.write("/>\\\"\");\n");
	  if (multiCardinal == false)
	   {
		 Out.write("/>\\\"\\n\");\n");
	   }
	  else
	   {
		 Out.write("\"+(InnerText.length() == 0 ? \"/>\" : \">\")+\"\\\"\\n\");\n");
		 Out.write("       if (InnerText.length() != 0) { Out.write(\" + \\\"\" + InnerText + \"\\\"\");\n");
		 Out.write  ("       Out.write(\" + \\\"</"+ECM.getExport()+">\\\"\\n\"); }");
	   }


      Out.write("\n");
      Out.write("       if (FirstTime == true)\n");
      Out.write("        { Out.write(\"+\\\"</xmi:XMI>\\\";\\n\");\n");
      Out.write("          Out.write(\"WDO4JSModelRoot_\"+Ctx.getLastModelName()+\".LoadXMIString(InstanceData); \");  \n");
	  Out.write("          Out.write(\" </script>\\n\"); }\n");
     }
     catch (Exception e)
     {
       Streamer.error.Header().printStackTrace(e);
     }
    }

 
//LDH-NOTE: This is an attempt at pushing out a nested XMI document instead of a flattened format. It doesn't seem
//         to work and:
//            1- DCUT is so near
//            2- This was done to solve our Root problem, which was solved in a more elegant, and performing way

   public void AddOtherImports(Writer Out)
    {
      try
      {
        Out.write("import java.io.StringWriter;\n");
        //Out.write("import com.ibm.odcb.jrender.misc.IntWrapper;\n");
      }
      catch (java.io.IOException e)
      {
        e.printStackTrace();
      }
    } 
   public void GenDataNested(Writer Out, EClassMap ECM)
    {
     try
     {
      Out.write("       boolean FirstTime = Ctx.isFirstDataExport();\n");
      Out.write("       if (FirstTime == true)\n");
      Out.write("        {\n");
      Out.write("          Out.write(\"<script type=\\\"text/javascript\\\"> var InstanceData = \\\""+_BlockBegin+"\\\"\\n\");\n");
      Out.write("          if (Ctx.getContextVariable(\"DEBUG_MODE\") != null)\n");
      Out.write("           {\n");
      Out.write("             Ctx.addContextVariable(\"XMI_MEDIATOR_NESTING_LEVEL\", new com.ibm.odcb.jrender.misc.IntWrapper(0));\n");
      Out.write("           }\n");
      Out.write("        }\n");
      Out.write("       com.ibm.odcb.jrender.misc.IntWrapper Nesting = (com.ibm.odcb.jrender.misc.IntWrapper) Ctx.getContextVariable(\"XMI_MEDIATOR_NESTING_LEVEL\");\n");
      Out.write("       if (Nesting != null) Nesting.increment();\n");
      Out.write("\n");

      Iterator I = ECM.getEFeatureMapIterator();
	  boolean SomeReference = false;
      int i = -1;

      Out.write("       StringWriter InnerOut = new StringWriter(256);\n");
      //Out.write("       Writer  InnerOut  = new Writer(InnerData);\n");
      Out.write("       String LineHeader = Nesting==null ? \"\" : com.ibm.odcb.jrender.misc.StringUtil.getPad(Nesting.getValue());\n");
      Out.write("\n");
      while (I.hasNext() == true)
       {
        ++i;
        EFeatureMap EFM = (EFeatureMap) I.next();
        String GetterStr = EFeatureMap.CleanupGetterSetter(EFM.getGetter());                
        if ( !EFM.isCalculateAttribute() )
        {
         if (EFM.getReferenceMap() != null)
          {
            if (!EFM.isMany() && !TypesUtil.isGeneralList(EFM.getGetterType()))
             {
               Out.write("       String "+EFM.getReferenceMap().getExport()+"Var"+i+"= Mediator.ExportData(InnerOut, Ctx, Obj."+GetterStr+", \""+MediatorFactory.GenTypeKey(EFM.getReferenceMap().getJavaComplexName(),_KEY)+"\", DebugMode);\n");
             }
            else
             {
               if (EFM.isContainment() == true)
                {
                  Out.write("       InnerOut.write(LineHeader); InnerOut.write(\"  + \\\"<"+EFM.getExport()+">\\\"\\n\");\n");
                  Out.write("       if (Nesting != null) Nesting.increment(2);\n");
                }
               Out.write("       Mediator.ExportData(InnerOut, Ctx, Obj."+GetterStr+", \""+MediatorFactory.GenTypeKey(EFM.getReferenceMap().getJavaComplexName(),_KEY)+"\", DebugMode);\n");
               if (EFM.isContainment() == true)
                {
                  Out.write("       Ctx.PopArrayVar(\""+MediatorFactory.GenTypeKey(EFM.getReferenceMap().getJavaComplexName(),_KEY)+"\");\n");
                  Out.write("       if (Nesting != null) Nesting.decrement(2);\n");
                  Out.write("       InnerOut.write(LineHeader); InnerOut.write(\"  + \\\"</"+EFM.getExport()+">\\\"\\n\");\n");
                }
               else
                Out.write("       String "+EFM.getReferenceMap().getExport()+"Var"+i+"= Ctx.PopArrayVar(\""+MediatorFactory.GenTypeKey(EFM.getReferenceMap().getJavaComplexName(),_KEY)+"\");\n");
             }
          }
          else
          {
          	if (EFM.isMany() && (TypesUtil.isBasicJavaType(EFM.getGetterType()) || TypesUtil.isArrayOfBasicJavaType(EFM.getGetterType(),false)))
          	{
	  			//TGupta NOTE: support list types containing base object types
				//if (TypesUtil.isGeneralList(ME.getGetType()))
				//{
				   //the data has to be exported similar to the ereferences
				   SomeReference = true;
				   if (TypesUtil.isCollection(EFM.getGetterType()) == true)
					 Out.write("       InnerOut.write(LineHeader); InnerOut.write(Mediator.constructArrayStringAsXMI(Obj."+EFM.getExport()+", Obj."+GetterStr+".iterator()));\n");
				   else
					 Out.write("       InnerOut.write(LineHeader); InnerOut.write(Mediator.constructArrayStringAsXMI(Obj."+EFM.getExport()+", Obj."+GetterStr+"));\n");
					  
				//}
			}
          }
        }
       }

      /////////////////////////////////////////////////////////////////////////////////////////////////////////////
      // Output the main oject with either in-place values, or references to the vars output just above, if any
      Out.write("\n");
      Out.write  ("       String InnerText = InnerOut.toString();\n");
      Out.write  ("       Out.write(LineHeader); Out.write(\" + \\\"<"+ECM.getExport()+" xmi:id=\\\\\\\"\"+Var+\"\\n\\\\\\\"");
      I = ECM.getEFeatureMapIterator();
      i = -1;
      while (I.hasNext() == true)
       {
        ++i;
        EFeatureMap EFM = (EFeatureMap) I.next();
        String GetterStr = EFeatureMap.CleanupGetterSetter(EFM.getGetter());        
        if ( !EFM.isCalculateAttribute() )
        {
         if (EFM.getReferenceMap() != null)
          {
            SomeReference = true;
            if (EFM.isContainment() == false)
             Out.write(" "+EFM.getExport()+"=\\\\\\\"\"+"+EFM.getReferenceMap().getExport()+"Var"+i+"+\"\\\\\\\"");
          }
         else
          {
			String GetType = EFM.getGetterType();
			char TheType = TypesUtil.getOutputTypeFromJavaType(GetType);
			if (!(EFM.isMany() && (TypesUtil.isBasicJavaType(EFM.getGetterType()) || TypesUtil.isArrayOfBasicJavaType(EFM.getGetterType(),false))))
			 {
			   if (TheType == 'D')
			    {
				  Out.write(" "+EFM.getExport()+"=\\\\\\\"\"+(Obj."+GetterStr+" == null?-1:Obj."+GetterStr+".getTime())+\"\\\\\\\"");
				}            
			   else if (TheType == ' ')
                {
                  Out.write(" "+EFM.getExport()+"=\"+com.ibm.odcb.jrender.misc.StringUtil.QuoteDoubleAndEscapeForXML(Obj."+GetterStr+",true)+\"");
                }
//				TGupta Note: Support primitive arrays here output as ="[1,2,3]"
				else if (TypesUtil.isArrayOfBasicJavaType(EFM.getGetterType(),true))
				{
				  Out.write(" "+EFM.getExport()+"=\"+Mediator.constructArrayString(Obj."+GetterStr+")+\"");
				}
				else if (TheType == 'N')
                {
                  Out.write(" "+EFM.getExport()+"=\\\\\\\"\"+Obj."+GetterStr+"+\"\\\\\\\"");
                }
				else
				  Out.write(" "+EFM.getExport()+"=\"+com.ibm.odcb.jrender.misc.StringUtil.QuoteDoubleAndEscapeForXML(Obj."+GetterStr+",true)+\"");
			 }
          }
        }
       }
      if (SomeReference == false)
       {
         Out.write("/>\\\"\");\n");
       }
      else
       {
         Out.write("\"+(InnerText.length() == 0 ? \"/>\" : \">\")+\"\\\"\");\n");
         Out.write("       if (InnerText.length() != 0) { Out.write(\" + \\\"\" + InnerText + \"\\\"\");\n");
         Out.write  ("       Out.write(LineHeader+\" + \\\"</"+ECM.getExport()+">\\\"\\n\"); }");
       }
      Out.write("\n");
      Out.write("       if (Nesting != null) Nesting.decrement();\n");
      Out.write("\n");
      Out.write("       if (FirstTime == true)\n");
      Out.write("        { Out.write(\"+\\\"</xmi:XMI>\\\";\\n\");\n");
      Out.write("          Out.write(\"WDO4JSModelRoot_\"+Ctx.getLastModelName()+\".LoadXMIString(InstanceData); \");  \n");
	  Out.write("          Out.write(\" </script>\\n\"); }\n");
    }
    catch (Exception e)
    {
      Streamer.error.Header().printStackTrace(e);
    }
   }  
 }
