/////////////////////////////////////////////////////////////////////////
//  IBM Confidential
//  
//  OCO Source Materials
//  
//  PID xxxx-xxx
//  
//   Copyright IBM Corp.  2003
//  
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////


/*
 * StreamPump.java
 *
 * Created on December 27, 2000, 11:18 AM
 */

package com.ibm.odcb.jrender.misc;

/**
 *
 * @author  ldh
 * @version 
 */

import java.io.*;

public class AsynchBufferedInputStream extends Thread
 {
   public static final String COPYRIGHT = com.ibm.odcb.utilities.IBMCopyright.SHORT_COPYRIGHT;
   
   public AsynchBufferedInputStream(int SleepTime, int BufferSize)
    {
      _SleepTime  = SleepTime ;
      _BufferSize = BufferSize;
    }

   public void Init(BufferedInputStream In, OutputStream Out)
    {
      _In  = In ;
      _Out = Out;
    }
    
   protected BufferedInputStream _In ;
   protected OutputStream        _Out;

   protected final int _SleepTime ;
   protected final int _BufferSize;

   public void run()
    {
      Streamer.StartThread();
      Streamer.debug.Header().println("AsynchBufferedInputStream starting");
      
      byte[] buf = new byte[_BufferSize];
      int bytesRead;
      try
       {
         while (true)
          {
            bytesRead=_In.read(buf, 0, _BufferSize);
            if (bytesRead == -1)
             break;
            _Out.write(buf, 0, bytesRead);
            try
            {
              Streamer.trace.Header().print("AsynchBufferedInputStream read ").print(_BufferSize).print(" bytes: ").printSubstring(buf, 0, _BufferSize);
            }
            catch (java.lang.StringIndexOutOfBoundsException e){}
            sleep(_SleepTime);
          }
       } 
      catch (InterruptedException e)
       {
         Streamer.error.Header().printStackTrace(e);
       }
      catch (IOException e)
       {
         Streamer.error.Header().printStackTrace(e);
       }
       
      Streamer.debug.Header().println("AsynchBufferedInputStream ending");
      Streamer.EndThread();        
    }
 }
