/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

package com.ibm.odcb.jrender.misc;

import java.io.IOException;
import java.io.InputStream;
/**
 * @author Jianren Li
 * This class is used  to locate a JS resource file by using a classloader
 * from jar files under a subdirectory: ibmjsfres.  This class is more efficient
 * and reliable than NLWebResourceManager.  The latter uses a full http request.
 */
public class NLResourceManager
{
	/*
	FIX FOR CS BUG #50729
	taking out the map as it was breaking wsrp support
	map was used to cache url's for resouce files, but this caused
	local portlets to have remote url when the remote portlet was added
	to the portal server first.
	protected static HashMap _Map = new HashMap(7);
	*/
	
	//This line is used when we use a HTTP request to locate a NL file
	//protected static PageGetter _PG  = new PageGetter();

	private static String PATH_PREFIX = Config.getString(Config.PROP_PATH_PREFIX);

	public synchronized static String getFile(String BaseURL, String rewrittenBaseFileName, String BaseFileName, String Locale, URLRewriter _Rewriter) throws Exception
	{ 	// BaseURL must be of the form "http://<domain name>/..." so that if the
	  	// rewrittenBaseFileName is appended to it, plus locale + ".js", it is potentially a valid
	  	// URL for the resource file.
		
		if(BaseURL == null)
		{	
				return  _Rewriter.Rewrite(rewrittenBaseFileName+'_'+"en.js"); // english is default
		}
		
		/* REMOVE AS PART OF FIX FOR CS BUG #50729
		String Signature    = rewrittenBaseFileName+'%'+Locale;
		String RealFileName = (String) _Map.get(Signature);
		if (RealFileName == null)
		{
			synchronized(_Map)
			{
				RealFileName = (String) _Map.get(Signature);
				if (RealFileName == null)
				{*/
					String RealFileName = null;
					try
					{
						RealFileName = Resolve(BaseURL, rewrittenBaseFileName, BaseFileName, Locale, _Rewriter);
					}
					catch(Exception e)
					{
						Streamer.error.Header().printStackTrace(e);
					}
				/*}
			}
		}*/
		return RealFileName;
	 }

	protected static String Resolve(String BaseUrl, String rewrittenBaseFileName, String BaseFileName, String Locale, URLRewriter _Rewriter) throws Exception
	{
		String L = Locale;
		
		//add version number
		
		rewrittenBaseFileName = rewrittenBaseFileName + "_" + Config.VERSION_NUMBER;
		BaseFileName = BaseFileName + "_" + Config.VERSION_NUMBER;

		
		//BaseFileName looks like: jsl/OdysseyMessage
		//This is used to look up the file using a classloader
		if(PATH_PREFIX!=null && !PATH_PREFIX.equals(""))
		{
		   //.ibmjsfres needs to be changed to ibmjsfres
		   //because .ibmjsfres is mapped a JSResourceServlet and ibmjsfres is a real directory in JSF implementation
		   // THIS WAS REMOVED BECAUSE IT BROKE WSRP SUPPORT
		   if(PATH_PREFIX.startsWith("."))
		   {
		      PATH_PREFIX= PATH_PREFIX.substring(1);
		   }
		   if (BaseFileName.startsWith("/"))
		   {
		      BaseFileName = PATH_PREFIX + BaseFileName;
		   }
		   else
		   {
		      BaseFileName = PATH_PREFIX +"/"+ BaseFileName;
		   }
	    }
		Streamer.debug.Header().println()
									   .println("*****************************************************************************************************************")
									   .println(" **** BaseFileName:"+BaseFileName+" after PATH_PREFIX is appended.")
									   .println("*****************************************************************************************************************")
									   .println();

		String RelativePathFileName = rewrittenBaseFileName+'_'+L+".js";
		
		RelativePathFileName = _Rewriter.Rewrite(RelativePathFileName);
		if (L != null && L.length() == 5) // "xx_XX" format
		{
			try
			{
                //This line is used when we use a HTTP request to locate a NL file
                //_PG.Start(RealFileName, PageGetter.BROWSER_IE_6_0_WIN);
				String BaseFileName1 = BaseFileName+'_'+L+".js";
				getResourceAsStream(BaseFileName1);
				return RelativePathFileName;
			}
			catch (Exception U)
			{
			  	L = L.substring(0, 2);
			}
		}
		if (L != null && L.length() == 2) // "xx" format
		{
			RelativePathFileName = rewrittenBaseFileName+'_'+L+".js";
			String BaseFileName2 = BaseFileName+'_'+L+".js";
			RelativePathFileName = _Rewriter.Rewrite(RelativePathFileName);
			try
			{
                
				getResourceAsStream(BaseFileName2);
				return RelativePathFileName;
				
			}
			catch (Exception U)
			{
				L = null;
			}
		}
		if (L == null || L.length() == 0) // "" format
		{
			RelativePathFileName = rewrittenBaseFileName+".js";
			String BaseFileName3 = BaseFileName+".js";
			RelativePathFileName = _Rewriter.Rewrite(RelativePathFileName);
			try
			{
				getResourceAsStream(BaseFileName3);
				return RelativePathFileName;
			}
		   	catch (Exception U)
			{
			  	Streamer.warning.Header().println()
				               .println("*****************************************************************************************************************")
				               .println(" **** A resource for file '"+rewrittenBaseFileName+"' and locale '"+Locale+"' could not be found.")
				               .println("*****************************************************************************************************************")
				               .println();

				
				return _Rewriter.Rewrite(rewrittenBaseFileName + '_' + "en.js"); // we are returning ENGLISH as default if all fails

			}
		 }
		Streamer.warning.Header().println()
					   .println("*****************************************************************************************************************")
					   .println("Locale "+Locale+" passed in is invalid: it must be 'xx_XX', 'xx', '' or null.")
		               .println("*****************************************************************************************************************")
		               .println();
		
			return  _Rewriter.Rewrite(rewrittenBaseFileName + '_' + "en.js"); // we are returning ENGLISH as default if all fails
	}

	private static  void getResourceAsStream(String uri) throws IOException
	{
		InputStream stream = null;

		stream = ODCClassLoader.getResourceAsStream(uri);

		if (stream == null || stream.available()==0)
		{
			throw new IOException();
		}

	}
}