/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

package com.ibm.odcb.jrender.misc;

import java.io.InputStream;

/**
 * @author ldh
 *
 * This class' methods should be called every time code involves class loaders. This allows various pieces of code
 * in the system, including utilities, to be run in a variety of environments.
 */
public class ODCClassLoader
 {
   private static ClassLoader _CL = ODCClassLoader.class.getClassLoader();

   public static void setClassLoader(ClassLoader CL)
    {
		_CL = CL;
	}
   public static ClassLoader getClassLoader()
    {
	  return _CL;
	}
	
   public static Class getClass(String ClassName)
   throws ClassNotFoundException
    {
	  return _CL.loadClass(ClassName);
    }
    
   public static Object getClassInstance(String ClassName)
   throws ClassNotFoundException, InstantiationException, IllegalAccessException
    {
      return _CL.loadClass(ClassName).newInstance();
    }
	
   public static InputStream getResourceAsStream(String ResourceName)
    {
      return _CL.getResourceAsStream(ResourceName);
	}
 }
