/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.odcb.jrender.misc;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;


public class ObjectSerializer
 {
   public static boolean Write(Object O, File F)
    {
      FileOutputStream fos = null;
      try
       {
         fos = new FileOutputStream(F);
         ObjectOutputStream oos = new ObjectOutputStream(fos);
         oos.writeObject(O);
         oos.flush();
       }
      catch (IOException e)
       {
         Streamer.error.Header().println("ERROR: Cannot serialize the data to the file "+F.getAbsolutePath());
         Streamer.error.Header().printStackTrace(e);
         return false;
       }
      finally
       {
         try
          {
            if (fos != null)
             fos.close();
          }
         catch (IOException e)  // don;t you hate having to do this !!!
          {
            Streamer.error.Header().println("ERROR: Cannot close the output file "+F.getAbsolutePath());
			Streamer.error.Header().printStackTrace(e);
            return false;
          }
       }
      return true;
    }  
    
   public static Object Read(File F)
    {
     FileInputStream is = null;
     try
       {
         is = new FileInputStream(F);
         ObjectInputStream ois = new ObjectInputStream(is);
         return ois.readObject();
       }
      catch (Exception e)
       {
         Streamer.error.Header().println("ERROR: Cannot read the serialized data from the file "+F.getAbsolutePath());
		 Streamer.error.Header().printStackTrace(e);
       }
      finally
       {
         try
          {
            if (is != null)
             is.close();
          }
         catch (IOException e)  // don;t you hate having to do this !!!
          {
            Streamer.error.Header().println("ERROR: Cannot close the input file "+F.getAbsolutePath());
			Streamer.error.Header().printStackTrace(e);
          }
       }
      return null;
    }
 }
