/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

 
package com.ibm.odcb.jrender.misc;

import java.net.*;
import java.io.*;

public class PageGetter extends Object 
 {
   public PageGetter()
    {
    }

   protected String    _StartUrl         = null;
   protected String    _CurrentUrl       = null;
   protected String    _NextUrl          = null;
   protected ByteArray _CurrentPage      = new ByteArray();
   protected String    _Host             = null;
   protected int       _MaxPageSize      = 0;
   protected ByteArray _StrippedDocument = new ByteArray();
   protected int       _BrowserPick      = -1;
   protected boolean   _Retry            = false;
   
   protected static final String HTTPCOLONSLASH = "http://";

   public final void WritePageToFile(String FileName)
    {
      PrintStream Out = null;;
      try
       {
         Streamer.debug.Header().print("Writing page to ").println(FileName);
         Out = new PrintStream( new FileOutputStream( new File(FileName)));
         if (_CurrentPage._A != null)
          {
            Out.println(new String(_CurrentPage._A, 0, _CurrentPage._S));
          }
         if (_StrippedDocument._A != null)
          {
			Out.println();
			Out.println();
			Out.println();
			Out.println();
			Out.println("------------------------------------------------------------------------------");
			Out.println();
			Out.println();
            Out.println(new String(_StrippedDocument._A, 0, _StrippedDocument._S));
          }
       }
      catch(Exception E)
       {
         Streamer.error.Header().printStackTrace(E);
       }
      finally
       {
         if (Out != null)
          Out.close();
       }
    }

	public final void Start(String StartUrl)
	throws Exception
	{
	  Start(StartUrl, 0, -1, false);
	}
	public final void Start(String StartUrl, int BrowserPick)
	throws Exception
	{
	  Start(StartUrl, 0, BrowserPick, false);
	}
   public final void Start(String StartUrl, int MaxPageSize, int BrowserPick, boolean Retry)
   throws Exception
    {
      _StartUrl   = StartUrl   ;
      _CurrentUrl = StartUrl   ;
      _NextUrl    = null       ;
      _MaxPageSize= MaxPageSize;
      _CurrentPage     ._A= null       ;
      _StrippedDocument._A= null       ;
      _BrowserPick =  BrowserPick;
      _Retry = Retry;
      ReadCurrentPage();
    }

   public final IntWrapper getIterator()
    {
      return new IntWrapper(0);
    }
    
   public final ByteArray getCurrentPage     () { return _CurrentPage     ; }
   public final ByteArray getStrippedDocument() { return _StrippedDocument; }
   
   public final String getCurrerntUrl() { return _CurrentUrl; }

   protected static String BROWSERS[] = { "Mozilla/5.0 (Windows; U; Win98; en-US; m18) Gecko/20001106 Netscape6/6.0"
                                         ,"Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; m18) Gecko/20010131 Netscape6/6.01"
                                         ,"Mozilla/5.0 (Windows; U; Win98; en-US; rv:0.9.1) Gecko/20010607 Netscape6/6.1b1"
                                         ,"Mozilla/5.0 (Macintosh; N; PPC; en-US; m18) Gecko/20001108 Netscape6/6.0"
                                         ,"Mozilla/5.0 (X11; U; Linux 2.4.2-2 i686; en-US; 0.7) Gecko/20010316"
                                         ,"IE 5.0 WinNT beta"
                                         ,"IE 5.5 WinNT"
                                         ,"IE 6.0 WinNT"
                                         ,"Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:0.9.2) Gecko/20010726 Netscape6/6.1"
                                         ,"Mozilla/4.74 [en] (Windows NT 5.0; U)"
                                         ,"Mozilla/4.76 (Linux 2.2.12-20 i686; U) Opera 5.0 [en]"
                                         ,"Opera/5.02 (Windows NT 5.0; U) [en]"
                                        };
   public static int BROWSER_NETSCAPE_6_0_WIN   = 0;
   public static int BROWSER_NETSCAPE_6_01_WIN  = 1;
   public static int BROWSER_NETSCAPE_6_1b1_WIN = 2;
   public static int BROWSER_NETSCAPE_6_0_MAC   = 3;
   public static int BROWSER_IE_5_0_WIN         = 5;
   public static int BROWSER_IE_5_5_WIN         = 6;
   public static int BROWSER_IE_6_0_WIN         = 7;
    
   protected final void ReadCurrentPage()
   throws Exception
    {
      int  j;
      long PhaseTime;
      long C1;
      URLConnection.setDefaultAllowUserInteraction(false);
      while (true)
       {
         InputStream in=null;
         j = 1;
         C1= 0;
         PhaseTime=1;
         try
          {
            Streamer.status.Header().print("Reading in page ").println(_CurrentUrl);
            C1 = System.currentTimeMillis();

            int TryCount = _Retry == true ? 0 : 2;
            String ReadUrl = _CurrentUrl;
            while (true)
             {
               URL Url = null;
               URLConnection Conn = null;
               try
                {
                  Url = new URL(_CurrentUrl);
                  _Host = Url.getHost();
                  Conn = Url.openConnection();
                  if (_BrowserPick == -1)
				   _BrowserPick = (int) (java.lang.Math.random()*BROWSERS.length);
                  Streamer.status.Header().println("Browser agent: "+BROWSERS[_BrowserPick]);
                  Conn.setRequestProperty("User-Agent", BROWSERS[_BrowserPick]);
                  ++TryCount;
                  in = /*new InputStreamReader(*/Conn.getInputStream()/*)*/;
                  
                  if(in.available()== 0)
                  {
                  	
                    throw new IOException();	
                  }
                  
                  URL U = Conn.getURL();
                  ReadUrl = HTTPCOLONSLASH+U.getHost()+ U.getFile();
                  break;
                }
               catch (IOException E)
                {
                  if (TryCount == 3)
                   throw new UrlNotAvailable(E.getMessage());
                  Streamer.warning.Header().print("Could not retrieve the url: ").print(_CurrentUrl).println(".");
                  URL U = Conn.getURL();
/*
                  Streamer.debug.Header().print("FILE    : ").println(U.getFile    ());
                  Streamer.debug.Header().print("HOST    : ").println(U.getHost    ());
                  Streamer.debug.Header().print("PATH    : ").println(U.getPath    ());
                  Streamer.debug.Header().print("PROTOCOL: ").println(U.getProtocol());
                  Streamer.debug.Header().print("QUERY   : ").println(U.getQuery   ());
                  Streamer.debug.Header().print("REF     : ").println(U.getRef     ());
                  Streamer.debug.Header().print("USERINFO: ").println(U.getUserInfo());
                  int i = 0;
                  while (true)
                   {
                     String Name = Conn.getHeaderFieldKey(i);
                     if (Name == null)
                      break;
                     String Value= Conn.getHeaderField(i);
                     Streamer.debug.Header().print("HEADER  : ").print(Name).print(" - ").println(Value);
                     ++i;
                   }
*/
                  _CurrentUrl = HTTPCOLONSLASH+U.getHost()+ U.getFile();
                  Streamer.warning.Header().print("Will retry with url: ").print(_CurrentUrl).println(".");
                  Thread.sleep(5000);
                }
             }
            if (_CurrentUrl.equals(ReadUrl) == false)
             {
               Streamer.debug.Header().print("We were redirected to another page that we got: ").println(ReadUrl);
               _CurrentUrl = ReadUrl;
               //throw new Exception("We were redirected to another page that we got: "+ReadUrl);
             }
            else
             {
               Streamer.debug.Header().println("Got the page");
             }
            if (_MaxPageSize <= 0)
             {
               Streamer.debug.Header().println("Passed in a buffer of size 0, so we are not reading the page in memory");
               break;
             }
            if (_CurrentPage._A == null)
             {
               _CurrentPage._A = new byte[_MaxPageSize+2];
               _CurrentPage._A[0]= '-';
             }
            Streamer.trace.Header().print(_CurrentPage._A.length).println(" bytes of buffer allocated");
            int k;
            Streamer.debug.Header().println("Starting to read the content");
            while ((k=in.read(_CurrentPage._A, j, 32*1024)) != -1)
             {
               Streamer.trace.Header().println("Read " + (j/1024) + "Kb so far");
               j+=k;
               Streamer.trace.Header().print(j).print(" bytes read so far (+").print(k).println(")");
             }
            PhaseTime = System.currentTimeMillis()-C1;
            Streamer.debug.Header().print("Read the content (").print(j/1024).print("KB at ").print(j/PhaseTime*1000/1024).println(" KB/s)");
            break;
          }
         catch (IndexOutOfBoundsException E)
          {
            Streamer.debug.Header().print("Read a document that is larger than ").print(_MaxPageSize).print(" bytes for ").println(_CurrentUrl);
            if (_MaxPageSize < 512 * 1024)
             {
               _MaxPageSize += 64 * 1024;
               _CurrentPage._A = null;
               Streamer.status.Header().print("Growing the buffer to ").print(_MaxPageSize).print(" bytes for ").println(_CurrentUrl);
             }
            else
             {
               throw new Exception("URL document read larger than "+_MaxPageSize+" bytes");
             }
          }
         catch (Exception E)
          {
            throw E;
          }
         finally
          {
            if (in != null) 
             in.close();
          }
       }       
      _CurrentPage._S = j;
    }

   public static void main(String[] args)
    {
      Streamer.ForceStdErr();
      Streamer.StartThread();

      try
       {
       	  PageGetter PG = new PageGetter();
       	  PG.Start("http://<ADD IP ADDRESS HERE>:8080/wps/portal/", 0, PageGetter.BROWSER_IE_6_0_WIN, false);
       	  PG.WritePageToFile("t:\\DisconnectedPortalPortfolio.html");
       }
      catch (Exception e)
       {
		Streamer.error.Header().printStackTrace(e);
       }
      Streamer.status.Header().println("Finished");
    }
 }
