/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

package com.ibm.odcb.jrender.misc;

import java.util.ArrayList;
import java.util.StringTokenizer;

import javax.faces.el.ReferenceSyntaxException;


public class PathTokenizer {
	
	protected String path = null;
	protected String[] tokens = null;
	
	public PathTokenizer(String pathExpression)
	{
		path = pathExpression;
		if (path != null)
		  tokenize();
	}
	
	protected void tokenize()
	{
		//parse the tokens here	
		//JRLI: This is not needed anymore because we decide to store the stripped
		//value binding expression into the map  	 
		/*try
		{ 
			path = PathTokenizer.getStrippedValueString(path);
		} 
		catch (ReferenceSyntaxException e)
		{
		}*/
		
		StringTokenizer st = new StringTokenizer(path, ".");
		ArrayList list = new ArrayList();
		while (st.hasMoreTokens())
		{
			String tok = st.nextToken();
			//if ( tok.indexOf('[') != -1)
			 //tok = tok.substring(0, tok.indexOf('['));
			list.add(tok);
		}
		
		tokens = new String[list.size()];
		for (int i=0; i<list.size(); i++)
		{
			tokens[i] = (String) list.get(i);
		}
	}
	
	public String getPathToLastObject(){
		int index = path.lastIndexOf('.');
		if(index != -1){
			return path.substring(0, index);
		}
		else{
			return path;
		}
	}
	
	public String getRoot()
	{
		if (tokens == null)
		  tokenize();
		return tokens[0];
	}
	
	public String[] getTokens()
	{
		if (tokens == null)
		  tokenize();
		return tokens;
	}
	
	public String getPath()
	{
		return path;
	}
	
	public void setPath(String thePath)
	{
		path = thePath;
	}
	
	public String getLastToken(){
		if(path.indexOf('.') == -1){
			return path;
		}
		else{
			return path.substring(path.lastIndexOf('.')+1, path.length());
		}
	}
	
/*	public static String getStrippedValueString(String rawValueString) throws InvalidValueReferenceException
	{
		//as per new JSF_Spec_1.0, valueRef will be of the form "#{ValueRef}".  
		//We need to strip out the "#{}" from the ValueRef if it's there.
		//TO DO: we have to account for all formats of Value String	here
		if (rawValueString == null)	
		  return null;
		if (rawValueString.startsWith("#{") && rawValueString.endsWith("}"))
		  rawValueString = rawValueString.substring(2,rawValueString.length()-1);

		return rawValueString;
	}*/
	
	public static String getStrippedValueString(String rawValueString)
			throws ReferenceSyntaxException {
			if (rawValueString == null)	
			  return null;
			int len = 0;
			// look for invalid expressions
			if ('#' == rawValueString.charAt(0)) {
				if ('{' != rawValueString.charAt(1)) {
					throw new ReferenceSyntaxException();
				}
				if ('}' != rawValueString.charAt((len = rawValueString.length()) - 1)) {
					throw new ReferenceSyntaxException();
				}
				rawValueString = rawValueString.substring(2, len - 1);
			}
			return rawValueString;
		}

	
	public static void main(String[] args)
	{
		PathTokenizer pt = new PathTokenizer("#{Root.Users[0].Portfolios[0]}");
		System.out.println("Input: " + "#{Root.Users[0].Portfolios[0]}");
		System.out.println("Path: " + pt.path);
		String root = pt.getRoot();
		System.out.println("Root: " + root);
		String[] tokens = pt.getTokens();
		if (tokens != null)
		{
			for (int i=0; i<tokens.length; i++)
			{
				System.out.println("Token "+i+": "+tokens[i]);
			}
		}
	}

}
