/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

package com.ibm.odcb.jrender.misc;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;


public class PropertiesUtil
 {
   public PropertiesUtil()
    {
    }
    
   public void Open(String PropertiesFilePath)
   throws IOException
    {
      _PropertiesFilePath = PropertiesFilePath;
      _Prop = new Properties();
      FileInputStream Input = new FileInputStream(_PropertiesFilePath);
      _Prop.load(Input);
      Input.close();
    }

   public void Save()
   throws IOException
    {
      FileOutputStream Output = new FileOutputStream(_PropertiesFilePath);
      _Prop.store(Output, null);
      Output.close();
    }

   protected Properties _Prop = null;
   protected String     _PropertiesFilePath;
   
   public String getProperty(String Name)
    {
      return _Prop.getProperty(Name);
    }
   
   public void AddProperty(String Name, String Value)
    {
      String Str = _Prop.getProperty(Name);
      if (Str == null)
       _Prop.setProperty(Name, Value);
      else if (Str.indexOf(Value) == -1)   // Not found, and this is an Add operation
       {
         Str = Str+" "+Value;
         _Prop.setProperty(Name, Str);
       }
    }
   public void SetProperty(String Name, String Value)
    {
      _Prop.setProperty(Name, Value);
    }

   public void DeleteProperty(String Name)
    {
      _Prop.remove(Name);
    }

   public void DeleteProperty(String Name, String Value)
    {
      String Str = _Prop.getProperty(Name);
      if (Str != null)
       {
         int i = Str.indexOf(Value);
         if (i != -1)
          {
            Str = Str.substring(0, i)+Str.substring(i+Value.length());
            _Prop.setProperty(Name, Str);
          }
       }
    }
 }
