/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID xxxx-xxx
//
// Copyright IBM Corp.  2003
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.odcb.jrender.misc;

import java.net.URL;
import java.security.CodeSource;


public class ResourceLocator
 {
   public static final String COPYRIGHT = com.ibm.odcb.utilities.IBMCopyright.SHORT_COPYRIGHT;


   public static String GetRootPathFromMarkerClassName(String ClassName)
    {
      try
       {
         Object O = ODCClassLoader.getClassInstance(ClassName);
         return GetRootPath(O);
       }
      catch (Exception E)
       {
         String Msg = "Cannot locate Marker class '"+ClassName+"'.";
         Streamer.error.println(Msg);
         Streamer.error.printStackTrace(E);
         throw new Error(Msg);
       }
    }
   public static String GetRootPath(Object O)
    {
      CodeSource CS = O.getClass().getProtectionDomain().getCodeSource();
      String ObjectPath = null;
      
      if (CS != null)
       { 
         URL ObjectUrl = CS.getLocation();
         ObjectPath  = ObjectUrl.toString();
       }
      else 
       { 
         ObjectPath = "null";
       }

      final String FILE_STRING = "file:/";
      if (ObjectPath.startsWith(FILE_STRING) == true)
       {
         ObjectPath = ObjectPath.substring(FILE_STRING.length());
       }
      else
       {
         final String Msg = "The path for the class '"+O.getClass().getName()+"' came back as '"+ObjectPath
                           +"', which is not a file resource (does not start with 'file:/'). A class with a proper file resource is required.";
         Streamer.error.Header().println(Msg);
         throw new Error(Msg);
       }
      return ObjectPath;
    }
    
   public static void main(String[] args)
    {
      System.out.println(GetRootPath(new ResourceLocator()));
    }
 }
