/////////////////////////////////////////////////////////////////////////
//  IBM Confidential
//  
//  OCO Source Materials
//  
//  PID xxxx-xxx
//  
//   Copyright IBM Corp.  2003
//  
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////


package com.ibm.odcb.jrender.utilities;

import com.ibm.odcb.jrender.mediators.MediatorFactory;
import com.ibm.odcb.jrender.misc.Streamer;

/*
 * @author ldh
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class MediatorGen
 {    
   public static final String COPYRIGHT = com.ibm.odcb.utilities.IBMCopyright.SHORT_COPYRIGHT;
   
   public static void main(String[] args)
    {
      Streamer.ForceStdErr();
      Streamer.StartThread();
      Streamer.status.Header().println("USAGE: WDO4JSMediatorGen <source path> <build path> <compiler command line> {-nocompile}")
                     .Header().println("WDO4JSMediatorGen utility: 3 or 4 parameters needed."
                                      +"\n     The source path parameter points to the root of where your application source is."
                                      +"\n     The build path parameter points to the root of where your application build directory is."
                                      +"\n     The compiler command line parameter is the command line call to invoke the java compiler."
                                      +"\n     Example: \"D:\\projects\\Testing\\src\" \"D:\\projects\\Testing\\bin\" \"C:\\dev\\java\\bin\\javac -O -g:none\" "
                                      +"\n     Make sure that parameters are passed in quotes in case they contain a space character")
                     .println();

      if (args.length < 3)
       {
         Streamer.error.Header().println("Invalid number of parameter passed.");
       }

      String SourcePath = args[0];
      String BuildPath  = args[1];
      String CompCmdln  = args[2];
      
      boolean Compile = true;
      if (args.length == 4)
       {
         Compile = args[3].equals("-nocompile") == false;
       }

      MediatorFactory.GenMediators(Compile, SourcePath, BuildPath, CompCmdln, null, false);
      Streamer.status.println("WDO4JSMediatorGen has ended.");
	   Streamer.EndThread();
    }
 }