/////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//PID 5724-E76 and 5724-E77
//
// Copyright IBM Corp.  2005
//
//The source code for this program is not published or other-
//wise divested of its trade secrets, irrespective of what has
//been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

package com.ibm.odcb.utilities;

import java.io.File;
import java.io.FileWriter;
import java.io.FileReader;
import java.io.BufferedReader;
import java.lang.String;
import java.io.IOException;

public class JSVersion {
	
	
	
	public static void main(String args[])
	{		
		
		
		if (args.length < 2) {
			System.out.println("Usage: JSVersion <revision> <date>");
			System.exit(0);
		}
		
		String revisionfile = args[0];
		String builddate = args[1];
		String jsldir = args[2];
		
		File versioninfoFile = new File(jsldir+"/versionInfo.js");
		
		String revision = new String();
		
		File cvsversionfile = new File(revisionfile);
		
		try {
			FileReader fr = new FileReader(cvsversionfile);
			String line = new  String();
			BufferedReader in = new BufferedReader(fr);
			
			while((line = in.readLine()) != null) {
				if (line.indexOf("/versionInfo") != -1) {
					revision = new String(line.substring(line.lastIndexOf(".js")+3)); 
                                        System.out.println("revision is : "+revision);
				}


			}
			
		}	
		catch (Exception ex){
			
			
		}
		
		
		
		
		try {
			FileWriter fw = new FileWriter(versioninfoFile);
						
			String versionBody = new String("\n\n/**\n" 
										  + "* @class public versionInfo \n"
										  + "* versionInfo is used to write out the code version (date,time,version stamp)\n "
										  + "*  to the page. This JS file will NOT be included in any ODC pages.\n"
										  + "**/\n"
										  + "\n"
										  + "<script>\n"
										  + "document.write(\"ODC Code Version: \");\n\n"
										  + "document.writeln(\"cvs_en_version_level="+revision+"\");\n\n"
										  + "document.writeln(\"Build Date: "+builddate+"\");\n\n"
										  + "</script>");
			fw.write("/** "+IBMCopyright.getLongCopyright()+" **/"+versionBody);

			fw.close();
			
		}
		catch (IOException ex) {
			System.out.println(ex.toString());
		}
		
		
				
		
	}	
}
