/////////////////////////////////////////////////////////////////////////
//  IBM Confidential
//  
//  OCO Source Materials
//  
//  PID xxxx-xxx
//  
//   Copyright IBM Corp.  2003
//  
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////

package com.ibm.odcb.utilities;

import java.io.*;


/**
 *
 * @author  ldh
 * @version 
 */
public class LineCount extends java.lang.Object
 {
   public LineCount() 
    {
    }

   public static class Toto implements FileFilter
    {
      public Toto()
       {
         _Dir = true;
       }
       
      public Toto(String Ext)
       {
         _Ext = Ext;
         _Dir = false;
       }
       
      
      protected String  _Ext;
      protected boolean _Dir;
      
      public boolean accept(File TheFile)
       {
         if (_Dir == true)
          {
            return TheFile.isDirectory();
          }
         else
          {
            final String Path = TheFile.getPath();
            int i = Path.indexOf(_Ext);
            return (i > 0 && i + _Ext.length() == Path.length() && Path.charAt(i-1) == '.');           
          }
       }
    }
    
   protected final static String _Exts[] = { "java", "cpp", "c", "h", "hpp", "d2w", "jsp", "htm", "html", "js", "properties", "xml", "sql", "inc" };
   protected       static long   _LC  [] = { 0     , 0    , 0  , 0  , 0    , 0    , 0    , 0    , 0     , 0   , 0           , 0    , 0    , 0 };
   
   public static long CountLines(File D)
   throws Exception
    {
      System.out.println("\n\nExploring directory: " +D.getAbsolutePath());
      long DirectoryLineCount = 0;
      for (int i = 0; i < _Exts.length; ++i)
       {
         File TheFiles[] = D.listFiles(new Toto(_Exts[i]));
         long LineCount = 0;
         for (int j = 0; j < TheFiles.length; ++j)
          {
            BufferedReader In = new BufferedReader(new FileReader(TheFiles[j]));
            String S;
            while ((S=In.readLine()) != null)
             {
               for (int k = 0; k < S.length(); ++k)
                {
                  char C = S.charAt(k);
                  if (Character.isWhitespace(C) == false)
                   {
                     if (C!='/' || k == S.length()-1 || S.charAt(k+1) != '/')
                      ++LineCount;
                     break;
                   }
                }
             }
          }
         _LC[i] += LineCount;
         DirectoryLineCount += LineCount;
         if (LineCount != 0)
          {
            System.out.println("Line count for '" + _Exts[i] + "' is " + LineCount);
          }
       }
      System.out.println("Total line count for '" + D.getAbsolutePath() + "' is " + DirectoryLineCount);
      
      File TheFiles[] = D.listFiles(new Toto());
      for (int i = 0; i < TheFiles.length; ++i)
       {
         DirectoryLineCount += CountLines(TheFiles[i]);
       }
      
      System.out.println("Total line count for '" + D.getAbsolutePath() + "' and all its subdirectories is " + DirectoryLineCount);
      return DirectoryLineCount;
    }
    
   public static void main (String args[])
    {
      if (args.length != 1)
       {
         System.out.println("\n\n  Run this utility with one parameter to indicate the directory to work on.");
         return;
       }
      try
       {
         final String Directory = args[0];
         File F = new File(Directory);
         long LineCount =  CountLines(F);
         System.out.println("\n\n\nTotal line count for '" + F.getName() + "' is " + LineCount);
         for (int i = 0; i < _Exts.length; ++i)
          {
            if (_LC[i] != 0)
             {
               System.out.println("Line count for '" + _Exts[i] + "' is " + _LC[i]);
             }
          }
       }
      catch (Exception E)
       {
         System.out.println("A problem occured");
         E.printStackTrace(System.out);
       }
    }
 }
