/////////////////////////////////////////////////////////////////////////
//  IBM Confidential
//  
//  OCO Source Materials
//  
//  PID 5724-E76 and 5724-E77
//  
//   Copyright IBM Corp.  2003
//  
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.odcb.utilities.jsdoc;
import java.util.StringTokenizer;

/**
 * @author rpzitel
 */
public class Cls {
private String className;
private String fileName;
private StringBuffer commentBuffer;
private String line0a ="<A NAME=\"";
// anchorName; methodName and signature
private String line0b ="\"><!-- --></A>";

private String line1 = "<H2>\n"
		+ "<BR>\n"
		+ "Class</H2><H3> ";
		// insert className
private String line2 = "</H3>\n";
		// and class comments...
private String line3 = "</DL>\n"
		+ "<HR>\n"
		+ "<P>\n"
		+ "<HR>\n"
		+ "<P>\n";
public Cls()
{
}	
public void init()
{
		commentBuffer = new StringBuffer();
}
	public void reset()
	{
		className = null;
		commentBuffer = null;
	}
	public static void main(String[] args) 
	{
		Cls h = new Cls();
		h.setClassName(args[0]);
		//System.out.println(h.toString());
	}
/**
 * Returns the className.
 * @return String
 */
public String getClassName() {
	return className;
}

/**
 * Sets the className.
 * @param className The className to set
 */
public void setClassName(String className) {
	this.className = className;
}

public String toString()
{
	return commentBuffer.toString();
}
	/**
	 * Sets the comment.
	 * @param comment The comment to set
	 */
	public void setComment(String comment) {
		//this.comment = comment;
		// here we parse the comment string
		String result = null;
		String temp1 = " ";
		String temp2 = " ";
		String temp3 = " ";;
		String type = null;
		int cls = 0, param = 0;
		int j = 0;
		int k = 0;
		int l = 0;
//		System.out.println("Cls: " + comment);
		StringTokenizer st = new StringTokenizer(comment.substring(3), "*");  // remove the /** at the beginning of the comment
		while (st.hasMoreTokens())
		{
			result = st.nextToken();
			//System.out.println(result);
			cls = result.indexOf("@class");
			if (cls > -1)
			{
				temp1 = result.substring(cls + 7);  // public or private
				j = temp1.indexOf("public");
				if (j > -1)
				{
					type = "public";
					j =+ 6;
					className = temp1.substring(j).trim();
					commentBuffer.append(line0a);
					commentBuffer.append(className);
					commentBuffer.append(line0b);
					commentBuffer.append(line1);
					commentBuffer.append(className);	// a comment line
					commentBuffer.append(line2);
					commentBuffer.append("file: " + fileName + "<br>");
					//commentBuffer.append(temp3);

				}
				else if (temp1.indexOf("private") > -1)
				{
					type = "private";
					j =+ 7;
					className = temp1.substring(j).trim();

					commentBuffer.append(line0a);
					commentBuffer.append(className);
					commentBuffer.append(line0b);
					commentBuffer.append(line1);
					commentBuffer.append(className);	// a comment line
					commentBuffer.append(line2);
					commentBuffer.append("file: " + fileName + "<br>");
					//commentBuffer.append(temp3);

				}
			}
			param = result.indexOf("@param");	
			if (param > -1)			
			{
				// process the @param comments
				temp1 = result.substring(param + 6);  // remove the @param
				commentBuffer.append(temp1);
				commentBuffer.append("<br>");	// new line
			}

			if (cls == -1 && param == -1 )
			{
				commentBuffer.append(result);	// a comment line
				commentBuffer.append("<br>");	// new line
			}
				
		}
	}
/**
 * Returns the fileName.
 * @return String
 */
public String getFileName() {
	return fileName;
}

/**
 * Sets the fileName.
 * @param fileName The fileName to set
 */
public void setFileName(String fileName) {
	this.fileName = fileName;
}

}
