/////////////////////////////////////////////////////////////////////////
//  IBM Confidential
//  
//  OCO Source Materials
//  
//  PID 5724-E76 and 5724-E77
//  
//   Copyright IBM Corp.  2003
//  
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.odcb.utilities.jsdoc;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Stack;

import com.ibm.odcb.utilities.JSCompressor.JavaScriptDocComment;
/**
 * @author rpzitel
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

public class JSDocGen {
private ArrayList comments_in; 
private ArrayList comments = new ArrayList(100);
private String outputFileName, indexFile, detailFile, frameFile;
public Stack commentStack = new Stack();
public Stack globalStack = new Stack();
private int gMethodIndex=0;
// the contents of the frameset file
//
private String frame1 = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\"\"http://www.w3.org/TR/REC-html40/loose.dtd>"
	+ "<!--NewPage-->"
	+ "<HTML>"
	+ "<HEAD>"
	+ "<!-- Generated by JSDoc on Mon Jun 16 21:52:40 EDT 2003-->"
	+ "<TITLE>"
	+ "Generated Documentation (Untitled)"
	+ "</TITLE>"
	+ "</HEAD>"
	+ "<FRAMESET cols=\"20%,80%\">"
	+ "<FRAME src=\"";
	// insert index file name 
private String frame2 ="\" name=\"packageFrame\">"
	+ "<FRAME src=\"";
	// insert detail file name
//	jsl-detail.html
private String frame3 = "\" name=\"classFrame\">"
	+ "</FRAMESET>"
	+ "<NOFRAMES>"
	+ "<H2> Frame Alert</H2>"
	+ "<P>"
	+ "This document is designed to be viewed using the frames feature. If you see this message, you are using a non-frame-capable web client."
	+ "<BR>"
	+ "Link to <A HREF=\"com/ibm/odcb/utilities/package-summary.html\">Non-frame version.</A></NOFRAMES>"
	+ "</HTML>";

private String filePrefix;
//
private int idx = 0;
private int stack_level = -1;
	public JSDocGen(ArrayList Comments, String OutputFileName)
	{
		this.comments_in = Comments;
		this.outputFileName = OutputFileName;
		detailFile = outputFileName + "-detail.html";
		indexFile = outputFileName + "-allclasses-frame.html";
		frameFile = outputFileName + "-index.html";
		int i = OutputFileName.lastIndexOf("\\");
		int j = OutputFileName.lastIndexOf("/");
		if (i > j) filePrefix = OutputFileName.substring(i +1);
		else filePrefix = OutputFileName.substring(j +1);

	}
	public void reorderComments()
	{	
		JavaScriptDocComment stack_jsc, jsc;
		//int idx = 0;
		//int stack_level = -1;
		int icls = -1;	// class
		int imth = -1;	// method
		while ( idx < comments_in.size())
		{
			jsc =	(JavaScriptDocComment) comments_in.get(idx);
			icls = jsc._Comment.indexOf("@class");
			imth = jsc._Comment.indexOf("@method");
			// if JSDoc is not one of @class or @method, we bypass it
			if (icls == -1 && imth == -1)
			{
				System.out.println("JSDocGen:error: comment is not @class or @method unknown JSDoc type: ");
				System.out.println("file name: " + jsc._FileName);
				System.out.println(jsc._Comment);
				idx++;
				continue;
			}
			//System.out.println("JSDocGen:input: " + jsc._NestingLevel + " " + jsc._Comment);
			if (jsc._Comment.indexOf("@class") > -1 && jsc._Comment.indexOf("@constructor") > -1)
 			{
 				// found a constructor
 				// breakup the comment into a class comment and a method comment

 				int constructor = jsc._Comment.indexOf("@constructor");
 				String classString = jsc._Comment.substring(0, constructor);
 				String consString = jsc._Comment.substring(constructor);
				JavaScriptDocComment cls = new JavaScriptDocComment(jsc._FileName, jsc._NestingLevel, classString); 				
				JavaScriptDocComment con = new JavaScriptDocComment(jsc._FileName, jsc._NestingLevel + 1, consString); 				
 				processComments(cls);		// process the class comment
 				processComments(con);		// process the constructor commnent as if it were  a method comment
 				idx++;
 				continue;
 			}
			if(jsc._Comment.indexOf("prototype")>-1)
			{
				jsc._NestingLevel++;
				JavaScriptDocComment com = new JavaScriptDocComment(jsc._FileName, jsc._NestingLevel, jsc._Comment);
				processComments(com);
				
			}else{
				processComments(jsc);
			}
			idx++;
		}
		while (!commentStack.isEmpty())
		{
			stack_jsc = (JavaScriptDocComment) commentStack.pop();	
			comments.add(stack_jsc);
			//System.out.println(idx + " JSDocGen: " + stack_jsc._NestingLevel + " " + stack_jsc._Comment);
			//idx++;
		}
		
		boolean globals = false;
//		idx = 0;
		String fname = " ";
		while (!globalStack.isEmpty())
		{
			stack_jsc = (JavaScriptDocComment) globalStack.pop();	
			comments.add(stack_jsc);
			globals = true;
			fname = stack_jsc._FileName;
			//System.out.print("fname "+fname);
			//System.out.println(idx + " JSDocGen: " + stack_jsc._NestingLevel + " " + stack_jsc._Comment);
			//idx++;
		}
		// if we have a global method, then create a fake @class Global comment
		if (globals)
		{	// cheat a little, use the file name from the global method above
			comments.add(new JavaScriptDocComment(fname, 0, "/** *@class public Global  **/"));
			//System.out.println(idx + " JSDocGen: " + "0" + " " + "/** * @class public Global  **/");
			//idx++;
		}
	}
	public void processComments(JavaScriptDocComment jsc)
	{
		JavaScriptDocComment stack_jsc; 	
		if ( (jsc._NestingLevel == 0) && (jsc._Comment.indexOf("@method") > -1)&&(jsc._Comment.indexOf("public")>-1))
		{	// we found a global method... handle it separately
		//	System.out.print("we found a global method... handle it separately " + jsc._Comment);
			jsc._NestingLevel++;
			gMethodIndex++;
			globalStack.push(jsc);
			//idx++;
			return; //continue;
		}
		if (stack_level < jsc._NestingLevel)	// frist time stack level is -1
		{
			commentStack.push(jsc);				
			stack_level = jsc._NestingLevel;
		}
		else
		if (stack_level == jsc._NestingLevel)
		{
			while ((stack_level == jsc._NestingLevel) && !commentStack.isEmpty())
			{
				stack_jsc = (JavaScriptDocComment) commentStack.pop();	
				comments.add(stack_jsc);
//				System.out.println("JSDocGen: " + stack_jsc._Comment);
				if (!commentStack.isEmpty())
				{
					stack_jsc = (JavaScriptDocComment) commentStack.peek();	
					stack_level = stack_jsc._NestingLevel;
				}
			}
			commentStack.push(jsc);					
			stack_level = jsc._NestingLevel;
		}
		else
		if (stack_level > jsc._NestingLevel)
		{
			while ((stack_level >= jsc._NestingLevel) && !commentStack.isEmpty())
			{
				stack_jsc = (JavaScriptDocComment) commentStack.pop();	
				comments.add(stack_jsc);
//				System.out.println("JSDocGen: " + stack_jsc._Comment);
				if (!commentStack.isEmpty())
				{
					stack_jsc = (JavaScriptDocComment) commentStack.peek();	
					stack_level = stack_jsc._NestingLevel;
				}
			}
			commentStack.push(jsc);
			stack_level = jsc._NestingLevel;
		}
	}
	public void execute()
	 throws Exception
    {
    	reorderComments();
    	com.ibm.odcb.utilities.jsdoc.Header h = new com.ibm.odcb.utilities.jsdoc.Header();
    	com.ibm.odcb.utilities.jsdoc.Cls cls = new com.ibm.odcb.utilities.jsdoc.Cls();    	
	   	com.ibm.odcb.utilities.jsdoc.MethodDetail md = new com.ibm.odcb.utilities.jsdoc.MethodDetail();
   		com.ibm.odcb.utilities.jsdoc.MethodSummary ms = new com.ibm.odcb.utilities.jsdoc.MethodSummary(detailFile);
   		com.ibm.odcb.utilities.jsdoc.IndexHtml ih = new com.ibm.odcb.utilities.jsdoc.IndexHtml(detailFile);
   		String currentFile = null;
   		String currentClass = null;
   		String oldClass = null;
   		String temp1, temp2, temp3;  // used for parsing className
   		int j =0, k = 0, l = 0;
    	BufferedWriter framef = new BufferedWriter(new FileWriter(frameFile));
		BufferedWriter Out = new BufferedWriter(new FileWriter(detailFile));
    	BufferedWriter ihf = new BufferedWriter(new FileWriter(indexFile));
		ih.init();
		h.init();

		cls.init();
		ms.init();
		md.init();
		Out.write(h.toString());	// heading for html

		for (int i = 0; i < comments.size(); ++i)
		{
			JavaScriptDocComment C = 
	         (JavaScriptDocComment) comments.get(i);
		//	System.out.println("GetJavaScriptDocs: " + C._FileName);
			//System.out.println("JSDocGen: " + C._NestingLevel + " " + C._Comment);
			String comment = C._Comment;
			//System.out.print("comment "+comment);
			if (comment.indexOf("@class") > -1)
			{
				// class comment
				// parse the className
				j = comment.indexOf("@class");
				temp1 = comment.substring(j+6).trim();  // go past @class
				l = temp1.indexOf("public");
				if (l > -1) 
				{
					temp2 = temp1.substring(l + 6).trim();
					//System.out.print("classname " + temp2+"\n");
				}
				else 
				{
					l = temp1.indexOf("private");
					if (l > -1) 
					{
						//temp2 = temp1.substring(l + 7).trim();
						continue;
					}
					else
					{		
						temp2 = temp1.trim();  // we have the class
					}
				}
				j = temp2.indexOf(" ");
				if (j > -1)
				{
					temp3 = temp2.substring(0,j+1).trim();
				}
				else
				{
					temp3 = temp2.trim();  // no trailing space
				}
				j = temp3.indexOf("*");    // if no trailing spaces, next character may be *
				if (j > -1)
					currentClass = temp3.substring(0, j);
				else
					currentClass = temp3;
				//System.out.print("current Class " + currentClass);
				//System.out.print("global stack " + gMethodIndex);
				if(!currentClass.equalsIgnoreCase("Global")||gMethodIndex>0){
					
					ih.setClassName(currentClass);		
					cls.setFileName(C._FileName);
					cls.setComment(comment);
					Out.write(cls.toString() + ms.toString() + md.toString());
					cls.reset();
					ms.reset();
					md.reset();
	
					cls.init();
					ms.init();
					md.init();
				}
			}
			else
			{
			// method comment, private method will not be printout
				if(comment.indexOf("private")==-1){
					md.setComment(C._Comment);
					ms.setReturnType(md.getReturnType());
					ms.setLinkName(md.getLinkName());
					ms.setMethodDes(md.getMethodDes());
					String methodname = md.getMethodAPI();
					/*
					int index = methodname.indexOf("prototype");
					if(index>-1)
					{
						methodname = methodname.substring(index+10);
					}
					*/
			
					ms.setMethodName(methodname);
				
				}
			}			
       }
       // end of comments
//		h.setClassName(currentFile); // testing
		//System.out.println("GenJavaScriptDocs:IndexHtml " + ih.toString());
		//System.out.println("GenJavaScriptDocs: " + h.toString() + ms.toString() + md.toString());			
		//Out.write(cls.toString() + ms.toString() + md.toString());
		framef.write(frame1);
		framef.write(filePrefix + "-allclasses-frame.html");
		framef.write(frame2);
		framef.write(filePrefix + "-detail.html");
		framef.write(frame3);
		ihf.write(ih.toString());
	    Out.close();
	    ihf.close();
	    framef.close();
    }

}
