/////////////////////////////////////////////////////////////////////////
//  IBM Confidential
//  
//  OCO Source Materials
//  
//  PID 5724-E76 and 5724-E77
//  
//   Copyright IBM Corp.  2003
//  
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.odcb.utilities.jsdoc;
import java.util.StringTokenizer;

/**
 * @author rpzitel
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class MethodDetail {
	// method detail headers
	private String mdh0= "<BR><BR><!-- ============ METHOD DETAIL ========== -->";
	private String mdh1 = "<A NAME=\"method_detail\"><!-- --></A>";
	private String mdh2 = "<TABLE BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\" WIDTH=\"100%\">";
	private String mdh3 = "<TR BGCOLOR=\"#CCCCFF\" CLASS=\"TableHeadingColor\">";
	private String mdh4 = "<TD COLSPAN=1><FONT SIZE=\"+2\">";
	private String mdh5 = "<B>Method Detail</B></FONT></TD>";
	private String mdh6 = "</TR>";
	private String mdh7 = "</TABLE>";
	// method detail details
private String mdd1="<A NAME=\"";
// anchorName; methodName and signature
private String mdd2="\"><!-- --></A>";
private String mdd3 ="<H3>";
// method name 
private String mdd4 ="</H3><PRE>";
// method details public static boolean <B>IsEscaped</B>(java.lang.String&nbsp;L, int&nbsp;i)
private String mdd9="</PRE><DL></DL><HR>";

	
	
	//
	private StringBuffer jsText = new StringBuffer();
	private String methodName;
	private String linkName;
	private String comment;	
	private String methodAPI;
	private String returnType;
	private StringBuffer commentBuffer;
	private StringBuffer methodDes;
	public MethodDetail()
	{

	}
	public void init()
	{
		// set up the heading for the method detail
		//jsText = new StringBuffer();
		jsText.append(mdh0);		
		jsText.append(mdh1);
		jsText.append(mdh2);				
		jsText.append(mdh3);
		jsText.append(mdh4);
		jsText.append(mdh5);
		jsText.append(mdh6);
		jsText.append(mdh7);
		commentBuffer = new StringBuffer();
	}

	public static void main(String[] args) 
	{
		MethodDetail md = new MethodDetail();
		//System.out.println("MethodDetail:" + md.toString());
	}

	/**
	 * Returns the methodName.
	 * @return String
	 */
	public String getMethodName() {
		return methodName;
	}


	public String toString()
	{
		//System.out.println("MethodDetail: " + jsText.toString());
		return jsText.toString();
	}
	
	public void reset()
	{
		jsText = new StringBuffer();
		methodName = null;
		commentBuffer = null;
	}
	/**
	 * Returns the comment.
	 * @return String
	 */
	public String getComment() {
		return comment;
	}
	/**
	 * Returns the returnType.
	 * @return String
	 */
	public String getReturnType() {
		return returnType;
	}
	/**
	 * Sets the comment.
	 * @param comment The comment to set
	 */
	public void setComment(String comment) {
		//this.comment = comment;
		// here we parse the comment string
		methodDes = new StringBuffer();
		commentBuffer = new StringBuffer();
		returnType = "void";
	
		String result = null;
		String temp1 = " ";
		String paramStr="";
		String type = null;
		int method = 0, param = 0, rtnType = 0, exceptionType =0, construct = 0;
		int j = 0;
		int k = 0;
		StringTokenizer st = new StringTokenizer(comment, "*");  // remove the /** at the beginning of the comment
		boolean isParam = false;
		boolean isReturn = false;
		boolean isExcept = false;
		while (st.hasMoreTokens())
		{
			//System.out.println(commentBuffer.toString());
			result = st.nextToken();
			if (result.trim().equals("/")) continue;  // skip the ending slash
			//System.out.println(result);
			method = result.indexOf("@method");
			String methodStr;
			if (method > -1)
			{
				temp1 = result.substring(method + 8);  // public or private
				j = temp1.indexOf("public");
				if (j > -1)
				{
					j =+ 6;
					methodName = temp1.substring(j).trim();
				}
				else 
				{
					j = temp1.indexOf("private");
					if ( j > -1)
					{
						//j =+ 7;
						//methodName = temp1.substring(j).trim();
						continue;
					}
					else
					{
						methodName = temp1.trim();
					}
				}
				int index = methodName.indexOf("prototype");
				if(index>-1)
				{
					methodName = methodName.substring(index+10);
				}
				linkName = methodName + "_method";  // if not constructor
				commentBuffer.append("<H3>" + methodName + "</H3><p>");	// a comment line
				commentBuffer.append("&MN&");
				commentBuffer.append("<br>");	// new line
			}
			construct = result.indexOf("@constructor");
			if (construct > -1)
			{
				temp1 = result.substring(construct + 12);  // public or private
				j = temp1.indexOf("public");
				if (j > -1)
				{
					j =+ 6;
					methodName = temp1.substring(j).trim();
				}
				else 
				{
					j = temp1.indexOf("private");
					if ( j > -1)
					{
					//	j =+ 7;
						//methodName = temp1.substring(j).trim();
						continue;
					}
					else
					{
						methodName = temp1.trim();
					}
				}
				linkName = methodName + "_contructor";
				commentBuffer.append("<H3>" + methodName + "</H3><P>");	// a comment line
				commentBuffer.append("&MN&");
				commentBuffer.append("<br>");	// new line
			}

			param = result.indexOf("@param");	
			if (param > -1)			
			{
				// process the @param comments
				temp1 = result.substring(param + 6);  // remove the @param
				if(!isParam)
				{
					commentBuffer.append("<DT><b>Parameters<br></b>");
					isParam = true;
				}
				paramStr += temp1+",";
				
				int n = temp1.trim().indexOf(" ");
				if (n > -1)
				{
					temp1 = temp1.substring(n+1);
				}
					
				commentBuffer.append("<DD><CODE>"+temp1+"</CODE> - ");
				
				//	commentBuffer.append("<br>");	// new line
			}
			rtnType = result.indexOf("@return");	
			if (rtnType > -1)			
			{
				// process the @param comments
				temp1 = result.substring(rtnType + 7);  // remove the @return

				if(!isReturn)
				{
					commentBuffer.append("<DT><b>Returns<br></b><DD>");
					isReturn = true;
				}
				
				//commentBuffer.append(temp1+" - ");		
				//commentBuffer.append(temp1);
				//commentBuffer.append("<br>");	// new line
				// set the returnType
				int n = temp1.trim().indexOf(" ");
				if (n > -1)
				{
					returnType = temp1.substring(0, n+1).trim();
				}
				else
				{
					returnType = temp1.trim();
				}
				
			}
			exceptionType = result.indexOf("@exception");	
			if (exceptionType > -1)			
			{
				// process the @exception comments
				temp1 = result.substring(exceptionType + 10);  // remove the @exception
				if(!isExcept)
				{
					commentBuffer.append("<DT><b>Throws<br></b>");
					isExcept = true;
				}
				commentBuffer.append(temp1+" - ");				
			//	commentBuffer.append(temp1);
			//  commentBuffer.append("<br>");	// new line
			}
			if (method == -1 && construct ==-1 && param == -1 && rtnType == -1 && exceptionType == -1)
			{

				if(!isParam) methodDes.append(result.trim());
				commentBuffer.append(result.trim());	// a comment line
				commentBuffer.append("<br>");	// new line
			}
				
		}
		methodAPI = "public "+ returnType + " "+methodName+"(";
		if(paramStr!=""){
			methodAPI += paramStr.substring(0,paramStr.length()-1);
			
		}
		methodAPI +=")<DL><DD>";
		
		int mtdInd = commentBuffer.indexOf("&MN&");
		commentBuffer.replace(mtdInd, mtdInd+4, methodAPI);
		// finished parsing the comment
		// now assemble everything
		jsText.append(mdd1);
		//jsText.append(methodName);
		jsText.append(linkName);
		jsText.append(mdd2);
		jsText.append(mdd3);
		jsText.append(mdd4);
		jsText.append(commentBuffer.toString());
		jsText.append(mdd9);
	}

	/**
	 * Returns the linkName.
	 * @return String
	 */
	public String getLinkName() {
		return linkName;
	}
	/**
	 * Returns the methodAPI.
	 * @return String
	 */
	public String getMethodAPI() {
		return methodAPI;
	}
	
	/**
	 * Returns the methodDescription.
	 * @return String
	 */
	public String getMethodDes() {
		if(methodDes!=null)
			return methodDes.toString();
		else
			return "";
			
	}
	
	/**
	 * Sets the linkName.
	 * @param linkName The linkName to set
	 */
	public void setLinkName(String linkName) {
		this.linkName = linkName;
	}

}
