/////////////////////////////////////////////////////////////////////////
//  IBM Confidential
//  
//  OCO Source Materials
//  
//  PID 5724-E76 and 5724-E77
//  
//   Copyright IBM Corp.  2003
//  
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
/////////////////////////////////////////////////////////////////////////
package com.ibm.odcb.utilities.jsdoc;

/**
 * @author rpzitel
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class MethodSummary {
	private String methodName, linkName, methodDes;
	private String htmlFileName = "jsdoc-detail.html";
	private String returnType = "void";
	private StringBuffer jsText = new StringBuffer();
	// method summary header
	private String mh1 = "<A NAME=\"method_summary\"><!-- --></A>";
	private String mh2 = "<TABLE BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\" WIDTH=\"100%\">";
	private String mh3 = "<TR BGCOLOR=\"#CCCCFF\" CLASS=\"TableHeadingColor\">";
	private String mh4 = "<TD COLSPAN=2><FONT SIZE=\"+2\">";
	private String mh5 = "<B>Method Summary</B></FONT></TD></TR>";
	
	private String md1 = "<TR BGCOLOR=\"white\" CLASS=\"TableRowColor\">";
	private String md2 = "<TD ALIGN=\"right\" VALIGN=\"top\" WIDTH=\"1%\"><FONT SIZE=\"-1\">";
	// method details
	private String md3a =" <CODE>";
	private String md3b = "</CODE></FONT></TD>";
	private String md4 ="<TD><CODE><B><A HREF=\"";
//	../../../../com/ibm/odcb/utilities/JSCompressor.html#CleanFile(java.io.BufferedWriter, java.lang.String, com.ibm.odcb.utilities.JSCompressor.ByteCounter)\">CleanFile</A></B>(java.io.BufferedWriter&nbsp;Out,          java.lang.String&nbsp;Name,          <A HREF=\"../../../../com/ibm/odcb/utilities/JSCompressor.ByteCounter.html\">JSCompressor.ByteCounter</A>&nbsp;BC)
	private String md4a ="\">";
	// insert the method name
	private String md5 ="</CODE><BR>";
	private String md6 = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>";
	private String md7= "</TR>";
	// method summary end
	private String me = "</TABLE>";

	public MethodSummary(String detailFile)
	{
		int i = detailFile.lastIndexOf("\\");
		int j = detailFile.lastIndexOf("/");
		if (i > j)	htmlFileName = detailFile.substring(i + 1);
		else htmlFileName = detailFile.substring(j + 1);
		//System.out.println("MethodSummary htmlFileName: " + htmlFileName);
		//System.out.println("MethodSummary detailFile: " + detailFile);
	}
	public static void main(String[] args) 
	{
		MethodSummary ms = new MethodSummary("xxx");

		ms.setMethodName(args[1]);
		ms.setMethodName(args[2]);
		System.out.println(ms.toString());
	}
	public void init()
	{
		jsText.append(mh1);
		jsText.append(mh2);
		jsText.append(mh3);
		jsText.append(mh4);
		jsText.append(mh5);
	}		
	/**
	 * Returns the methodName.
	 * @return String
	 */
	public String getMethodName() {
		return methodName;
	}

	/**
	 * Sets the methodName.
	 * @param methodName The methodName to set
	 */
	public void setMethodName(String methodName) 
	{
		
		if (methodName == null) this.methodName=" ";
		else methodName = methodName.trim();
		
		methodName = methodName.substring(6);

		int n = methodName.trim().indexOf(" ");
		if (n > -1)
		{
			methodName = methodName.substring(n+1);
		}		
		

		n = methodName.trim().indexOf("(");
		String name = methodName.substring(0,n+1);
		methodName = methodName.substring(n+1);	

		
		jsText.append(md1);
		jsText.append(md2);
		jsText.append(md3a);
		if (returnType == null) returnType = "void";
		jsText.append(returnType);
		jsText.append(md3b);
		jsText.append(md4);		
		jsText.append(htmlFileName);
		jsText.append("#");
		//jsText.append(methodName);
		jsText.append(linkName);
		jsText.append(md4a);	
		jsText.append(name);
		jsText.append("</A></B>"+methodName);
		jsText.append(this.methodDes);
		jsText.append(md5);
		jsText.append(md6);
		jsText.append(md7);
	}
		/**
	 * Returns the linkName.
	 * @return String
	 */
	public String getLinkName() {
		return linkName;
	}

	/**
	 * Sets the linkName.
	 * @param linkName The linkName to set
	 */
	public void setLinkName(String linkName) {
		if (linkName == null) this.linkName = " ";
		else this.linkName = linkName.trim();

	}
	public String toString()
	{

		jsText.append(me);
		return jsText.toString();
	}



	public void reset()
	{
		jsText = new StringBuffer();
		methodName = null;
	}
	/**
	 * Returns the returnType.
	 * @return String
	 */
	public String getReturnType() {
		return returnType;
	}

	/**
	 * Sets the returnType.
	 * @param returnType The returnType to set
	 */
	public void setReturnType(String returnType) {
		this.returnType = returnType;
	}
	/**
	 * Sets the returnType.
	 * @param returnType The returnType to set
	 */
	public void setMethodDes(String methodDes) {
		this.methodDes = methodDes;
	}

}
